<?php
require_once('vendor/autoload.php');

// Set your Stripe API key
\Stripe\Stripe::setApiKey('sk_test_5J87rf5MsZJYIK36Jt9bveuI');

try {
    // Create a Payment Intent with Apple Pay enabled
    $paymentIntent = \Stripe\PaymentIntent::create([
        'amount' => 2000, // Amount in cents (e.g., £20.00)
        'currency' => 'gbp',
        'payment_method_types' => ['google_pay'], // Include 'apple_pay' here
    ]);

    // Retrieve the client secret to pass to the client-side script
    $clientSecret = $paymentIntent->client_secret;

} catch (\Stripe\Exception\ApiErrorException $e) {
    echo 'Error: ' . $e->getMessage();
}
?>

<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Apple Pay with Stripe</title>
    <script src="https://js.stripe.com/v3/"></script>
</head>
<body>
    <h1>Apple Pay with Stripe</h1>

    <!-- Display Apple Pay button -->
    <div id="payment-request-button"></div>

    <script>
        var stripe = Stripe('pk_test_AdQkfvDPjhh5OBqmlJ5DGCub');
        var paymentRequest = stripe.paymentRequest({
            country: 'GB',
            currency: 'gbp',
            total: {
                label: 'Total',
                amount: 2000, // Amount in cents (e.g., £20.00)
            },
            requestPayerName: true,
            requestPayerEmail: true,
        });

        var elements = stripe.elements();
        var prButton = elements.create('paymentRequestButton', {
            paymentRequest: paymentRequest,
        });

        // Check if Apple Pay is available
        paymentRequest.canMakePayment().then(function(result) {
            result.applePay = true;
            console.log(result);
            if (result) {
                // Display the Apple Pay button
                prButton.mount('#payment-request-button');
            } else {
                // Apple Pay is not available
                document.getElementById('payment-request-button').style.display = 'none';
            }
        });

        // Handle payment authorization
        paymentRequest.on('paymentmethod', function(ev) {
            // Confirm the Payment Intent with the payment method
            stripe.confirmCardPayment('<?php echo $clientSecret; ?>', {
                payment_method: ev.paymentMethod.id
            }).then(function(result) {
                if (result.error) {
                    // Payment failed
                    console.error(result.error);
                } else {
                    // Payment succeeded
                    console.log(result.paymentIntent);
                }
            });
        });
    </script>
</body>
</html>
