<?php

namespace App;

use App\Http\Controllers\SiteSettingController;
use App\ModelsConnect\ExternalAccount;
use Illuminate\Database\Eloquent\Model;

class ActionLog extends Model
{
    protected $fillable = [
        'user_type',
        'user_id',
        'prefix',
        'end_point',
        'full_path',
        'method',
        'request_raw',
        'ip',
        'device_id',
    ];
    protected $hidden = ['updated_at'];
    protected $appends = ['user'];
    protected $casts = ['request_raw' => 'json'];

    // Attributes
    //
    public function getUserAttribute()
    {
        if ($this->user_type == 'admin' || $this->user_type == '') {
            return Admin::where('id', $this->user_id)->first();
        }

        if ($this->user_type == 'tiffintom') {
            return User::where('id', $this->user_id)->first();
        }

        return;
    }
}
