<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class BankDetail extends Model
{
    protected $fillable = ['title', 'bank_name', 'account_name', 'account_number', 'account_type', 'sort_code', 'bank_url', 'business_id', 'user_id'];
    protected $hidden = ['updated_at'];
    protected $appends = ['is_default'];
    protected $casts = ['disabled' => 'bool'];

    // Attributes
    //
    public function getIsDefaultAttribute()
    {
        if ($this->business_id != null)
            $defaultBankDetail = Business::where('id', $this->business_id)->where('bank_detail_id', $this->id)->first();
        else $defaultBankDetail = User::where('id', $this->user_id)->where('bank_detail_id', $this->id)->first();
        return (!empty($defaultBankDetail));
    }
}
