<?php

namespace App;

use App\Helpers\ImageHelper;
use Illuminate\Database\Eloquent\Model;

class BusinessGallery extends Model
{
    protected $fillable = [
        'business_id',
        'type',
        'link',
        'image'
    ];
    protected $hidden = ['updated_at'];
    protected $appends = ['image_url', 'thumb_url'];
    protected $casts = [];

    // Attributes
    //
    public function getImageUrlAttribute()
    {
        return ImageHelper::getServerImageUrl(ImageHelper::$TYPE_BUSINESS_GALLERY, $this->image);
    }
    public function getThumbUrlAttribute()
    {
        return ImageHelper::getServerThumbUrl(ImageHelper::$TYPE_BUSINESS_GALLERY, $this->image);
    }
}
