<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class CardBrandCommission extends Model
{
    protected $fillable = [
        'card_brand_id',
        'business_id',
        'stripe_percentage',
        'stripe_fixed',
        'other',
    ];
    protected $hidden = ['updated_at'];
    protected $appends = ['card_brand'];
    protected $casts = ['other' => 'bool', 'stripe_percentage' => 'double', 'stripe_fixed' => 'double'];

    // Attributes
    //
    public function getCardBrandAttribute()
    {
        return $this->card_brand();
    }
    // Attributes
    //
    public function card_brand()
    {
        return CardBrand::where('id', $this->card_brand_id)->first();
    }
}
