<?php

namespace App;

use App\Helpers\ImageHelper;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Support\Facades\Log;

class Career extends Model
{
    protected $fillable = [
        'first_name',
        'last_name',
        'profile_link',
        'email',
        'phone',
        'attach_cv',
        'position',
        'start_date',
        'created_at',
        'updated_at',
    ];
    protected $hidden = ['updated_at'];
    protected $appends = ['attach_cv_url'];
    protected $casts = [];

    // Attributes
    //
    public function getAttachCvUrlAttribute()
    {
        return ImageHelper::getServerImageUrl(ImageHelper::$TYPE_CV, $this->attach_cv);
    }
}
