<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class CaxtonCard extends Model
{
    protected $fillable = [
        'wallet_id',
        'card_id',
        'card_holder_name',
        'expiry',
        'card_number',
        'email',
        'mobile_number',
        'dob',
        'gender',
        'masked_pan',
        'sequence_number',
        'is_renewed',
        'can_be_renewed',
        'reissue_blocked',
        'reissue_failure',
        'is_expired',
        'date_issued',
        'is_expiring',
        'is_blocked_by_client',
        'is_contactless',
        'pan_type_code',
        'base_pan_type_code',
        'is_primary_pan',
        'gps_token',
        'card_state',
        'activation_token',
        'index1',
        'index2',
        'index3',
        'index4',
        'index5',
        'index6',
    ];
    protected $hidden = ['updated_at'];
    protected $appends = ['wallet_name'];
    protected $casts = [
        'is_renewed' => 'bool',
        'can_be_renewed' => 'bool',
        'reissue_blocked' => 'bool',
        'reissue_failure' => 'bool',
        'is_expired' => 'bool',
        'is_expiring' => 'bool',
        'is_blocked_by_client' => 'bool',
        'is_contactless' => 'bool',
        'is_primary_pan' => 'bool',
    ];

    // Attributes
    //
    public function getWalletNameAttribute()
    {
        $wallet = CaxtonWallet::where('wallet_id', $this->wallet_id)->first();
        return $wallet->name;
    }
}
