<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class CaxtonPayoutRequest extends Model
{
    protected $fillable = [
        'business_id',
        'user_id',
        'wallet_id',
        'beneficiary_id',
        'amount',
        'note',
        'rejection_note',
        'shop_order_id',
        'status',
        'available_at',
    ];
    protected $hidden = ['updated_at'];
    protected $appends = ['wallet', 'beneficiary'];


    // Attributes
    //
    public function getWalletAttribute()
    {
        return CaxtonWallet::where('id', $this->wallet_id)->first();
    }
    public function getBeneficiaryAttribute()
    {
        return CaxtonBeneficiary::where('id', $this->beneficiary_id)->first();
    }
}
