<?php

namespace App;

use App\Http\Controllers\SiteSettingController;
use Illuminate\Database\Eloquent\Model;

class CaxtonTransaction extends Model
{
    protected $fillable = [
        'transactions_id',
        'beneficiary_id',
        'user_id',
        'buy_ccy_code',
        'buy_amount',
        'executed_date',
        'pay_away_date',
        'pay_status',
        'account_transation_id',
        'payment_reference',
        'created_date',
        'payment_provider',
        'compliance_status_desc',
        'beneficiary_name',
    ];
    protected $hidden = ['updated_at'];
    protected $appends = ['user_name', 'beneficiary'];
    protected $casts = [];

    // Attributes
    //
    public function getBeneficiaryAttribute()
    {
        return CaxtonBeneficiary::where('beneficiary_id', $this->beneficiary_id)->first();
    }
    public function getUserNameAttribute()
    {
        $caxton_user_id = SiteSettingController::findByKey('caxton_user_id')->value;
        if ($caxton_user_id == $this->user_id) {
            return 'Admin';
        } else {
            $user = CaxtonUser::where('account_id', $this->user_id)->first();
            return $user->name;
        }
    }
}
