<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class CaxtonTransfer extends Model
{
    protected $fillable = [
        'pending_transfer_id',
        'transfer_id',
        'beneficiary_id',
        'user_id',
        'buy_ccy_Code',
        'buy_amount',
        'complete',
        'automatic',
        'executed',
        'pay_away',
        'pay_status',
        'account_transaction_id',
        'cash_available',
        'authorisation',
        'authorisation_status',
        'payment_accepted',
        'rejection_reason',
        'payment_reference',
        'is_pending',
        'created',
        'payment_provider',
        'compliance_status',
        'eye_check_status',
        'compliance_status_desc',
        'is_high_risk_transfer',
        'fee_currency',
        'fee',
        'external_source_id',
        'beneficiary_name',
        'notes',
    ];
    protected $hidden = ['updated_at'];
    protected $appends = ['user'];
    protected $casts = ['complete' => 'bool', 'automatic' => 'bool', 'is_pending' => 'bool', 'is_high_risk_transfer' => 'bool'];

    // Attributes
    //
    public function getUserAttribute()
    {
        return CaxtonUser::where('account_id', $this->user_id)->first();
    }
}
