<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class CaxtonUser extends Model
{
    protected $fillable = [
        'account_id',
        'business_id',
        'name',
        'email',
        'phone_number',
        'username',
        'password',
        'human_password',
        'token',
        'public_key',
        'encrypt_key',
    ];
    protected $hidden = ['updated_at', 'otp'];
    protected $appends = ['business', 'bank_detail'];
    protected $casts = [];

    // Attributes
    //
    public function getBusinessAttribute()
    {
        return Business::find($this->business_id);
    }
    public function getBankDetailAttribute()
    {
        return CaxtonBankDetails::where('user_id', $this->id)->first();
    }
}
