<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class CaxtonWalletTransaction extends Model
{
    protected $fillable = [
        'wallet_id',
        'card_id',
        'description',
        'debit_amount',
        'debit_currency',
        'debit_currency_symbol',
        'credit_amount',
        'credit_currency',
        'credit_currency_symbol',
        'transaction_category',
        'transaction_type',
        'transaction_type_desc',
        'transaction_date',
        'is_authorisation',
        'is_transaction',
        'is_balance_adjustment',
        'pan_reference_number',
        'exchange_rate',
        'transaction_amount',
        'transaction_currency',
        'transaction_currency_symbol',
        'valitor_transaction_id',
        'merchant_name',
        'merchant_city',
        'merchant_country',
        'is_loyalty_point',
        'authorization_number',
        'card_token_id',
        'is_fee',
        'is_wallet_alignment',
    ];
    protected $hidden = ['updated_at'];
    protected $appends = ['wallet', 'card'];
    protected $casts = [
        'is_authorisation' => 'bool',
        'is_transaction' => 'bool',
        'is_balance_adjustment' => 'bool',
        'is_loyalty_point' => 'bool',
        'is_fee' => 'bool',
        'is_wallet_alignment' => 'bool',
    ];

    // Attributes
    //
    public function getWalletAttribute()
    {
        return CaxtonWallet::where('wallet_id', $this->wallet_id)->first();
    }
    public function getCardAttribute()
    {
        return CaxtonCard::where('card_id', $this->card_id)->first();
    }
}
