<?php

namespace App\Console\Commands;

use Illuminate\Console\Command;
use Carbon\Carbon;
use Illuminate\Support\Facades\Log;
use Illuminate\Support\Facades\Queue;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\File;

class ClearOldLogs extends Command
{
    protected $signature = 'ClearOldLogs:clear';
    protected $description = 'Clear old log files';

    public function handle()
    {
        $logPath = storage_path('logs');
        $files = File::glob($logPath . '/*.log');
        $threshold = now()->subDays(5); // Change 5 to the number of days you want to keep logs

        foreach ($files as $file) {
            if (File::lastModified($file) < $threshold->timestamp) {
                File::delete($file);
                $this->info("Deleted old log file: $file");
            }
        }
    }
}
