<?php

namespace App\Console\Commands;

use App\Invoice;
use App\Jobs\invoiceCreatorJob;
use App\Jobs\TransferFetchJob;
use Illuminate\Console\Command;
use Carbon\Carbon;
use Illuminate\Support\Facades\Log;
use Illuminate\Support\Facades\Queue;
use Illuminate\Http\Request;

class InvoiceRecurring extends Command
{
    /**
     * The name and signature of the console command.
     *
     * @var string
     */
    protected $signature = 'InvoiceRecurring:fetch';

    /**
     * The console command description.
     *
     * @var string
     */
    protected $description = 'Cron for fetching invoice recurring';

    public static $process_busy = false;

    /**
     * Create a new command instance.
     *
     * @return void
     */
    public function __construct()
    {
        parent::__construct();
    }

    /**
     * Execute the console command.
     *
     * @return mixed
     */
    public function handle()
    {
        $req = Request::create("");
        $today = Carbon::today()->format('Y-m-d');
        $invoices = Invoice::where('recurring', '1')->where('recurring_date', $today)->get();
        $invoices->each(function ($invoice) use ($req) {
            Queue::later(Carbon::now(), new invoiceCreatorJob($req, $invoice->id));
        });
    }
}
