<?php

namespace App\Console\Commands;

use Illuminate\Console\Command;
use App\Http\Controllers\OnlineOrderController;
use Carbon\Carbon;

class OnlineOrderFetcher extends Command
{
    /**
     * The name and signature of the console command.
     *
     * @var string
     */
    protected $signature = 'OnlineOrderFetcher:fetch';

    /**
     * The console command description.
     *
     * @var string
     */
    protected $description = 'Cron for fetching online orders';

    public static $process_busy = false;

    /**
     * Create a new command instance.
     *
     * @return void
     */
    public function __construct()
    {
        parent::__construct();
    }

    /**
     * Execute the console command.
     *
     * @return mixed
     */
    public function handle()
    {
        $startdate = Carbon::today()->subDays(7)->format('d-m-Y');
        $enddate = Carbon::today()->format('d-m-Y');

        (new OnlineOrderController())->orders($startdate, $enddate);

        return "Online DONE";
    }
}
