<?php

namespace App\Console\Commands;

use App\Business;
use App\Http\Controllers\PaypalPaymentController;
use App\Http\Controllers\SiteSettingController;
use Illuminate\Console\Command;
use App\Http\Controllers\StripeTransactionController;
use App\Jobs\PaypalFetchJob;
use Carbon\Carbon;
use Illuminate\Support\Facades\Log;
use Illuminate\Support\Facades\Queue;

class PaypalTransactionsFetcher extends Command
{
    /**
     * The name and signature of the console command.
     *
     * @var string
     */
    protected $signature = 'PaypalTransactionsFetcher:fetch';

    /**
     * The console command description.
     *
     * @var string
     */
    protected $description = 'Cron for fetching paypal transactions';

    public static $process_busy = false;

    /**
     * Create a new command instance.
     *
     * @return void
     */
    public function __construct()
    {
        parent::__construct();
    }

    /**
     * Execute the console command.
     *
     * @return mixed
     */
    public function handle()
    {
        $modeSetting = SiteSettingController::findByKey('paypal_mode');
        $paypalMode = "test";
        if (!empty($modeSetting)) {
            $paypalMode = strtolower($modeSetting->value);
        }
        $paypalPublicKey = "";
        $paypalSecretKey = "";
        $privateKeyColoumn = 'paypal_private_key_test';
        $publicKeyColoumn = 'paypal_public_key_test';
        $url = "https://api.sandbox.paypal.com/v1/payments/payment";
        if ($paypalMode == 'test') {
            $privateKeySetting = SiteSettingController::findByKey('paypal_private_key_test');
            $publicKeySetting = SiteSettingController::findByKey('paypal_public_key_test');
        }
        if ($paypalMode == 'live') {
            $privateKeySetting = SiteSettingController::findByKey('paypal_private_key_live');
            $publicKeySetting = SiteSettingController::findByKey('paypal_public_key_live');
            $privateKeyColoumn = "paypal_private_key_live";
            $publicKeyColoumn = "paypal_public_key_live";
            $url = "https://api.paypal.com/v1/payments/payment";
        }
        if (!empty($privateKeySetting) && !empty($publicKeySetting)) {
            $paypalSecretKey = trim($privateKeySetting->value);
            $paypalPublicKey = trim($publicKeySetting->value);
        }

        Queue::later(Carbon::now(), new PaypalFetchJob($url, $paypalPublicKey, $paypalSecretKey));
    }
}
