<?php

namespace App\Console\Commands;

use App\CaxtonUser;
use App\Jobs\TransferFetchJob;
use Illuminate\Console\Command;
use Carbon\Carbon;
use Illuminate\Support\Facades\Log;
use Illuminate\Support\Facades\Queue;
use Illuminate\Http\Request;

class TransferTransactionFetcher extends Command
{
    /**
     * The name and signature of the console command.
     *
     * @var string
     */
    protected $signature = 'TransferTransactionFetcher:fetch';

    /**
     * The console command description.
     *
     * @var string
     */
    protected $description = 'Cron for fetching stripe transactions';

    public static $process_busy = false;

    /**
     * Create a new command instance.
     *
     * @return void
     */
    public function __construct()
    {
        parent::__construct();
    }

    /**
     * Execute the console command.
     *
     * @return mixed
     */
    public function handle()
    {
        $req = Request::create("");
        $users = CaxtonUser::orderByRaw('created_at DESC')->get();
        $users->each(function ($user) use ($req) {
            Queue::later(Carbon::now(), new TransferFetchJob($req, $user->id));
        });
    }
}
