<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class CountryCommission extends Model
{
    protected $fillable = [
        'country_id',
        'business_id',
        'paypal_percentage',
        'paypal_fixed',
        'stripe_percentage',
        'stripe_fixed',
        'other',
    ];
    protected $hidden = ['updated_at'];
    protected $appends = ['country'];
    protected $casts = ['other' => 'bool', 'paypal_percentage' => 'double', 'paypal_fixed' => 'double', 'stripe_percentage' => 'double', 'stripe_fixed' => 'double'];


    public function getCountryAttribute()
    {
        return $this->country();
    }
    // Attributes
    //
    public function country()
    {
        return Country::where('id', $this->country_id)->first();
    }
}
