<?php

namespace App\Exports;

use Maatwebsite\Excel\Concerns\FromCollection;
use Illuminate\Support\Collection;
use Maatwebsite\Excel\Concerns\Exportable;

class AdminWalletLoadReportExport implements FromCollection
{
    use Exportable;
    public $details;
    public $fromDate;
    public $toDate;

    public function __construct($details, $fromDate, $toDate)
    {
        $this->details = $details;
        $this->fromDate = $fromDate;
        $this->toDate = $toDate;
    }

    /**
    * @return \Illuminate\Support\Collection
    */
    public function collection()
    {
        $data = [];
        $data['first-header'][] = 'CFX BULK UPLOAD';
        $data['first-header'][] = 'CARD LOAD';
        $data['first-header'][] = 'HEADER';
        $data['first-header'][] = 'ROWS: ' . count($this->details);
        $data['first-header'][] = 'DATES: ' . $this->fromDate . ' - ' . $this->toDate;

        $data['second-header'][] = 'CardHolderName';
        $data['second-header'][] = 'WalletGroupName';
        $data['second-header'][] = 'WalletId';
        $data['second-header'][] = 'LoadCurrency';
        $data['second-header'][] = 'LoadAmount';

        foreach ($this->details as $key => $detail) {
            $data[$key][] = $detail['CardHolderName'];
            $data[$key][] = $detail['WalletGroupName'];
            $data[$key][] = $detail['WalletId'];
            $data[$key][] = $detail['LoadCurrency'];
            $data[$key][] = $detail['LoadAmount'];
        }

        return new Collection([
            $data
        ]);
    }
}
