<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class FactoryResetLog extends Model
{
    protected $table = 'factory_reset_logs';

    protected $fillable = [
        'business_id',
        'user_id',
        'device_id',
        'device_name',
        'sync_mode'
    ];

    protected $hidden = ['updated_at'];
    protected $appends = ['business_name', 'user_name'];
    protected $casts = [];

    // Attributes
    //
    public function getBusinessNameAttribute()
    {
        $business = Business::where('id', $this->business_id)->first();
        if (empty($business)) {
            return null;
        }
        return $business->name;
    }
    // Attributes
    //
    public function getUserNameAttribute()
    {
        $user = User::where('id', $this->user_id)->first();
        if (empty($user)) {
            return null;
        }
        return $user->first_name . ' ' . $user->last_name;
    }
}
