<?php

namespace App;

use Illuminate\Database\Eloquent\Model;
use Illuminate\Support\Facades\Log;

class Faq extends Model
{
    protected $fillable = [
        'parent_id',
        'question',
        'answer',
        'page',
        'disabled',
        'created_at',
        'updated_at',
    ];
    protected $hidden = ['updated_at'];
    protected $appends = ['title', 'key', 'children'];
    protected $casts = ['disabled' => 'bool',];

    // Attributes
    //
    public function getTitleAttribute()
    {
        return $this->question;
    }
    public function getKeyAttribute()
    {
        return $this->id;
    }
    public function getChildrenAttribute()
    {
        $children = $this->hasMany('App\Faq', 'parent_id', 'id')->orderByRaw('id DESC')->get();
        if ($children->isEmpty()) {
            return null;
        }
        return $children->makeHidden(['created_at', 'updated_at']);
    }
}
