<?php

namespace App;

use Illuminate\Database\Eloquent\Model;
use Illuminate\Support\Facades\Log;

class HardwareOrder extends Model
{
    protected $fillable = [
        'customer_id',
        'flat_no',
        'address',
        'second_line',
        'city',
        'zipcode',
        'sub_total',
        'tax',
        'voucher_code',
        'offer_amount',
        'total',
        'delivery_date',
        'notes',
        'status',
        'txn_id',
        'created_at',
        'updated_at',
    ];
    protected $hidden = ['updated_at'];
    protected $appends = ['customer', 'order_items'];
    protected $casts = [
        'sub_total' => 'double',
        'tax' => 'double',
        'offer_amount' => 'double',
        'total' => 'double',
    ];

    // Attributes
    //
    public function getOrderItemsAttribute()
    {
        return $this->order_items();
    }
    public function order_items()
    {
        return HardwareOrderItem::where('order_id', $this->id)->get();
    }
    public function getCustomerAttribute()
    {
        return $this->customer();
    }
    public function customer()
    {
        return User::where('id', $this->customer_id)->first();
    }
}
