<?php

namespace App;

use App\Helpers\ImageHelper;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Support\Facades\Log;

class HardwareProduct extends Model
{
    protected $fillable = [
        'name',
        'stock_quantity',
        'amount',
        'description',
        'tax_amount',
        'is_excludes',
        'created_at',
        'updated_at',
    ];
    protected $hidden = ['updated_at'];
    protected $appends = ['images'];
    protected $casts = [
        'disabled' => 'bool',
        'is_exclude' => 'bool',
    ];

    // Attributes
    //
    public function getImagesAttribute()
    {
        return $this->images()->get();
    }

    public function images()
    {
        return $this->hasMany('App\HardwareProductImage', 'product_id', 'id')->select(['id', 'image']);
    }
}
