<?php

namespace App;

use App\Helpers\ImageHelper;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Support\Facades\Log;

class HardwareProductImage extends Model
{
    protected $fillable = ['product_id', 'image', 'priority'];
    protected $hidden = ['updated_at', 'image'];
    protected $appends = ['image_url', 'thumb_url'];
    protected $casts = ['priority' => 'int'];

    // Attributes
    public function getThumbUrlAttribute()
    {
        return ImageHelper::getServerThumbUrl(ImageHelper::$TYPE_HARDWARE_PRODUCT, $this->image);
        // return "https://images.tiffintom.com/testrms/images/hardware/HAjC0wpvRyZkGt8ypelXloOGrWON6z1InoglKwt8.webp";
    }

    public function getImageUrlAttribute()
    {
        return ImageHelper::getServerImageUrl(ImageHelper::$TYPE_HARDWARE_PRODUCT, $this->image);
        // return "https://images.tiffintom.com/testrms/images/hardware/HAjC0wpvRyZkGt8ypelXloOGrWON6z1InoglKwt8.webp";
    }
}
