<?php

namespace App\Helpers;

use App\Http\Controllers\Tiffintom\TiffintomSiteSettingController;
use App\ModelsTiffintom\TiffintomMessage;
use App\ModelsTiffintom\TiffintomSiteSetting;
use App\ModelsTiffintom\TiffintomSMSEvent;
use App\ModelsTiffintom\TiffintomSMSPort;
use App\ModelsTiffintom\TiffintomUrl;
use App\Otp;
use App\SMSLog;
use GuzzleHttp\Client;
use GuzzleHttp\Psr7\Request;
// use Illuminate\Http\Request;
use Textmagic\Services\TextmagicRestClient;
use Illuminate\Support\Str;

class OtpHelper
{
    public static function sendMessage($message, $mobile, $event = 'other_events', $senderId = null)
    {
        $siteSetting =  TiffintomSiteSetting::find('1');
        $sms_gateway = $siteSetting->sms_gateway;

        $event = TiffintomSMSEvent::where('events', $event)->first();

        if (!empty($event) && $event->package != 'default') {
            $sms_gateway = $event->package;
        }

        $messageSend = '0';
        $checkMessages =  TiffintomMessage::where('status', '1')->where('delete_status', 'N')->orderByRaw('id ASC')->get();
        if (!$checkMessages->isEmpty()) {
            foreach ($checkMessages as $CheckMessage) {
                $sub = substr($mobile, 0, $CheckMessage['number_count']);
                if ($CheckMessage['number'] == $sub) {
                    if ($CheckMessage['mobile'] == '1') {
                        $messageSend = '1';
                    }
                }
            }
        }

        if ($messageSend == '1') {
            if ($sms_gateway == 'server') {
                $ports = TiffintomSMSPort::where('status', '1')->get();

                $multipleports = array();
                foreach ($ports as $cKey => $cValue) {
                    $multiplecartUpdates[] = $cValue->port_no;
                }
                $Ports = implode('', $multiplecartUpdates);

                $Port = substr(str_shuffle($Ports), 0, 1);

                $query = [
                    "type" => "send-sms",
                    "task_num" => 1,
                    "tasks" => [array(
                        "tid" => rand(100000000, 1000000000),
                        "from" => $Port,
                        "to" => $mobile,
                        "sms" => $message
                    )]
                ];

                $urls =  TiffintomUrl::where('status', '1')->orderBy('id', 'DESC')->first();
                if (empty($urls)) {
                    $url = "https://sms.tiffintom.com/goip_post_sms.html?username=" . $siteSetting->sms_username . "&password=" . $siteSetting->sms_password;
                } else {
                    $url = $urls->url;
                }
                $client = new Client();
                $response = $client->request(
                    'POST',
                    $url,
                    [
                        'json' => $query,
                    ]
                );

                $result = null;
                if ($response->getStatusCode() == 200) {
                    $sms_log = new SMSLog();
                    $sms_log->event = $event->events;
                    $sms_log->mobile_number = $mobile;
                    $sms_log->message = $message;
                    $sms_log->sms_package = $sms_gateway;
                    $sms_log->save();

                    $result = $response->getBody();
                    error_log("Message sent to $mobile => " . $result);
                } else {
                    error_log('Cannot sent message');
                }
            } else if ($sms_gateway == 'click_send') {

                if ($senderId == null) {
                    $senderId = $siteSetting->click_send_sender_id;
                }

                // CLICK SEND MESSAGE
                $url = "https://api.clicksend.com/http/v2/send.php?method=http&username=" . $siteSetting->click_send_username . "&key=" . $siteSetting->click_send_api_key;
                $client = new Client();
                $headers = [
                    'Content-Type' => 'application/x-www-form-urlencoded'
                ];
                $options = [
                    'form_params' => [
                        'to' => $mobile,
                        'message' => $message,
                        'from' => $senderId
                    ]
                ];
                $request = new Request('POST', $url, $headers);
                $res = $client->sendAsync($request, $options)->wait();

                $sms_log = new SMSLog();
                $sms_log->event = $event->events;
                $sms_log->mobile_number = $mobile;
                $sms_log->message = $message;
                $sms_log->sms_package = $sms_gateway;
                $sms_log->save();

                error_log("Message sent successfully");

                $sms_log = new SMSLog();
                $sms_log->event = $event->events;
                $sms_log->mobile_number = $mobile;
                $sms_log->message = $message;
                $sms_log->sms_package = $sms_gateway;
                $sms_log->save();
                return;
            } else if ($sms_gateway == 'text_magic') {
                // TEXT MAGIC MESSAGE
                $client = new TextmagicRestClient($siteSetting->text_magic_username, $siteSetting->text_magic_api_key);
                $result = ' ';

                if (str_starts_with($mobile, '44') || str_starts_with($mobile, '+44')) {
                    $mobile = $mobile;
                } else {
                    $mobile = '44' . $mobile;
                }

                try {
                    $result = $client->messages->create(
                        array(
                            'text' => $message,
                            'phones' => $mobile
                        )
                    );

                    $sms_log = new SMSLog();
                    $sms_log->event = $event->events;
                    $sms_log->mobile_number = $mobile;
                    $sms_log->message = $message;
                    $sms_log->sms_package = $sms_gateway;
                    $sms_log->save();
                    error_log("Message sent successfully");

                    $sms_log = new SMSLog();
                    $sms_log->event = $event->events;
                    $sms_log->mobile_number = $mobile;
                    $sms_log->message = $message;
                    $sms_log->sms_package = $sms_gateway;
                    $sms_log->save();
                } catch (\Exception $e) {
                    error_log($e->getMessage());
                }
                return;
            } else if ($sms_gateway == 'route_mobile') {
                try {
                    if (str_starts_with($mobile, '44') || str_starts_with($mobile, '+44')) {
                        $mobile = $mobile;
                    } else {
                        $mobile = '44' . $mobile;
                    }
                    $client = new Client();
                    $request = new Request('GET', 'https://api.rmlconnect.net/bulksms/bulksms?username=' . $siteSetting->route_mobile_username . '&password=' . $siteSetting->route_mobile_password . '&type=1&dlr=1&destination=' . $mobile . '&source=' . $siteSetting->route_mobile_sender . '&message=' . urlencode(utf8_encode($message)) . '&url=ubsidi.com');
                    $apiRequest = $client->sendAsync($request)->wait();

                    $sms_log = new SMSLog();
                    $sms_log->event = $event->events;
                    $sms_log->mobile_number = $mobile;
                    $sms_log->message = $message;
                    $sms_log->sms_package = $sms_gateway;
                    $sms_log->save();
                    error_log("Message sent successfully");

                    $sms_log = new SMSLog();
                    $sms_log->event = $event->events;
                    $sms_log->mobile_number = $mobile;
                    $sms_log->message = $message;
                    $sms_log->sms_package = $sms_gateway;
                    $sms_log->save();
                } catch (\Exception $e) {
                    error_log($e->getMessage());
                }
            } else {
            }
        }
    }
}
