<?php

namespace App\Helpers;

use App\Otp;
use GuzzleHttp\Client;
use Illuminate\Support\Facades\Log;

class PushNotificationHelper
{
    public static function sendNotification($payload, $topic, $api_key, $notification = null)
    {
        $url = 'https://fcm.googleapis.com/fcm/send';

        $headers = array(
            'Authorization: Key= ' . $api_key,
            'Content-Type: application/json'
        );

        $fields = array(
            'to' => $topic,
            'notification' => $notification,
            'data' => $payload,
        );

        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_POST, true);
        curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
        curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($fields));
        $result = curl_exec($ch);
        if ($result === FALSE) {
            Utils::error('Curl failed: ' . curl_error($ch), 404);
        }

        curl_close($ch);
    }
}
