<?php

namespace App\Helpers;

use App\ModelsTiffintom\TiffintomSiteSetting;
use App\Otp;
use GuzzleHttp\Client;
use Illuminate\Support\Facades\Log;

class PushNotificationTiffintomHelper
{
    public static function sendNotification($payload, $to, $notification = null, $notification_type = null)
    {
        $siteSettings = TiffintomSiteSetting::first();
        if (empty($siteSettings)) Utils::error("No site-settings found", 404);

        $url = 'https://fcm.googleapis.com/fcm/send';

        // Customer Notification Send
        if ($notification_type == 'customer') {
            $Devices = explode(',', $siteSettings->fcm_key);
            foreach ($Devices as $Device) {

                $headers = array(
                    'Authorization: Key= ' . $Device,
                    'Content-Type: application/json'
                );

                $fields = array(
                    'to' => $to,
                    'notification' => $notification,
                    'data' => $payload,
                    'priority' => 'high',
                );

                $ch = curl_init();
                curl_setopt($ch, CURLOPT_URL, $url);
                curl_setopt($ch, CURLOPT_POST, true);
                curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
                curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
                curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
                curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($fields));
                $result = curl_exec($ch);
                // if ($result === FALSE) {
                //     Utils::error('Curl failed: ' . curl_error($ch), 404);
                // }
                curl_close($ch);
            }
        }

        // Partner Notification Send 
        if ($notification_type == 'restaurant') {
            $headers_partner = array(
                'Authorization: Key= ' . $siteSettings->fcm_key1,
                'Content-Type: application/json'
            );

            $partner_fields = array(
                'to' => $to,
                'notification' => $notification,
                'data' => $payload,
                'priority' => 'high',
            );

            $ch = curl_init();
            curl_setopt($ch, CURLOPT_URL, $url);
            curl_setopt($ch, CURLOPT_POST, true);
            curl_setopt($ch, CURLOPT_HTTPHEADER, $headers_partner);
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
            curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
            curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($partner_fields));
            $result = curl_exec($ch);
            if ($result === FALSE) {
                Utils::error('Curl failed: ' . curl_error($ch), 404);
            }
            curl_close($ch);
        }
    }
}
