<?php

namespace App\Http\Controllers;

use App\BusinessPermission;
use Illuminate\Http\Request;

class BusinessPermissionController extends Controller
{
    public function create_update(Request $req)
    {
        $this->validate($req, [
            'business_id' => 'required',
            'role' => 'required|in:user,supervisor,admin',
            'payworks' => 'required|boolean',
            'tips' => 'required|boolean',
            'archive' => 'required|boolean',
            'archive_list' => 'required|boolean',
            'moto_service' => 'required|boolean',
            'transaction_list' => 'required|boolean',
            'print' => 'required|boolean',
            'refund' => 'required|boolean',
            'refund_list' => 'required|boolean',
            'recent_list' => 'required|boolean',
            'statement' => 'required|boolean',
        ]);
        $businessPermission = BusinessPermission::where('business_id', $req->input('business_id'))->where('role', $req->input('role'))->first();
        if (empty($businessPermission)) {
            $businessPermission = new BusinessPermission();
        }
        $businessPermission->fill($req->all());
        $businessPermission->save();
        return $businessPermission;
    }
}
