<?php

namespace App\Http\Controllers;

use App\Helpers\ImageHelper;
use App\Note;
use App\Helpers\Auth;
use App\Helpers\Utils;
use App\Http\Controllers\Controller;
use Carbon\Carbon;
use Faker\Factory;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\File;

class LogController extends Controller
{
    /**
     * List log.
     * GET /logs
     */
    public function index(Request $req)
    {
        $carbon = Carbon::today();
        $filename = 'lumen-' . $carbon->toDateString() . '.log';
        if ($req->has('date')) {
            $filename = 'lumen-' . $req->input('date') . '.log';
        }
        $file_path = storage_path("logs/$filename");
        if (File::exists($file_path)) {
            return '<pre>' . File::get($file_path) . '</pre>';
        } else {
            Utils::error("No logs found", 400);
        }
    }


    /**
     * Delete log by date.
     * DELETE /api/logs/
     */
    public function delete(Request $req)
    {
        $carbon = Carbon::today();
        $filename = 'lumen-' . $carbon->toDateString() . '.log';
        if ($req->has('date')) {
            $filename = 'lumen-' . $req->input('date') . '.log';
        }
        $file_path = storage_path("logs/$filename");
        if (File::exists($file_path)) {
            File::delete($file_path);
            return "File deleted";
        } else {
            Utils::error("No log file found", 400);
        }
    }
}
