<?php

namespace App\Http\Controllers;

use App\Business;
use App\BusinessGallery;
use App\Helpers\Utils;
use Illuminate\Http\Request;

class RestaurantController extends Controller
{

    /**
     * List business gallery.
     * GET /api/restarant/restaurant_id
     */
    public function gallery_fetch(Request $req, $restaurant_id)
    {
        $business = Business::where('restaurant_id', $restaurant_id)->first();
        if (empty($business)) Utils::error('No business found!', 404);
        $businessGalleryVideo = BusinessGallery::selectRaw('id,type,link,image')->where('business_id', $business->id)->where('type', 'link')->orderByRaw('created_at ASC')->get();
        $businessGalleryImage = BusinessGallery::selectRaw('id,type,link,image')->where('business_id', $business->id)->where('type', 'image')->orderByRaw('created_at ASC')->get();

        $Galleries = array();
        $Galleries['gallery_video_visible'] = $business->gallery_video_visible;
        $Galleries['gallery_image_visible'] = $business->gallery_image_visible;
        $Galleries['android_restaurant_app_version'] = $business->android_restaurant_app_version;
        $Galleries['ios_restaurant_app_version'] = $business->ios_restaurant_app_version;
        $Galleries['videos'] = $businessGalleryVideo;
        $Galleries['images'] = $businessGalleryImage;

        return ($Galleries);
    }
}
