<?php

namespace App\Http\Controllers\Tiffintom;

use App\Business;
use App\Helpers\Auth;
use App\Helpers\PushNotificationTiffintomHelper;
use App\Helpers\Utils;
use App\Http\Controllers\Controller;
use App\Http\Controllers\ExtraController;
use App\ModelsTiffintom\TiffintomPaymentTransaction;
use Carbon\Carbon;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Log;

class TiffintomPaymentTransactionController extends Controller
{

    /**
     * List payment-transactions
     * GET /tiffintom/payment-transactions
     */
    public function index(Request $req)
    {
        $payment_transactions = TiffintomPaymentTransaction::orderBy('id', 'DESC');

        if ($query = $req->query("restaurant_id", false)) {
            $payment_transactions->where('restaurant_id', $query);
            // User wise check
            if ($req->hasHeader('business-id')) {
                $business = Business::where('restaurant_id', $query)->first();
                if (empty($business)) Utils::error('User not authenticated.', 404);
                (new ExtraController())->userCheck($req->header('business-id'), $business->id);
            }
        }

        if ($query = $req->query('from_date')) {
            $fromDate = Carbon::parse($query)->startOfDay();
            $payment_transactions->where('payment_date', '>=', $fromDate);
        }
        if ($query = $req->query('to_date')) {
            $toDate = Carbon::parse($query)->endOfDay();
            $payment_transactions->where('payment_date', '<=', $toDate);
        }

        if ($req->query('nopaginate', false) == '1') {
            $payment_transactions = $payment_transactions->get();
        } else {
            $payment_transactions = $payment_transactions->paginate($req->query('per_page', 20));
        }

        if ($payment_transactions->isEmpty()) Utils::error('No payment transactions found!', 404);

        return $payment_transactions;
    }
}
