<?php

namespace App\Http\Controllers\Tiffintom;

use App\Helpers\Utils;
use App\Http\Controllers\Controller;
use App\ModelsTiffintom\TiffintomMetaTag;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Log;

class TiffintomRestaurantMetatagController extends Controller
{
    public function create_update(Request $req)
    {
        $this->validate($req, [
            'restaurant_id' => 'required|exists:tiffintom_connection.restaurants,id',
            'review_meta_title' => 'string',
            'review_meta_title' => 'string',
            'review_meta_keyword' => 'string',
            'review_meta_description' => 'string',
            'booking_meta_title' => 'string',
            'booking_meta_keyword' => 'string',
            'booking_meta_description' => 'string',
            'info_meta_title' => 'string',
            'info_meta_keyword' => 'string',
            'info_meta_description' => 'string',
            'offer_meta_title' => 'string',
            'offer_meta_keyword' => 'string',
            'offer_meta_description' => 'string',
            'android_link' => 'string',
            'ios_link' => 'string',
        ]);

        $metaTag = TiffintomMetaTag::where('restaurant_id', $req->input('restaurant_id'))->first();
        Log::debug($metaTag);
        if (empty($metaTag)) {
            $metaTag = new TiffintomMetaTag();
        }
        $metaTag->fill($req->all());
        $metaTag->save();
        return $metaTag;
    }
}
