<?php

namespace App\Http\Controllers;

use App\Helpers\ImageHelper;
use App\Helpers\Auth;
use App\Helpers\Utils;
use App\Http\Controllers\Controller;
use App\Http\Controllers\Tiffintom\TiffintomSiteSettingController;
use App\Http\Controllers\Tiffintom\TiffintomSMSPortController;
use App\Http\Controllers\Tiffintom\TiffintomUrlController;
use Faker\Factory;
use Illuminate\Http\Request;

class TiffintomController extends Controller
{

    // GET /api/tiffintom-site-settings/{id}
    public function sitesettng_show(Request $req, $id)
    {
        return (new TiffintomSiteSettingController())->show($req, $id);
    }
    // POST /api/tiffintom-site-settings/{id}
    public function sitesettng_update(Request $req, $id)
    {
        return (new TiffintomSiteSettingController())->update($req, $id);
    }



    // GET /api/tiffintom-sms-ports
    public function sms_port_index(Request $req)
    {
        return (new TiffintomSMSPortController())->index($req);
    }
    // POST /api/tiffintom-sms-ports/
    public function sms_port_create(Request $req)
    {
        return (new TiffintomSMSPortController())->create($req);
    }
    // POST /api/tiffintom-sms-ports/{id}
    public function sms_port_update(Request $req, $id)
    {
        return (new TiffintomSMSPortController())->update($req, $id);
    }
    // POST /api/tiffintom-sms-ports/{id}/enable
    public function sms_port_enable(Request $req, $id)
    {
        return (new TiffintomSMSPortController())->enable($req, $id);
    }
    // POST /api/tiffintom-sms-ports/{id}/disable
    public function sms_port_disable(Request $req, $id)
    {
        return (new TiffintomSMSPortController())->disable($req, $id);
    }
    // DELETE /api/tiffintom-sms-ports/{id}
    public function sms_port_delete(Request $req, $id)
    {
        return (new TiffintomSMSPortController())->delete($req, $id);
    }

    // GET /api/tiffintom-urls
    public function urls_index(Request $req)
    {
        return (new TiffintomUrlController())->index($req);
    }
    // POST /api/tiffintom-urls/
    public function urls_create(Request $req)
    {
        return (new TiffintomUrlController())->create($req);
    }
    // POST /api/tiffintom-urls/{id}
    public function urls_show(Request $req, $id)
    {
        return (new TiffintomUrlController())->show($req, $id);
    }
    // POST /api/tiffintom-urls/{id}
    public function urls_update(Request $req, $id)
    {
        return (new TiffintomUrlController())->update($req, $id);
    }
    // DELETE /api/tiffintom-urls/{id}
    public function urls_delete(Request $req, $id)
    {
        return (new TiffintomUrlController())->delete($req, $id);
    }
}
