<?php

namespace App\Http\Middleware;

use Closure;
use Illuminate\Support\Facades\Log;

class APITimeLogger
{
    public function handle($request, Closure $next)
    {
        // Record the start time
        $start_time = microtime(true);

        // Proceed with the request
        $response = $next($request);

        // Record the end time
        $end_time = microtime(true);

        // Calculate the runtime in milliseconds
        $runtime = round(($end_time - $start_time) * 1000, 2);

        // Log the runtime
        Log::info("API Runtime: " . $runtime . " ms");

        return $response;
    }
}
