<?php

namespace App;

use App\Helpers\ImageHelper;
use Illuminate\Database\Eloquent\Model;

class IdProof extends Model
{
    protected $fillable = ['user_id',  'type', 'type_proof', 'id_number', 'file_type', 'front_image', 'back_image', 'issuing_country', 'issue_place', 'issue_date', 'expiry_date'];
    protected $hidden = ['updated_at', 'front_image', 'back_image'];
    protected $appends = ['front_image_url', 'front_thumb_url', 'back_image_url', 'back_thumb_url'];

    public function getFrontImageUrlAttribute()
    {
        return ImageHelper::getServerImageUrl(ImageHelper::$TYPE_PROOF, $this->front_image);
    }
    public function getFrontThumbUrlAttribute()
    {
        return ImageHelper::getServerThumbUrl(ImageHelper::$TYPE_PROOF, $this->front_image);
    }

    public function getBackImageUrlAttribute()
    {
        return ImageHelper::getServerImageUrl(ImageHelper::$TYPE_PROOF, $this->back_image);
    }
    public function getBackThumbUrlAttribute()
    {
        return ImageHelper::getServerThumbUrl(ImageHelper::$TYPE_PROOF, $this->back_image);
    }

    // Attributes
    //
}
