<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class IssuingCard extends Model
{
    protected $fillable = [
        'business_id',
        'cardholder_id',
        'card_id',
        'brand',
        'cancellation_reason',
        'currency',
        'exp_month',
        'exp_year',
        'last4',
        'livemode',
        'replaced_by',
        'replacement_for',
        'replacement_reason',
        'type',
        'status',
        'service',
        'shipping_type',
        'city',
        'country',
        'line1',
        'postal_code',
        'line2',
        'state',
        'created',
    ];
    protected $hidden = ['updated_at'];
    protected $appends = ['card_holder', 'business'];
    protected $casts = ['livemode' => 'bool'];

    // Attributes
    //
    public function getBusinessAttribute()
    {
        return $this->business();
    }
    public function getCardHolderAttribute()
    {
        return $this->card_holder();
    }

    // Attributes
    //
    public function business()
    {
        return Business::where('id', $this->business_id)->first();
    }
    public function card_holder()
    {
        return CardHolder::where('id', $this->cardholder_id)->first();
    }
}
