<?php

namespace App\Jobs;

use App\Http\Controllers\Connect\StripeController;
use App\Http\Controllers\StripeTransactionController;
use App\StripeTransaction;
use Carbon\Carbon;
use Illuminate\Support\Facades\Log;

class ConnectTransferJob extends Job
{

    /**
     * Create a new job instance.
     *
     * @return void
     */
    public function __construct()
    {
    }

    /**
     * Execute the job.
     *
     * @return void
     */
    public function handle()
    {
        // Log::debug("Connect transfer called");
        $fromDate = Carbon::now()->subDays(10)->startOfDay();
        $toDate = Carbon::now()->subDays(4)->endOfDay();
        $stripeTransactions = StripeTransaction::where('service', 'Connect')->where('transfer_status', 'pending')->where('refunded', 0)->where('refunded_amount', '<', 'amount')->where('archived', 0);
        $stripeTransactions->where('created', '>', $fromDate->timestamp);
        $stripeTransactions->where('created', '<', $toDate->timestamp);
        $stripeTransactions = $stripeTransactions->get();
        if (!$stripeTransactions->isEmpty()) {
            return (new StripeTransactionController())->transferTransactions($stripeTransactions);
        }
    }
}
