<?php

namespace App\Jobs;

use Illuminate\Support\Facades\Log;
use Illuminate\Support\Facades\Mail;

class EmailSender extends Job
{
    /**
     * Run jobs
     * nohup php artisan queue:work --daemon > storage/logs/queue.log &
     * this will run all queues in background task
     * 
     */
    public $email;
    /**
     * Create a new job instance.
     *
     * @return void
     */
    public function __construct($email)
    {
        $this->email = $email;
    }

    /**
     * Execute the job.
     *
     * @return void
     */
    public function handle()
    {
        Mail::send([], [], function ($mail) {
            $mail->to($this->email['to'], $this->email['to_name']);
            $mail->subject($this->email['subject']);
            $mail->setBody($this->email['body']);
        });
        if (Mail::failures()) {
            Log::error("Mail send failed:: " . print_r($this->email, true));
        }
    }
}
