<?php

namespace App\Jobs;

use App\Http\Controllers\PaypalPaymentController;
use App\Http\Controllers\PaypalTransactionController;
use Illuminate\Support\Facades\Log;

class PaypalFetchJob extends Job
{
    /**
     * Run jobs
     * nohup php artisan queue:work --daemon > storage/logs/queue.log &
     * this will run all queues in background task
     * 
     */
    public $url;
    public $public_key;
    public $private_key;
    /**
     * Create a new job instance.
     *
     * @return void
     */
    public function __construct($url = null, $public_key = null, $private_key = null)
    {
        $this->url = $url;
        $this->private_key = $private_key;
        $this->public_key = $public_key;
    }

    /**
     * Execute the job.
     *
     * @return void
     */
    public function handle()
    {
        (new PaypalPaymentController())->fetch(null, $this->public_key, $this->private_key, $this->url);
    }
}
