<?php

namespace App\Jobs;

use App\Http\Controllers\PayoutReportController;
use App\Http\Controllers\PayoutRequestController;
use Carbon\Carbon;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Log;

class ReportCreatorJob extends Job
{
    /**
     * Run jobs
     * nohup php artisan queue:work --daemon > storage/logs/queue.log &
     * this will run all queues in background task
     * 
     */
    /**
     * Create a new job instance.
     *
     * @return void
     */
    public $req;
    public $business_id;
    public function __construct(Request $req, $business_id)
    {
        $this->req = $req;
        $this->business_id = $business_id;
    }

    /**
     * Execute the job.
     *
     * @return void
     */
    public function handle()
    {
        (new PayoutReportController())->quick_report($this->req, $this->business_id);
    }
}
