<?php

namespace App\Jobs;

use Illuminate\Contracts\Queue\ShouldQueue;
use Illuminate\Queue\SerializesModels;
use Illuminate\Support\Facades\Mail;

class SMTPMailJob extends Job implements ShouldQueue
{
    use SerializesModels;

    public $data;

    /**
     * Create a new job instance.
     *
     * @return void
     */
    public function __construct($data)
    {
        $this->data = $data;
    }

    /**
     * Execute the job.
     *
     * @return void
     */
    public function handle()
    {
        $mailData = $this->data;
        Mail::mailer('sendmail')->send([], [], function($message) use ($mailData) {
            $message->to($mailData['to_address'])
            ->subject($mailData['subject'])
            ->from($mailData['from_address'],$mailData['from_name'])
            ->setBody($mailData['body'], 'text/html');
        });
    }
}