<?php

namespace App\Jobs;

use App\Http\Controllers\StripeTransactionController;
use Illuminate\Support\Facades\Log;

class StripeFetchJob extends Job
{
    /**
     * Run jobs
     * nohup php artisan queue:work --daemon > storage/logs/queue.log &
     * this will run all queues in background task
     * 
     */
    public $business;
    public $private_key;
    public $mode;
    public $account_type;
    /**
     * Create a new job instance.
     *
     * @return void
     */
    public function __construct($business = null, $private_key = null, $mode = 'test', $account_type = 'normal')
    {
        $this->business = $business;
        $this->private_key = $private_key;
        $this->mode = $mode;
        $this->account_type = $account_type;
    }

    /**
     * Execute the job.
     *
     * @return void
     */
    public function handle()
    {
        (new StripeTransactionController())->fetch($this->business, $this->private_key, $this->mode, $this->account_type);
    }
}
