<?php

namespace App\Jobs;

use App\Http\Controllers\CaxtonfxUserController;
use App\Http\Controllers\PayoutReportController;
use Carbon\Carbon;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Log;

class TransferFetchJob extends Job
{
    /**
     * Run jobs
     * nohup php artisan queue:work --daemon > storage/logs/queue.log &
     * this will run all queues in background task
     * 
     */
    /**
     * Create a new job instance.
     *
     * @return void
     */
    public $req;
    public $user_id;
    public function __construct(Request $req, $user_id)
    {
        $this->req = $req;
        $this->user_id = $user_id;
    }

    /**
     * Execute the job.
     *
     * @return void
     */
    public function handle()
    {
        $client = new \GuzzleHttp\Client();
        (new CaxtonfxUserController($client))->fetch_pending_transfers($this->req, $this->user_id);
        (new CaxtonfxUserController($client))->fetch_transfer_transaction_sync($this->req, $this->user_id);
    }
}
