<?php

namespace App\ModelsEpos;

use Illuminate\Database\Eloquent\Model;

class EposCustomer extends Model
{
    protected $table = 'customers';
    protected $connection = "epos_connection";
    protected $fillable = [
        'name',
        'mobile',
        'email',
        'landline',
        'birth_date',
        'anniversary_date',
        'house_no',
        'street',
        'postcode',
        'distance',
        'city',
        'country',
        'state',
        'membership_no',
        'membership_points',
        'available_credit',
        'comment',
        'news_letter',
        'unique_id',
    ];
    protected $hidden = ['updated_at'];
    protected $casts = ['disabled' => 'bool', 'news_letter' => 'bool', 'membership_points' => 'double'];
}
