<?php

namespace App\ModelsEpos;

use App\Business;
use Illuminate\Database\Eloquent\Model;

class EposDevice extends Model
{
    protected $table = 'devices';
    protected $connection = "epos_connection";
    protected $fillable = ['device_id', 'device_token', 'type', 'name', 'business_id'];
    protected $hidden = ['updated_at'];
    protected $appends = ['business_name'];
    protected $casts = ['disabled' => 'bool', 'web_order' => 'bool'];

    public function getBusinessNameAttribute()
    {
        $business = Business::select('name', 'id')->where('id', $this->business_id)->first();
        if (!empty($business)) {
            $business->makeHidden(['user_counts', 'business_commissions', 'country', 'balance']);
            return $business->name;
        } else return null;
    }
}
