<?php

namespace App\ModelsEpos;

use Illuminate\Database\Eloquent\Model;

class EposFloor extends Model
{
    protected $table = 'floors';
    protected $connection = "epos_connection";
    protected $fillable = [
        'name'
    ];
    protected $hidden = ['updated_at'];
    protected $appends = ['total_tables'];

    public function getTotalTablesAttribute()
    {
        return EposTable::where('floor_id', $this->id)->where('disabled', '0')->count();
    }
    public function getTablesAttribute()
    {
        return $this->tables()->orderByRaw('sequence ASC')->get();
    }
    public function tables()
    {
        return $this->hasMany('App\ModelsEpos\EposTable', 'floor_id');
    }
}
