<?php

namespace App\ModelsEpos;

use Illuminate\Database\Eloquent\Model;

class EposReservation extends Model
{
    protected $table = 'reservations';
    protected $connection = "epos_connection";
    protected $fillable = [
        'customer_id',
        'table_id',
        'reservation_status_id',
        'deposit_type_id',
        'reservation_confirmation_id',
        'updater_id',
        'deposit_amount',
        'telephone',
        'reservation_date_time',
        'children',
        'infants',
        'diners',
        'special_instruction',
        'unique_id',
    ];
    protected $hidden = ['updated_at'];

    public function getCustomerAttribute()
    {
        return $this->customer();
    }
    public function customer()
    {
        return EposCustomer::where('id', $this->customer_id)->first();
    }

    public function getTableAttribute()
    {
        return $this->table();
    }
    public function table()
    {
        return EposTable::where('id', $this->table_id)->first();
    }
}
