<?php

namespace App\ModelsEpos;

use App\Helpers\ImageHelper;
use Illuminate\Database\Eloquent\Model;

class EposUser extends Model
{
    protected $table = "users";
    protected $connection = "epos_connection";

    protected $fillable = [
        'user_type_id',
        'user_group_id',
        'username',
        'password',
        'mobile',
        'email',
        'is_loggin',
        'preffix',
    ];
    protected $hidden = ['password', 'updated_at'];
    protected $casts = ['disabled' => 'bool', 'is_loggin' => 'bool', 'reseller' => 'bool', 'permissions' => 'json'];
    protected $appends = ['image_url', 'thumb_url'];

    public function getImageUrlAttribute()
    {
        return ImageHelper::getServerImageUrl(ImageHelper::$TYPE_EPOS_USER, $this->image);
    }
    public function getThumbUrlAttribute()
    {
        return ImageHelper::getServerThumbUrl(ImageHelper::$TYPE_EPOS_USER, $this->image);
    }
}