<?php

namespace App\ModelsEpos;

use Illuminate\Database\Eloquent\Model;

class EposVoucher extends Model
{
    protected $table = 'vouchers';
    protected $connection = "epos_connection";
    protected $fillable = [
        'customer_id',
        'order_type_id',
        'week_day',
        'voucher_code',
        'voucher_amount',
        'minimum_order_value',
        'start_date',
        'end_date',
        'unique_id',
    ];
    protected $hidden = ['updated_at'];
    protected $appends = ['customer'];
    protected $casts = ['disabled' => 'bool', 'voucher_amount' => 'float', 'minimum_order_value' => 'float', 'applied' => 'bool'];

    public function getCustomerAttribute()
    {
        return $this->customer();
    }
    public function customer()
    {
        return EposCustomer::where('id', $this->customer_id)->first();
    }
}
