<?php

namespace App\ModelsTiffintom;

use Illuminate\Database\Eloquent\Model;

class TiffintomAppFeedback extends Model
{
    protected $table = "app_feedback";
    protected $connection = "tiffintom_connection";
    protected $casts = [];
    protected $fillable = [
        'customer_id',
        'subject',
        'message',
        'response',
    ];
    protected $hidden = [];
    protected $appends = ['customer'];

    const CREATED_AT = 'created';
    const UPDATED_AT = 'created';

    // Attributes
    //
    public function getCustomerAttribute()
    {
        $user = TiffintomUser::where('id', $this->customer_id)->first();
        if (empty($user)) {
            return null;
        }
        return $user;
    }
}
