<?php

namespace App\ModelsTiffintom;

use Illuminate\Database\Eloquent\Model;
use Illuminate\Support\Facades\Log;

class TiffintomCart extends Model
{
    protected $table = "carts";
    protected $connection = "tiffintom_connection";
    protected $casts = [
        'quantity' => 'int',
        'menu_price' => 'double',
        'offer_price' => 'double',
        'total_price' => 'double',
        'menu_price' => 'double',
    ];
    protected $fillable = [
        'id',
        'order_id',
        'restaurant_id',
        'menu_id',
        'menu_name',
        'subaddons_name',
        'menu_price',
        'total_price',
        'quantity',
        'menu_description',
        'customer_id',
    ];
    const CREATED_AT = 'created';
    const UPDATED_AT = 'updated';
    protected $appends = ['short_name', 'restaurant'];


    // Attributes
    //
    public function getShortNameAttribute()
    {
        $menu = TiffintomMenu::where('id', $this->menu_id)->first();
        if (isset($menu->short_name)) {
            return $menu->short_name;
        } else {
            return null;
        }
    }
    public function getRestaurantAttribute()
    {
        return  TiffintomRestaurant::where('id', $this->restaurant_id)->first();
    }
}
