<?php

namespace App\ModelsTiffintom;

use Illuminate\Database\Eloquent\Model;

class TiffintomCategory extends Model
{
    protected $table = "categories";
    protected $connection = "tiffintom_connection";

    protected $fillable = [
        'id',
        'restaurant_id',
        'category_name',
        'category_seo',
        'sortorder',
        'description',
        'delete_status',
        'status',
    ];
    const CREATED_AT = 'created';
    const UPDATED_AT = 'modified';
    protected $casts = [
        'status' => 'bool'
    ];

    public function getMenuAttribute()
    {
        return $this->hasMany('App\ModelsTiffintom\TiffintomMenu', 'category_id', 'id')->where('status', '1')->with(['variants'])->orderByRaw('sortorder ASC')->get();
    }
    public function getMenuSuggestedAttribute()
    {
        return $this->hasMany('App\ModelsTiffintom\TiffintomMenu', 'category_id', 'id')->where('status', '1')->where('is_suggest', '1')->where('price_option', 'single')->where('menu_addon', 'No')->with(['variants'])->orderByRaw('sortorder ASC')->get();
    }
    public function getPrintBlockIdAttribute()
    {
        $printBlockAssign = $this->assign_print_block();
        if (!empty($printBlockAssign)) {
            return $printBlockAssign->print_block_id;
        } else return null;
    }
    public function getAssignPrintBlockAttribute()
    {
        $PrintBlockAssign = $this->assign_print_block();
        return $PrintBlockAssign;
    }
    public function assign_print_block()
    {
        $PrintBlockAssign = TiffintomPrintBlockAssign::select('print_block_id')->where('category_id', $this->id)->first();
        return $PrintBlockAssign;
    }
}
