<?php

namespace App\ModelsTiffintom;

use App\Helpers\ImageHelper;
use Illuminate\Database\Eloquent\Model;

class TiffintomChat extends Model
{
    protected $table = "chat";
    protected $connection = "tiffintom_connection";
    protected $casts = [];
    protected $fillable = [
        'message',
        'user_id',
        'restaurant_id',
        'order_id',
        'admin',
        'status',
        'is_attach',
    ];
    protected $hidden = ['modified'];
    protected $appends = ['image_url', 'user', 'restaurant', 'unread_count_restaurant', 'unread_count_user'];

    const CREATED_AT = 'created';
    const UPDATED_AT = 'modified';

    // Attributes
    //
    public function getImageUrlAttribute()
    {
        // return ImageHelper::getServerImageUrl(ImageHelper::$TYPE_TIFFINTOM_ORDERHELP, $this->image, env('FTP_IMAGE_PATH_TIFFINTOM'));
        if ($this->is_attach != 0) {
            return ImageHelper::getServerImageUrl(ImageHelper::$TYPE_TIFFINTOM_ORDERHELP, $this->message, env('FTP_IMAGE_PATH_TIFFINTOM'));
        } else {
            return null;
        }
    }
    public function getUserAttribute()
    {
        return TiffintomUser::where('id', $this->user_id)->first();
    }
    public function getRestaurantAttribute()
    {
        return TiffintomRestaurant::where('id', $this->restaurant_id)->first();
    }
    public function getUnreadCountRestaurantAttribute()
    {
        return TiffintomChat::where('restaurant_id', $this->restaurant_id)->where('status', '1')->where('admin', '1')->count();
    }
    public function getUnreadCountUserAttribute()
    {
        return TiffintomChat::where('user_id', $this->user_id)->where('status', '1')->where('admin', '0')->count();
    }
}
