<?php

namespace App\ModelsTiffintom;

use Illuminate\Database\Eloquent\Model;

class TiffintomCity extends Model
{
    protected $table = "cities";
    protected $connection = "tiffintom_connection";
    protected $fillable = [
        'id',
        'country_id',
        'state_id',
        'city_name',
        'status',
    ];
    protected $hidden = [];
    protected $appends = ['country', 'state'];
    protected $casts = [
        'status' => 'bool',
    ];
    const CREATED_AT = 'created';
    const UPDATED_AT = 'modified';

    // Attributes
    //
    public function getCountryAttribute()
    {
        return TiffintomCountry::where('id', $this->country_id)->first();
    }
    public function getStateAttribute()
    {
        return TiffintomState::where('id', $this->state_id)->first();
    }
}
