<?php

namespace App\ModelsTiffintom;

use App\Helpers\ImageHelper;
use Illuminate\Database\Eloquent\Model;

class TiffintomComplaint extends Model
{
    protected $table = "complaint";
    protected $connection = "tiffintom_connection";
    protected $fillable = [
        'message',
        'user_id',
        'restaurant_id',
        'order_id',
        'admin',
        'status',
        'close',
    ];
    protected $hidden = ['modified'];
    protected $appends = ['user', 'restaurant'];
    protected $casts = [
        'admin' => 'bool',
        'status' => 'bool',
        'close' => 'bool',
    ];

    const CREATED_AT = 'created';
    const UPDATED_AT = 'modified';

    // Attributes
    //
    public function getUserAttribute()
    {
        return TiffintomUser::where('id', $this->user_id)->first();
    }
    public function getRestaurantAttribute()
    {
        return TiffintomRestaurant::where('id', $this->restaurant_id)->first();
    }
}
