<?php

namespace App\ModelsTiffintom;

use App\Helpers\ImageHelper;
use Illuminate\Database\Eloquent\Model;

class TiffintomCuisine extends Model
{
    protected $table = "cuisines";
    protected $connection = "tiffintom_connection";
    protected $casts = [
        'status' => 'bool'
    ];
    protected $fillable = [
        'cuisine_name',
        'cuisine_image',
        'cuisine_seo',
        'first_bg',
        'second_bg',
        'status',
        'delete_status',
    ];
    protected $hidden = ['modified'];
    protected $appends = ['image_url'];

    const CREATED_AT = 'created';
    const UPDATED_AT = 'modified';

    // Attributes
    //
    public function getImageUrlAttribute()
    {
        return ImageHelper::getServerImageUrl(ImageHelper::$TYPE_TIFFINTOM_CUISINE, $this->cuisine_image, env('FTP_IMAGE_PATH_TIFFINTOM'));
    }
}
