<?php

namespace App\ModelsTiffintom;

use Illuminate\Database\Eloquent\Model;

class TiffintomDineinCategory extends Model
{
    protected $table = "dinein_categories";
    protected $connection = "tiffintom_connection";
    protected $casts = [
        'status' => 'bool'
    ];
    protected $fillable = [
        'id',
        'restaurant_id',
        'category_name',
        'category_seo',
        'sortorder',
        'description',
        'delete_status',
        'status',
    ];
    const CREATED_AT = 'created';
    const UPDATED_AT = 'modified';

    public function getMenuAttribute()
    {
        return $this->hasMany('App\ModelsTiffintom\TiffintomDineinMenu', 'category_id', 'id')->where('status', '1')->with(['variants'])->orderByRaw('sortorder ASC')->get();
    }
    public function getMenuSuggestedAttribute()
    {
        return $this->hasMany('App\ModelsTiffintom\TiffintomDineinMenu', 'category_id', 'id')->where('status', '1')->where('is_suggest', '1')->where('price_option', 'single')->where('menu_addon', 'No')->with(['variants'])->orderByRaw('sortorder ASC')->get();
    }
}
