<?php

namespace App\ModelsTiffintom;

use Illuminate\Database\Eloquent\Model;

class TiffintomDineinMenu extends Model
{
    protected $table = "dinein_restaurant_menus";
    protected $connection = "tiffintom_connection";
    protected $casts = [

        'is_suggest' => 'int',
        'sortorder' => 'int',
        'status' => 'bool',
        'vegetarian' => 'int',
        'contains_nuts' => 'int',
        'milk' => 'int',
        'mustard' => 'int',
        'eggs' => 'int',
        'fish' => 'int',
        'gluten_free' => 'int',
        'halal' => 'int',
        'koshar' => 'int',
        'vegan' => 'int',
        'crustaceans' => 'int',
        'molluscs' => 'int',
        'sulphur_dioxide' => 'int',
        'sulphites' => 'int',
        'product_percentage' => 'double',
    ];
    protected $fillable = [
        'id',
        'restaurant_id',
        'category_id',
        'menu_name',
        'is_suggest',
        'price_option',
        'menu_description',
        'menu_type',
        'menu_addon',
        'popular_dish',
        'featured',
        'spicy_dish',
        'favourite',
        'status',
        'delete_status',
        'sortorder',
        'short_name',
        'vegetarian',
        'contains_nuts',
        'milk',
        'mustard',
        'eggs',
        'fish',
        'gluten_free',
        'halal',
        'koshar',
        'vegan',
        'crustaceans',
        'molluscs',
        'sulphur_dioxide',
        'sulphites',
        'product_percentage',
    ];
    const CREATED_AT = 'created';
    const UPDATED_AT = 'modified';
    public function variants()
    {
        return $this->hasMany('App\ModelsTiffintom\TiffintomDineinMenuVariant', 'menu_id', 'id');
    }
}
