<?php

namespace App\ModelsTiffintom;

use Illuminate\Database\Eloquent\Model;

class TiffintomDineinOrder extends Model
{
    protected $table = "dinein_orders";
    protected $connection = "tiffintom_connection";
    protected $casts = [
        'offer_percentage' => 'double',
        'offer_amount' => 'double',
        'order_point' => 'double',
        'order_sub_total' => 'double',
        'order_grand_total' => 'double',
        'service_charge' => 'double',
        'charity_amount' => 'double',
        'voucher_amount' => 'double',
    ];
    protected $fillable = [
        'id',
        'restaurant_id',
        'customer_id',
        'customer_name',
        'customer_email',
        'customer_phone',
        'order_description',
        'offer_percentage',
        'offer_amount',
        'day_offer',
        'tax_percentage',
        'tax_amount',
        'service_charge',
        'voucher_code',
        'voucher_percentage',
        'voucher_amount',
        'order_sub_total',
        'order_grand_total',
        'cardfee_percentage',
        'cardfee_price',
        'payment_status',
        'payment_method',
        'card_id',
        'payment_wallet',
        'paid_full',
        'split_payment',
        'wallet_amount',
        'transaction_id',
        'reward_used',
        'failed_reason',
        'order_point',
        'spent_point',
        'reward_offer',
        'reward_offer_percentage',
        'stripe_customerid',
        'payerID',
        'paymentToken',
        'paymentID',
        'order_proof',
        'status',
        'type',
        'completed_time',
        'preparation',
        'charity_amount',
        'charity_message',
        'gratuity',
        'no_of_guest',
        'table_no',
    ];
    const CREATED_AT = 'created';
    const UPDATED_AT = 'modified';
    protected $appends = ['restaurant'];


    // Attributes
    //
    public function getRestaurantAttribute()
    {
        return  TiffintomRestaurant::where('id', $this->restaurant_id)->first();
    }
    public function getCartViewAttribute()
    {
        $carts = TiffintomDineinCart::where('order_id', $this->id)->orderBy('id', 'DESC')->get();
        return $carts;
    }
    public function getCardViewAttribute()
    {
        $cards = TiffintomStripeCustomer::where('id', $this->card_id)->first();
        return $cards;
    }
    public function getReviewsAttribute()
    {
        $reviews = TiffintomReview::where('order_id', $this->id)->where('order_type', '1')->orderBy('id', 'DESC')->first();
        return $reviews;
    }
}
