<?php

namespace App\ModelsTiffintom;

use App\Helpers\ImageHelper;
use Illuminate\Database\Eloquent\Model;

class TiffintomDownloadDocument extends Model
{
    protected $table = "download_documents";
    protected $connection = "tiffintom_connection";
    protected $casts = [];
    protected $fillable = [
        'name',
        'type',
        'path',
    ];
    protected $appends = ['image_url'];

    const CREATED_AT = 'created';
    const UPDATED_AT = 'created';

    // Attributes
    //
    public function getImageUrlAttribute()
    {
        if ($this->type == 'file') {
            return ImageHelper::getServerImageUrl(ImageHelper::$TYPE_TIFFINTOM_PARTNERMEDIA, $this->url, env('FTP_IMAGE_PATH_TIFFINTOM'));
        } else {
            return null;
        }
    }
}
