<?php

namespace App\ModelsTiffintom;

use App\Helpers\ImageHelper;
use Illuminate\Database\Eloquent\Model;

class TiffintomLanguageSetting extends Model
{
    protected $table = "language_settings";
    protected $connection = "tiffintom_connection";
    protected $fillable = [
        'language_name',
        'language_code',
        'language_default',
        'status',
        'delete_status',
    ];
    protected $appends = ['language_contents'];
    protected $casts = [
        'language_default' => 'bool',
        'status' => 'bool',
    ];

    const CREATED_AT = 'created';
    const UPDATED_AT = 'modified';

    // Attributes
    //
    public function getLanguageContentsAttribute()
    {
        return $this->language_contents();
    }
    public function language_contents()
    {
        return TiffintomLanguageContent::where('language_id', $this->id)->get();
    }
}