<?php

namespace App\ModelsTiffintom;

use Illuminate\Database\Eloquent\Model;

class TiffintomLocation extends Model
{
    protected $table = "locations";
    protected $connection = "tiffintom_connection";
    protected $fillable = [
        'id',
        'state_id',
        'city_id',
        'area_name',
        'zip_code',
        'status',
    ];
    protected $hidden = [];
    protected $appends = ['state', 'city'];
    protected $casts = [
        'status' => 'bool',
    ];
    const CREATED_AT = 'created';
    const UPDATED_AT = 'modified';

    // Attributes
    //
    public function getStateAttribute()
    {
        return TiffintomState::where('id', $this->state_id)->first();
    }
    public function getCityAttribute()
    {
        return TiffintomCity::where('id', $this->city_id)->first();
    }
}
