<?php

namespace App\ModelsTiffintom;

use App\Helpers\ImageHelper;
use Illuminate\Database\Eloquent\Model;

class TiffintomMenu extends Model
{
    protected $table = "restaurant_menus";
    protected $connection = "tiffintom_connection";
    protected $casts = [
        'is_suggest' => 'string',
        'sortorder' => 'int',
        'status' => 'bool',
        'vegetarian' => 'bool',
        'contains_nuts' => 'bool',
        'milk' => 'bool',
        'mustard' => 'bool',
        'eggs' => 'bool',
        'fish' => 'bool',
        'gluten_free' => 'bool',
        'halal' => 'bool',
        'koshar' => 'bool',
        'vegan' => 'bool',
        'crustaceans' => 'bool',
        'molluscs' => 'bool',
        'sulphur_dioxide' => 'bool',
        'sulphites' => 'bool',
        'product_percentage' => 'double',
    ];
    protected $fillable = [
        'id',
        'restaurant_id',
        'category_id',
        'menu_name',
        'is_suggest',
        'price_option',
        'menu_description',
        'menu_type',
        'menu_addon',
        'popular_dish',
        'featured',
        'spicy_dish',
        'favourite',
        'status',
        'delete_status',
        'sortorder',
        'short_name',
        'vegetarian',
        'contains_nuts',
        'milk',
        'mustard',
        'eggs',
        'fish',
        'gluten_free',
        'halal',
        'koshar',
        'vegan',
        'crustaceans',
        'molluscs',
        'sulphur_dioxide',
        'sulphites',
        'product_percentage',
    ];
    protected $appends = ['image_url', 'thumb_url'];

    const CREATED_AT = 'created';
    const UPDATED_AT = 'modified';

    public function variants()
    {
        return $this->hasMany('App\ModelsTiffintom\TiffintomMenuVariant', 'menu_id', 'id');
        // return $this->hasMany(TiffintomMenuVariant::class, 'menu_id', 'id');
    }

    // Attributes
    //
    public function getImageUrlAttribute()
    {
        if (isset($this->menu_image)) {
            return ImageHelper::getServerImageUrl(ImageHelper::$TYPE_TIFFINTOM_MENU . '/' . $this->id, $this->menu_image, env('FTP_IMAGE_PATH_TIFFINTOM'));
        } else {
            return null;
        }
    }
    public function getThumbUrlAttribute()
    {
        if (isset($this->menu_image)) {
            return ImageHelper::getServerThumbUrl(ImageHelper::$TYPE_TIFFINTOM_MENU . '/' . $this->id, $this->menu_image, env('FTP_IMAGE_PATH_TIFFINTOM'));
        } else {
            return null;
        }
    }
}
