<?php

namespace App\ModelsTiffintom;

use Illuminate\Database\Eloquent\Model;
use Illuminate\Support\Facades\Log;

class TiffintomMenuVariant extends Model
{
    protected $table = "menu_details";
    protected $connection = "tiffintom_connection";
    protected $casts = [];
    const CREATED_AT = 'created';
    const UPDATED_AT = 'modified';

    public function getMainAddonsAttribute()
    {
        $mainAddonIds = TiffintomMenuAddons::select("mainaddons_id")->where('menudetails_id', $this->id)->groupBy('mainaddons_id')->get();
        if (!$mainAddonIds->isEmpty()) {
            $mainAddons = TiffintomMainAddon::whereIn('id', $mainAddonIds)->orderBy('sortorder', 'ASC')->get();
            foreach ($mainAddons as $key => $mainAddon) {
                $menuAddonsId = TiffintomMenuAddons::select("subaddons_id")->where('mainaddons_id', $mainAddon->id)->where('menu_id', $this->menu_id)->where('menudetails_id', $this->id)->get();
                // $mainAddons[$key]['sub_addons'] = TiffintomSubAddon::whereIn('id', $menuAddonsId)->get();
                $mainAddons[$key]['sub_addons'] = TiffintomSubAddon::selectRaw("subaddons.id,subaddons.mainaddons_id,subaddons.category_id,subaddons.subaddons_name,subaddons.status,subaddons.delete_status,menu_addons.subaddons_price as subaddons_price,subaddons.created,subaddons.modified")->leftJoin('menu_addons', 'menu_addons.subaddons_id', '=', 'subaddons.id')->where('menu_addons.menudetails_id', $this->id)->where('menu_addons.menu_id', $this->menu_id)->whereIn('subaddons.id', $menuAddonsId)->get();
            }
            return $mainAddons;
        }
        return null;
    }

    public function getMenuAddonsAttribute()
    {
        $mainAddonIds = TiffintomMenuAddons::where('menudetails_id', $this->id)->get();
        if (!$mainAddonIds->isEmpty()) {
            return $mainAddonIds; //TiffintomMainAddon::whereIn('id', $mainAddonIds)->orderBy('sortorder', 'ASC')->get();
        }
        return null;
    }

    public function getAllAddonsAttribute()
    {
        $mainAddonIds = TiffintomMenuAddons::select("category_id")->where('menudetails_id', $this->id)->groupBy('mainaddons_id')->get();
        if (!$mainAddonIds->isEmpty()) {
            return TiffintomMainAddon::whereIn('category_id', $mainAddonIds)->where('status', '1')->orderBy('sortorder', 'ASC')->get();
        }
        return null;
    }

    // public function menuAddons()
    // {
    //     return $this->hasMany(TiffintomMenuAddons::class, 'menudetails_id');
    // }
}