<?php

namespace App\ModelsTiffintom;

use Illuminate\Database\Eloquent\Model;

class TiffintomNote extends Model
{
    protected $table = "notes";
    protected $connection = "tiffintom_connection";
    protected $fillable = [
        'id',
        'creates',
        'restaurant_id',
        'note',
        'status',
    ];
    protected $hidden = ['modified'];
    protected $appends = ['user', 'restaurant'];
    protected $casts = [
        'status' => 'bool',
    ];

    const CREATED_AT = 'created';
    const UPDATED_AT = 'modified';

    // Attributes
    //
    public function getUserAttribute()
    {
        return TiffintomUser::where('id', $this->creates)->first();
    }
    public function getRestaurantAttribute()
    {
        return TiffintomRestaurant::where('id', $this->restaurant_id)->first();
    }
}
