<?php

namespace App\ModelsTiffintom;

use App\Helpers\ImageHelper;
use Illuminate\Database\Eloquent\Model;

class TiffintomPartnerMedia extends Model
{
    protected $table = "partner_media";
    protected $connection = "tiffintom_connection";
    protected $fillable = [
        'restaurant_id',
        'title',
        'url',
        'type',
        'status',
    ];
    protected $appends = ['image_url'];
    protected $casts = [
        'status' => 'bool',
    ];

    const CREATED_AT = 'created';
    const UPDATED_AT = 'created';

    // Attributes
    //
    public function getImageUrlAttribute()
    {
        if ($this->type == 0) {
            return ImageHelper::getServerImageUrl(ImageHelper::$TYPE_TIFFINTOM_PARTNERMEDIA, $this->url, env('FTP_IMAGE_PATH_TIFFINTOM'));
        } else {
            return null;
        }
    }
}
