<?php

namespace App\ModelsTiffintom;

use App\Helpers\ImageHelper;
use Illuminate\Database\Eloquent\Model;

class TiffintomPaymentMethod extends Model
{
    protected $table = "payment_methods";
    protected $connection = "tiffintom_connection";
    protected $fillable = [
        'id',
        'payment_method_name',
        'payment_method_image',
    ];
    protected $casts = [
        'status' => 'bool'
    ];
    protected $appends = ['image_url'];
    protected $hidden = ['created', 'modified'];

    const CREATED_AT = 'created';
    const UPDATED_AT = 'modified';

    // Attributes
    //
    public function getImageUrlAttribute()
    {
        return ImageHelper::getServerImageUrl(ImageHelper::$TYPE_TIFFINTOM_PAYMENT_METHOD, $this->url, env('FTP_IMAGE_PATH_TIFFINTOM'));
    }
}