<?php

namespace App\ModelsTiffintom;

use App\Helpers\ImageHelper;
use Illuminate\Database\Eloquent\Model;

class TiffintomPromotion extends Model
{
    protected $table = "promotions";
    protected $connection = "tiffintom_connection";
    protected $casts = [];
    protected $fillable = [
        'restaurant_id',
        'promo_image',
        'promo_image_url',
    ];
    protected $appends = ['image_url'];

    public $timestamps = false;

    // Attributes
    //
    public function getImageUrlAttribute()
    {
        if (isset($this->promo_image)) {
            return ImageHelper::getServerImageUrl(ImageHelper::$TYPE_TIFFINTOM_RESTAURANT, $this->restaurant_id . '/storeBanners/' . $this->promo_image, env('FTP_IMAGE_PATH_TIFFINTOM'));
        } else {
            return null;
        }
    }
}
