<?php

namespace App\ModelsTiffintom;

use App\Helpers\ImageHelper;
use Illuminate\Database\Eloquent\Model;

class TiffintomPromotionBanner extends Model
{
    protected $table = "promotion_banners";
    protected $connection = "tiffintom_connection";
    protected $casts = [];
    protected $fillable = [
        'banner_image',
        'banner_link',
        'restaurant_id',
    ];
    protected $appends = ['image_url'];

    public $timestamps = false;

    // Attributes
    //
    public function getImageUrlAttribute()
    {
        if (isset($this->banner_image)) {
            return ImageHelper::getServerImageUrl(ImageHelper::$TYPE_TIFFINTOM_PROMOTION_BANNER, $this->banner_image, env('FTP_IMAGE_PATH_TIFFINTOM'));
        } else {
            return null;
        }
    }
}
