<?php

namespace App\ModelsTiffintom;

use Illuminate\Database\Eloquent\Model;

class TiffintomReferralPending extends Model
{
    protected $table = "referrals_pending";
    protected $connection = "tiffintom_connection";
    protected $fillable = [
        'id',
        'invite_user',
        'invite_amount',
        'recieve_user',
        'receive_amount',
        'status',
    ];
    protected $casts = [];
    protected $hidden = [];
    protected $appends = ['invite_user_name', 'recieve_user_name'];
    const CREATED_AT = 'created';
    const UPDATED_AT = 'created';

    // Attributes
    //
    public function getInviteUserNameAttribute()
    {
        $user = TiffintomUser::where('id', $this->invite_user)->first();
        if ($user) {
            return $user->first_name;
        } else {
            return null;
        }
    }
    public function getRecieveUserNameAttribute()
    {
        $user =  TiffintomUser::selectRaw('first_name')->where('id', $this->recieve_user)->first();
        if ($user) {
            return $user->first_name;
        } else {
            return null;
        }
    }
}
