<?php

namespace App\ModelsTiffintom;

use App\Business;
use App\Helpers\ImageHelper;
use App\Http\Controllers\SiteSettingController;
use Carbon\Carbon;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Support\Facades\Log;

class TiffintomRestaurant extends Model
{
    protected $table = "restaurants";
    protected $connection = "tiffintom_connection";
   // protected $guarded = [];
   protected $fillable = [
    'user_id',
    'contact_name',
    'contact_phone',
    'contact_email',
    'contact_address',
    'sourcelatitude',
    'sourcelongitude',
    'street_address',
    'country_id',
    'currency',
    'timezone',
    'currency_code',
    'state_id',
    'city_id',
    'location_id',
    'zipcode',
    'restaurant_name',
    'seo_url',
    'restaurant_phone',
    'working_time',
    'monday_first_opentime',
    'monday_first_closetime',
    'monday_second_opentime',
    'monday_second_closetime',
    'tuesday_first_opentime',
    'tuesday_first_closetime',
    'tuesday_second_opentime',
    'tuesday_second_closetime',
    'wednesday_first_opentime',
    'wednesday_first_closetime',
    'wednesday_second_opentime',
    'wednesday_second_closetime',
    'thursday_first_opentime',
    'thursday_first_closetime',
    'thursday_second_opentime',
    'thursday_second_closetime',
    'friday_first_opentime',
    'friday_first_closetime',
    'friday_second_opentime',
    'friday_second_closetime',
    'saturday_first_opentime',
    'saturday_first_closetime',
    'saturday_second_opentime',
    'saturday_second_closetime',
    'sunday_first_opentime',
    'sunday_first_closetime',
    'sunday_second_opentime',
    'sunday_second_closetime',
    'monday_status',
    'tuesday_status',
    'wednesday_status',
    'thursday_status',
    'friday_status',
    'saturday_status',
    'sunday_status',
    'monday_estimate_time',
    'tuesday_estimate_time',
    'wednesday_estimate_time',
    'thursday_estimate_time',
    'friday_estimate_time',
    'saturday_estimate_time',
    'sunday_estimate_time',
    'restaurant_tax',
    'pickup_estimate_time',
    'restaurant_cuisine',
    'restaurant_dietary',
    'restaurant_visibility',
    'restaurant_dispatch',
    'online_order',
    'restaurant_pickup',
    'restaurant_delivery',
    'restaurant_booktable',
    'booking_status',
    'image_type',
    'restaurant_about',
    'username',
    'estimate_time',
    'minimum_order',
    'paypal_minimum_order',
    'card_minimum_order',
    'free_delivery',
    'booking_start',
    'booking_end',
    'map_mode',
    'email_order',
    'order_email',
    'sms_option',
    'sms_phonenumber',
    'restaurant_commission',
    'cash_commission',
    'card_commission',
    'paypal_commission',
    'invoice_period',
    'meta_title',
    'meta_keyword',
    'meta_description',
    'restaurant_logo',
    'logo_name',
    'is_logged',
    'device_name',
    'device_id',
    'fb_page_id',
    'reward_option',
    'status',
    'response_status',
    'notification_status',
    'delete_status',
    'created',
    'modified',
    'service_charge',
    'service_charge_type',
    'service_charge_status',
    'stripe_description',
    'stripe_descriptor',
    'close',
    'servicecharge_delivery',
    'servicecharge_picked',
    'order_charge_type',
    'per_order_charge',
    'cash_charge_type',
    'cash_charge',
    'card_charge_type',
    'card_charge',
    'paypal_charge_type',
    'paypal_charge',
    'food_rating',
    'facebook_login',
    'google_login',
    'twitter_login',
    'apple_login',
    'new',
    'is_featured',
    'alcahol_available',
    'alcahol_not_available',
    'bring_your_alcahol',
    'soft_drink',
    'checkout_message',
    'driver_tip',
    'payment_plan',
    'smart_mps_id',
    'RTC',
    'app_setting',
    'delivered_message',
    'delivery_charge',
    'wallet_payment',
    'otp',
    'verify_email',
    'dine_in',
    'qr_code',
    'gratuity',
    'dinein_stripe_description',
    'dinein_stripe_descriptor',
    'dinein_wallet_payment',
    'dinein_service_charge',
    'dinein_service_charge_type',
    'dinein_service_charge_status',
    'dinein_restaurant_commission',
    'type',
    'booking_start_days',
    'no_of_guest',
    'is_allergy',
    'allergy_message',
    'sms_sender_id',
];
    protected $casts = [
        'status' => 'bool',
        'is_featured' => 'bool',
        'alcahol_available' => 'bool',
        'alcahol_not_available' => 'bool',
        'bring_your_alcahol' => 'bool',
        'soft_drink' => 'bool',
        'verify_email' => 'bool',
        'servicecharge_delivery' => 'bool',
        'servicecharge_picked' => 'bool',
        'response_status' => 'bool',
        'notification_status' => 'bool',
        'no_of_guest' => 'integer',
        'driver_tip' => 'bool',
        'gratuity' => 'bool',
        'service_charge_type' => 'string',
        // 'is_allergy' => 'bool',
        // 'RTC' => 'bool',
        // 'new' => 'bool',
        // 'dine_in' => 'bool',
        // 'dinein_service_charge_type' => 'bool',
        // 'paypal_charge_type' => 'bool',
        // 'order_charge_type' => 'bool',
        // 'cash_charge_type' => 'bool',
        // 'card_charge_type' => 'bool',
        // 'paypal_charge_type' => 'bool',
    ];
    protected $hidden = [];
    protected $appends = ['image_url', 'thumb_url', 'promotions', 'offer_texts', 'surcharges', 'city_name'];
    const CREATED_AT = 'created';
    const UPDATED_AT = 'modified';

    // Attributes
    //
    public function getImageUrlAttribute()
    {
        if (isset($this->logo_name)) {
            return ImageHelper::getServerImageUrl(ImageHelper::$TYPE_TIFFINTOM_RESTAURANT, $this->id . '/storeLogo/' . $this->logo_name, env('FTP_IMAGE_PATH_TIFFINTOM'));
        } else {
            return null;
        }
    }
    public function getThumbUrlAttribute()
    {
        if (isset($this->logo_name)) {
            return ImageHelper::getServerThumbUrl(ImageHelper::$TYPE_TIFFINTOM_RESTAURANT, $this->id . '/storeLogo/' . $this->logo_name, env('FTP_IMAGE_PATH_TIFFINTOM'));
        } else {
            return null;
        }
    }
    public function orders()
    {
        return $this->belongsTo('App\ModelsTiffintom\TiffintomOrder', 'id', 'restaurant_id');
    }
    public function offerTexts()
    {
        return $this->hasMany('App\ModelsTiffintom\TiffintomOfferText', 'restaurant_id', 'id');
    }
    public function getSurchargesAttribute()
    {
        return TiffintomSurcharge::where('restaurant_id', $this->id)->where('status', 1)->get();
    }
    public function getRestaurantTimingAttribute()
    {
        return $this->restaurant_timing();
    }
    public function restaurant_timing()
    {
        return TiffintomRestaurantTiming::where('restaurant_id', $this->id)->first();
    }
    public function getCityNameAttribute()
    {
        if (isset($this->city_id)) {
            $text = preg_replace('~[^\\pL\d]+~u', '-', $this->city_id);
            $text = trim($text, '-');
            $text = strtolower($text);
            $text = preg_replace('~[^-\w]+~', '', $text);
            if (strlen($text) > 70) $text = substr($text, 0, 70);
            return $text;
        } else {
            return null;
        }
    }
    public function getCurrentStatusAttribute()
    {
        return $this->currentStatus();
    }
    public function currentStatus()
    {
        $restaurant = TiffintomRestaurant::where('id', $this->id)->first();
        $currentTime = strtotime(date('h:i A'));
        $carbonDate = Carbon::parse(date('d-m-Y'));
        $currentDay = strtolower(date('l'));
        $tomorrowDay = strtolower($carbonDate->addDays(1)->format('l'));
        $dayaftertomorrowDay = strtolower($carbonDate->addDays(1)->format('l'));

        $firstOpenTime = strtotime($restaurant[$currentDay . '_first_opentime']);
        $firstCloseTime = strtotime($restaurant[$currentDay . '_first_closetime']);
        $secondOpenTime = strtotime($restaurant[$currentDay . '_second_opentime']);
        $secondCloseTime = strtotime($restaurant[$currentDay . '_second_closetime']);
        $Daystatus = isset($restaurant[$currentDay . '_status']) ? $restaurant[$currentDay . '_status'] : 'Close';

        $delivery_tomorrow_firstOpenTime = $restaurant[$tomorrowDay . '_first_opentime'];
        $delivery_tomorrow_firstCloseTime = $restaurant[$tomorrowDay . '_first_closetime'];
        $delivery_tomorrow_secondOpenTime = $restaurant[$tomorrowDay . '_second_opentime'];
        $delivery_tomorrow_secondCloseTime = $restaurant[$tomorrowDay . '_second_closetime'];
        $delivery_tomorrow_Daystatus = isset($restaurant[$currentDay . '_status']) ? $restaurant[$currentDay . '_status'] : 'Close';

        $delivery_after_firstOpenTime = $restaurant[$dayaftertomorrowDay . '_first_opentime'];
        $delivery_after_firstCloseTime = $restaurant[$dayaftertomorrowDay . '_first_closetime'];
        $delivery_after_secondOpenTime = $restaurant[$dayaftertomorrowDay . '_second_opentime'];
        $delivery_after_secondCloseTime = $restaurant[$dayaftertomorrowDay . '_second_closetime'];
        $delivery_after_Daystatus = isset($restaurant[$currentDay . '_status']) ? $restaurant[$currentDay . '_status'] : 'Close';

        if ($restaurant['restaurant_timing'] != null) {
            $pickfirstOpenTime = strtotime($restaurant['restaurant_timing']['pick_' . $currentDay . '_first_opentime']);
            $pickfirstCloseTime = strtotime($restaurant['restaurant_timing']['pick_' . $currentDay . '_first_closetime']);
            $picksecondOpenTime = strtotime($restaurant['restaurant_timing']['pick_' . $currentDay . '_second_opentime']);
            $picksecondCloseTime = strtotime($restaurant['restaurant_timing']['pick_' . $currentDay . '_second_closetime']);
            $pickstatus = $restaurant['restaurant_timing']['pick_' . $currentDay . '_status'];

            $pick_tomorrow_firstOpenTime = $restaurant['restaurant_timing']['pick_' . $tomorrowDay . '_first_opentime'];
            $pick_tomorrow_firstCloseTime = $restaurant['restaurant_timing']['pick_' . $tomorrowDay . '_first_closetime'];
            $pick_tomorrow_secondOpenTime = $restaurant['restaurant_timing']['pick_' . $tomorrowDay . '_second_opentime'];
            $pick_tomorrow_secondCloseTime = $restaurant['restaurant_timing']['pick_' . $tomorrowDay . '_second_closetime'];
            $pick_tomorrow_status = $restaurant['restaurant_timing']['pick_' . $tomorrowDay . '_status'];

            $pick_day_after_firstOpenTime = $restaurant['restaurant_timing']['pick_' . $dayaftertomorrowDay . '_first_opentime'];
            $pick_day_after_firstCloseTime = $restaurant['restaurant_timing']['pick_' . $dayaftertomorrowDay . '_first_closetime'];
            $pick_day_after_secondOpenTime = $restaurant['restaurant_timing']['pick_' . $dayaftertomorrowDay . '_second_opentime'];
            $pick_day_after_secondCloseTime = $restaurant['restaurant_timing']['pick_' . $dayaftertomorrowDay . '_second_closetime'];
            $pick_day_after_status = $restaurant['restaurant_timing']['pick_' . $dayaftertomorrowDay . '_status'];
        } else {
            $pickfirstOpenTime = strtotime('12:00 PM');
            $pickfirstCloseTime = strtotime('12:00 PM');
            $picksecondOpenTime = strtotime('12:00 PM');
            $picksecondCloseTime = strtotime('12:00 PM');
            $pickstatus = 'Close';

            $pick_tomorrow_firstOpenTime = '12:00 PM';
            $pick_tomorrow_firstCloseTime = '12:00 PM';
            $pick_tomorrow_secondOpenTime = '12:00 PM';
            $pick_tomorrow_secondCloseTime = '12:00 PM';
            $pick_tomorrow_status = 'Close';

            $pick_day_after_firstOpenTime = '12:00 PM';
            $pick_day_after_firstCloseTime = '12:00 PM';
            $pick_day_after_secondOpenTime = '12:00 PM';
            $pick_day_after_secondCloseTime = '12:00 PM';
            $pick_day_after_status = 'Close';
        }

        if ($Daystatus != 'Close' || $pickstatus != 'Close') {
            if (($currentTime > $firstOpenTime && $currentTime <= $firstCloseTime) || ($currentTime > $pickfirstOpenTime && $currentTime <= $pickfirstCloseTime)) {
                return 'Open';
            } else if (($currentTime > $secondOpenTime && $currentTime <= $secondCloseTime) || ($currentTime > $picksecondOpenTime && $currentTime <= $picksecondCloseTime)) {
                return 'Open';
            } else if (
                $delivery_tomorrow_Daystatus != 'Close' && $pick_tomorrow_status != 'Close' && (!($delivery_tomorrow_firstOpenTime == '12:00 PM' && $delivery_tomorrow_firstCloseTime == '12:00 PM') || !($pick_tomorrow_firstOpenTime == '12:00 PM' && $pick_tomorrow_firstCloseTime == '12:00 PM'))
            ) {
                return 'PreOrder';
            } else if (
                $delivery_tomorrow_Daystatus != 'Close' && $pick_tomorrow_status != 'Close' && (!($delivery_tomorrow_secondOpenTime == '12:00 PM' && $delivery_tomorrow_secondCloseTime == '12:00 PM')  || !($pick_tomorrow_secondOpenTime == '12:00 PM' && $pick_tomorrow_secondCloseTime == '12:00 PM'))
            ) {
                return 'PreOrder';
            } else if (
                $delivery_after_Daystatus != 'Close' && $pick_day_after_status != 'Close' && (!($delivery_after_firstOpenTime == '12:00 PM' && $delivery_after_firstCloseTime == '12:00 PM') || !($pick_day_after_firstOpenTime == '12:00 PM' && $pick_day_after_firstCloseTime == '12:00 PM'))
            ) {
                return 'PreOrder';
            } else if (
                $delivery_after_Daystatus != 'Close' && $pick_day_after_status != 'Close' && (!($delivery_after_secondOpenTime == '12:00 PM' && $delivery_after_secondCloseTime == '12:00 PM') || !($pick_day_after_secondOpenTime == '12:00 PM' && $pick_day_after_secondCloseTime == '12:00 PM'))
            ) {
                return 'PreOrder';
            } else {
                return 'Closed';
            }
        } else {
            return 'Closed';
        }
    }
    public function getBankDetailAttribute()
    {
        return $this->bank_detail();
    }
    public function bank_detail()
    {
        return TiffintomBankDetail::where('restaurant_id', $this->id)->first();
    }
    public function getBusinessAttribute()
    {
        return $this->business();
    }
    public function business()
    {
        $business =  Business::selectRaw('id,name,restaurant_id,connect_service')->where('restaurant_id', $this->id)->first();
        if (!empty($business)) {
            $mode = SiteSettingController::findByKey('connect_stripe_mode')->value;
            if ($mode == 'test') {
                $columns = 'connect_stripe_public_key_test';
            }
            if ($mode == 'live') {
                $columns = 'connect_stripe_public_key_live';
            }
            $business['connect_stripe_public_key'] = SiteSettingController::findByKey($columns)->value;
            $business->makeHidden(['business_commissions', 'country']);
            return $business;
        }
    }
    public function getDeliverySettingsAttribute()
    {
        return $this->delivery_settings();
    }
    public function delivery_settings()
    {
        return TiffintomDeliverySetting::where('restaurant_id', $this->id)->get();
    }
    public function getAreamapsAttribute()
    {
        return $this->areamaps();
    }
    public function areamaps()
    {
        return TiffintomAreaMap::where('res_id', $this->id)->get();
    }
    public function getDeliverySettingAttribute()
    {
        return $this->delivery_setting();
    }
    public function delivery_setting()
    {
        return TiffintomDeliverySetting::where('restaurant_id', $this->id)->orderBy('delivery_charge', 'ASC')->get();
    }
    public function getPaymentMethodsAttribute()
    {
        $paymentMethods = TiffintomRestaurantPaymentMethod::selectRaw("restaurant_payments.*,payment_methods.payment_method_name")->where('restaurant_id', $this->id)->leftJoin('payment_methods', 'payment_methods.id', '=', 'restaurant_payments.payment_id')->orderBy('payment_methods.id', 'ASC')->get();
        return $paymentMethods;
    }
    public function getSiteSettingAttribute()
    {
        $siteSetting = TiffintomSiteSetting::select('id', 'site_name', 'site_logo', 'site_fav', 'site_currency',  'assign_status', 'assign_miles', 'facebook_login', 'google_login', 'twitter_login', 'apple_login', 'banner_status', 'charity_message', 'charity_amount', 'android_version', 'ios_version', 'dine_in', 'show_offers', 'signup_verify', 'checkout_verify', 'booking_verify', 'order_verify', 'signup_verify_type', 'order_verify_type', 'booking_verify_type', 'wallet_available')->where('id', '1')->first();
        return $siteSetting;
    }
    public function getMetaTagAttribute()
    {
        $meta_tag = TiffintomMetaTag::where('restaurant_id', $this->id)->first();
        return $meta_tag;
    }
    public function getPromotionsAttribute()
    {
        $promotions = TiffintomPromotion::where('restaurant_id', $this->id)->get();
        return $promotions;
    }
    public function getOfferTextsAttribute()
    {
        $offer_texts = TiffintomOfferText::where('restaurant_id', $this->id)->where('status', '1')->where('delete_status', 'N')->get();
        return $offer_texts;
    }
}
