<?php

namespace App\ModelsTiffintom;

use App\Helpers\ImageHelper;
use Illuminate\Database\Eloquent\Model;

class TiffintomRestaurantRegistration extends Model
{
    protected $table = "restaurant_registration";
    protected $connection = "tiffintom_connection";
    protected $casts = [
        'status' => 'bool'
    ];
    protected $fillable = [
        'restaurant_name',
        'restaurant_address',
        'restaurant_city',
        'restaurant_postcode',
        'first_name',
        'surname',
        'email',
        'phone',
        'company_type',
        'restaurant_cuisine',
        'restaurant_dietary',
        'no_of_location',
        'deliver',
        'payment',
        'company_name',
        'company_first_address',
        'company_second_address',
        'company_city',
        'company_postcode',
        'menu_image',
        'logo',
        'ip_address',
        'status',
    ];
    protected $appends = ['logo_url', 'menu_image_url'];

    public $timestamps = false;

    // Attributes
    //
    public function getLogoUrlAttribute()
    {
        if (isset($this->logo)) {
            return ImageHelper::getServerImageUrl(ImageHelper::$TYPE_TIFFINTOM_BECOME, $this->logo, env('FTP_IMAGE_PATH_TIFFINTOM'));
        } else {
            return null;
        }
    }
    public function getMenuImageUrlAttribute()
    {
        if (isset($this->menu_image)) {
            return ImageHelper::getServerImageUrl(ImageHelper::$TYPE_TIFFINTOM_BECOME, $this->menu_image, env('FTP_IMAGE_PATH_TIFFINTOM'));
        } else {
            return null;
        }
    }
}
