<?php

namespace App\ModelsTiffintom;

use Illuminate\Database\Eloquent\Model;

class TiffintomShortlnUrl extends Model
{
    protected $table = "epos_shortn_url";
    protected $connection = "tiffintom_connection";
    protected $fillable = [
        'id',
        'name',
        'phone',
        'publishkey',
        'secretkey',
        'description',
        'descriptor',
        'amount',
        'device_id',
        'shortn',
        'status',
        'cancel',
        'expired',
        'qr',
        'order_id',
    ];
    protected $casts = [
        'cancel' => 'bool',
        'expired' => 'bool',
        'qr' => 'bool',
    ];
    protected $hidden = [];
    protected $appends = ['link'];
    const CREATED_AT = 'created';
    const UPDATED_AT = 'created';

    public function getLinkAttribute()
    {
        return $this->links();
    }
    // Attributes
    //
    public function links()
    {
        return env('APP_URL') . 'epos-payment?code=' . $this->shortn . '&';
    }
}
