<?php

namespace App\ModelsTiffintom;

use App\Helpers\ImageHelper;
use Carbon\Carbon;
use Illuminate\Database\Eloquent\Model;

class TiffintomSiteSetting extends Model
{
    protected $table = "sitesettings";
    protected $connection = "tiffintom_connection";
    protected $casts = [];
    protected $fillable = [];
    protected $appends = ['today', 'logo_image_url', 'favicon_image_url'];

    const CREATED_AT = 'created';
    const UPDATED_AT = 'updated';

    // Attributes
    //
    public function getTodayAttribute()
    {
        return Carbon::today()->getTimestamp();
    }
    public function getLogoImageUrlAttribute()
    {
        return ImageHelper::getServerThumbUrl(ImageHelper::$TYPE_TIFFINTOM_SITE_LOGO, $this->site_logo, env('FTP_IMAGE_PATH_TIFFINTOM'));
    }
    public function getFaviconImageUrlAttribute()
    {
        return ImageHelper::getServerThumbUrl(ImageHelper::$TYPE_TIFFINTOM_SITE_FAVICON, $this->site_fav, env('FTP_IMAGE_PATH_TIFFINTOM'));
    }
}
