<?php

namespace App\ModelsTiffintom;

use Illuminate\Database\Eloquent\Model;

class TiffintomState extends Model
{
    protected $table = "states";
    protected $connection = "tiffintom_connection";
    protected $fillable = [
        'id',
        'country_id',
        'state_name',
        'state_code',
        'status',
    ];
    protected $hidden = [];
    protected $appends = ['country'];
    protected $casts = [
        'status' => 'bool',
    ];
    const CREATED_AT = 'created';
    const UPDATED_AT = 'modified';

    // Attributes
    //
    public function getCountryAttribute()
    {
        return TiffintomCountry::where('id', $this->country_id)->first();
    }
}
