<?php

namespace App\ModelsTiffintom;

use Illuminate\Database\Eloquent\Model;

class TiffintomWalletHistory extends Model
{
    protected $table = "wallet_histories";
    protected $connection = "tiffintom_connection";
    protected $casts = [];
    protected $fillable = [
        'id',
        'customer_id',
        'purpose',
        'transaction_type',
        'transaction_details',
        'amount',
    ];
    const CREATED_AT = 'created';
    const UPDATED_AT = 'modified';

    protected $appends = ['store_name'];

    // Attributes
    //
    public function getStoreNameAttribute()
    {
        if ($this->transaction_type == 'Debited') {
            $order_no = explode("ORD00", $this->transaction_details);
            $order_no = implode("", $order_no);
            $orderDetail = TiffintomOrder::where('id', $order_no)->first();
            if (!empty($orderDetail)) {
                $restaurantDetail = TiffintomRestaurant::where('id', $orderDetail->restaurant_id)->first();
                return $restaurantDetail->restaurant_name;
            } else {
                return null;
            }
        } else {
            return null;
        }
    }
}
