<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Passbook extends Model
{
    protected $table = "passbook";
    protected $fillable = [
        'business_id',
        'user_id',
        'amount',
        'entity_id',
        'entity',
        'date',
        'from_date',
        'to_date',
        'description',
    ];
    protected $hidden = ['updated_at'];
    protected $appends = ['payout_invoice'];

    // Attributes
    //
    public function getPayoutInvoiceAttribute()
    {
        return $this->payout_invoice();
    }
    public function payout_invoice()
    {
        if ($this->entity_id) {
            return PayoutInvoice::where('id', $this->entity_id)->first();
            // return $payout_invoice->transaction_type;
        } else {
            return null;
        }
    }
}
