<?php

namespace App;

use App\ModelsConnect\ExternalAccount;
use Illuminate\Database\Eloquent\Model;

class PayoutRequest extends Model
{
    protected $fillable = [
        'business_id',
        'user_id',
        'amount',
        'status',
        'note',
        'rejection_note',
        'payout_id',
        'payout_status',
        'created',
        'arrival_date',
    ];
    protected $hidden = ['updated_at'];
    protected $appends = ['external_account'];

    public function getExternalAccountAttribute()
    {
        return $this->external_account();
    }
    // Attributes
    //
    public function external_account()
    {
        return ExternalAccount::where('s_bank_account_id', $this->bank_account_id)->first();
    }
}
