<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class PaypalDetail extends Model
{
    protected $fillable = ['name', 'email', 'business_id', 'user_id'];
    protected $hidden = ['updated_at'];
    protected $appends = ['is_default'];
    protected $casts = ['disabled' => 'bool'];

    // Attributes
    //
    public function getIsDefaultAttribute()
    {
        if ($this->business_id != null)
            $defaultPaypalDetail = Business::where('id', $this->business_id)->where('paypal_detail_id', $this->id)->first();
        else $defaultPaypalDetail = User::where('id', $this->user_id)->where('paypal_detail_id', $this->id)->first();
        return (!empty($defaultPaypalDetail));
    }
}
