<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Plan extends Model
{
    protected $fillable = [
        'name',
        'service',
        'permissions',
        'description',
    ];
    protected $hidden = ['updated_at'];
    protected $appends = ['business'];
    protected $casts = ['permissions' => 'json'];

    // Attributes
    //
    public function getBusinessAttribute()
    {
        return $this->business();
    }
    public function business()
    {
        return Business::selectRaw("businesses.*")->leftJoin('business_plans', 'business_plans.business_id', '=', 'businesses.id')->where('business_plans.plan_id', $this->id)->get();
    }
}
