<?php

namespace App;

use Illuminate\Database\Eloquent\Model;
use Illuminate\Support\Facades\Log;

class PouchHistory extends Model
{
    protected $table = "pouch_history";
    protected $fillable = [
        'business_id',
        'debit_amount',
        'credit_amount',
        'fee',
        'total_balance',
        'description',
        'transaction_category',
        'remark',
        'wallet_id',
        'device_type',
        'is_admin',
        'status',
        'updater_id',
    ];
    protected $hidden = ['updated_at', 'status_description', 'fee'];
    protected $appends = ['user_name', 'wallet_name'];
    protected $casts = [
        'is_admin' => 'bool',
        'debit_amount' => 'decimal:2',
        'credit_amount' => 'decimal:2',
        'total_balance' => 'decimal:2',
    ];

    // Attributes
    //
    public function getUserNameAttribute()
    {
        return $this->usersName();
    }
    public function getWalletNameAttribute()
    {
        return $this->walletsName();
    }

    public function usersName()
    {
        $name = null;
        if ($this->updater_id != '') {
            if ($this->is_admin == 1) {
                $user = Admin::where('id', $this->updater_id)->first();
                if (!empty($user)) $name = $user->name;
            } else {
                $user = User::where('id', $this->updater_id)->first();
                if (!empty($user)) $name = $user->first_name . ' ' . $user->last_name;
            }
        }
        return $name;
    }

    public function walletsName()
    {
        $name = null;
        if ($this->wallet_id != '') {
            $wallet = CaxtonWallet::where('wallet_id', $this->wallet_id)->first();
            if (!empty($wallet)) $name = $wallet->name;
        }
        return $name;
    }
}
