<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class ResellerPayoutInvoiceGroup extends Model
{
    protected $fillable = [
        'from_date',
        'to_date', 'user_id '
    ];
    protected $hidden = ['updated_at'];
    protected $appends = ['total_amount', 'total_paid_amount'];
    protected $casts = ['disabled' => 'bool'];

    // Attributes
    //
    public function getTotalAmountAttribute()
    {
        return ResellerPayoutInvoice::where('user_id', $this->user_id)->where('from_date', $this->from_date)->where('to_date', $this->to_date)->sum('net_fee');
    }
    public function getTotalPaidAmountAttribute()
    {
        return Passbook::where('user_id', $this->user_id)->where('entity', 'reseller_payout_invoice_group')->where('entity_id', $this->id)->whereRaw('amount != (SELECT SUM(net_fee) FROM reseller_payout_invoices WHERE user_id = ? AND from_date = ? AND to_date = ?)', [$this->user_id, $this->from_date, $this->to_date])->sum('amount');
    }
}
