<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class ResellerPayoutRequest extends Model
{
    protected $fillable = [
        'user_id',
        'amount',
        'status',
        'note',
        'rejection_note',
        'request_type',
        'bank_details_id',
        'accepted_at',
        'rejected_at',
    ];
    protected $hidden = ['updated_at'];
    protected $appends = [];
    protected $casts = [];

    public function bankDetails()
    {
        return $this->belongsTo(BankDetail::class, 'bank_details_id');
    }

    public function user()
    {
        return $this->belongsTo(User::class, 'user_id');
    }
}