<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class StandingInstruction extends Model
{
    protected $fillable = [
        'user_id',
        'beneficiary_id',
        'amount',
        'standing_type',
        'expiry_date',
        'order_date',
        'days',
        'notes',
        'disabled',
    ];
    protected $hidden = ['updated_at'];
    protected $appends = [];
    protected $casts = ['disabled' => 'bool'];

    // Attributes
    //

    public function getBeneficiaryNameAttribute()
    {
        $beneficiary = CaxtonBeneficiary::find($this->beneficiary_id);
        if (!empty($beneficiary)) {
            return $beneficiary->name;
        } else {
            return;
        }
    }
}
