<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class TicketMessage extends Model
{
    protected $fillable = [
        'ticket_id',
        'message',
        'admin',
        'close'
    ];
    protected $hidden = ['updated_at'];
    protected $appends = ['ticket'];
    protected $casts = ['close' => 'bool', 'admin' => 'bool'];

    // Attributes
    //
    public function getTicketAttribute()
    {
        return $this->tickets();
    }
    public function tickets()
    {
        return Ticket::where('id', $this->ticket_id)->first();
    }
}
