<?php

namespace App\Traits;

trait ResponseTrait
{
    public $success = 200;
    public $error = 500;
    public $response = ['status' => false, 'message' => '', 'data' => []];

    public function success($data = [], $message = '')
    {
        $this->response['status'] = true;
        $this->response['message'] = $message;
        $this->response['data'] = $data;
        return response()->json($this->response, $this->success);
    }

    public function error($data = [], $message = 'Something went wrong.')
    {
        $this->response['message'] = $message;
        $this->response['data'] = $data;
        return response()->json($this->response, $this->error);
    }
}
