<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class UserBusiness extends Model
{
    protected $fillable = ['business_id', 'user_id'];
    protected $hidden = ['updated_at'];
    protected $appends = ['reseller_commissions'];
    protected $casts = ['disabled' => 'bool'];

    // Attributes
    //
    public function getResellerCommissionsAttribute()
    {
        return $this->reseller_commissions();
    }
    public function reseller_commissions()
    {
        return ResellerCommission::where('business_id', $this->business_id)->where('user_id', $this->user_id)->latest()->first();
    }
}
