<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class UserContact extends Model
{
    protected $fillable = ['name', 'number', 'type', 'user_id', 'contact_group_ids'];
    protected $hidden = ['updated_at'];
    protected $appends = ['contact_groups'];

    // Attributes
    //
    public function getContactGroupsAttribute()
    {
        return $this->groups();
    }
    public function groups()
    {
        if ($this->contact_group_ids == null) {
            return null;
        }
        return ContactGroup::whereRaw("(id IN ($this->contact_group_ids))")->select(['id', 'name'])->get();
    }
}
