<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Schema;

class CreateTablesTable extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::create('tables', function (Blueprint $table) {
            $table->id();
            $table->string('number');
            $table->unsignedBigInteger('floor_id');
            $table->unsignedBigInteger('table_status_id');
            $table->unsignedBigInteger('updater_id')->nullable();

            $table->boolean('disabled')->default(0);
            $table->boolean('locked')->default(0);
            $table->boolean('hold')->default(0);
            $table->integer('sequence')->default(1);

            $table->timestamp('created_at')->default(DB::raw('CURRENT_TIMESTAMP'));
            $table->timestamp('updated_at')->default(DB::raw('CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP'));

            $table->foreign('floor_id')->references('id')->on('floors')->onDelete('restrict');
            $table->foreign('table_status_id')->references('id')->on('table_statuses')->onDelete('restrict');
            $table->foreign('updater_id')->references('id')->on('users')->onDelete('set null');
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::dropIfExists('tables');
    }
}
