<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Schema;

class CreateSettingsTable extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::create('settings', function (Blueprint $table) {
            $table->id();
            $table->string('name');
            $table->string('key')->unique();
            $table->longText('value');
            $table->longText('comment')->nullable();
            $table->longText('hint')->nullable();
            $table->string('setting_group')->nullable();
            $table->enum('data_type', ['string', 'enum', 'int', 'double', 'bool', 'json', 'text','json_array'])->default('string');
            $table->text('expected_values')->comment('Comma saperated values e.g for enum live,test ; For json_array it should be default array')->nullable();
            $table->integer('sequence')->default(0);
            $table->boolean('is_editable')->default(1);

            $table->timestamp('created_at')->default(DB::raw('CURRENT_TIMESTAMP'));
            $table->timestamp('updated_at')->default(DB::raw('CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP'));
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::dropIfExists('settings');
    }
}
