<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

class AddCollectionPreparationLocationIdToProductsTable extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::table('products', function (Blueprint $table) {

            $table->unsignedBigInteger('collection_preparation_location_id')->after("preparation_location_id")->nullable();
            $table->unsignedBigInteger('delivery_preparation_location_id')->after("collection_preparation_location_id")->nullable();
            $table->unsignedBigInteger('banquet_preparation_location_id')->after("delivery_preparation_location_id")->nullable();

            $table->foreign('collection_preparation_location_id')->references('id')->on('preparation_locations')->onDelete('set null');
            $table->foreign('delivery_preparation_location_id')->references('id')->on('preparation_locations')->onDelete('set null');
            $table->foreign('banquet_preparation_location_id')->references('id')->on('preparation_locations')->onDelete('set null');
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::table('products', function (Blueprint $table) {
            //
        });
    }
}
