<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

class AddParentIdToProductAddonsTable extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::table('product_addons', function (Blueprint $table) {
            $table->unsignedBigInteger('parent_id')->after('addon_id')->nullable();
            $table->foreign('parent_id')->references('id')->on('product_addons')->onDelete('cascade');
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::table('product_addons', function (Blueprint $table) {
            $table->dropColumn('parent_id');
        });
    }
}
