<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

class AddPayoutModesToBusinessesTable extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::table('businesses', function (Blueprint $table) {
            $table->enum('payout_mode', ['Auto', 'Manual'])->after('bank_detail_id')->default('Manual');
            $table->enum('payout_method', ['Bank', 'Paypal', 'Cash'])->after('payout_mode')->default('Cash');

            $table->enum('archived_payout_mode', ['Auto', 'Manual'])->after('payout_method')->default('Manual');
            $table->enum('archived_payout_method', ['Bank', 'Paypal', 'Cash'])->after('archived_payout_mode')->default('Cash');
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::table('businesses', function (Blueprint $table) {
            $table->drop('payout_mode');
            $table->drop('payout_method');
            $table->drop('archived_payout_mode');
            $table->drop('archived_payout_method');
        });
    }
}
