<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

class AddChargeBackFeeToBusinessCommissionsTable extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::table('business_commissions', function (Blueprint $table) {
            $table->enum('charge_back_fee_type', ['flat', 'percentage'])->after('card_charge')->default('percentage');
            $table->double('charge_back_fee')->after('charge_back_fee_type')->default(0);
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::table('business_commissions', function (Blueprint $table) {
            $table->drop('charge_back_fee_type');
            $table->drop('charge_back_fee');
        });
    }
}
