<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

class AddKeysToBusinessesTable extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::table('businesses', function (Blueprint $table) {
            $table->enum('paypal_mode', ['Live', 'Test'])->after('archived_payout_method')->default('Test');

            $table->longText('paypal_public_key_test')->after('paypal_mode')->nullable();
            $table->longText('paypal_private_key_test')->after('paypal_public_key_test')->nullable();

            $table->longText('paypal_public_key_live')->after('paypal_private_key_test')->nullable();
            $table->longText('paypal_private_key_live')->after('paypal_public_key_live')->nullable();

            $table->enum('stripe_mode', ['Live', 'Test'])->after('paypal_private_key_live')->default('Test');

            $table->longText('stripe_public_key_test')->after('stripe_mode')->nullable();
            $table->longText('stripe_private_key_test')->after('stripe_public_key_test')->nullable();

            $table->longText('stripe_public_key_live')->after('stripe_private_key_test')->nullable();
            $table->longText('stripe_private_key_live')->after('stripe_public_key_live')->nullable();
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::table('businesses', function (Blueprint $table) {
            $table->drop('paypal_mode');
            $table->drop('paypal_public_key_test');
            $table->drop('paypal_private_key_test');
            $table->drop('paypal_public_key_live');
            $table->drop('paypal_private_key_live');
            $table->drop('stripe_mode');
            $table->drop('stripe_public_key_test');
            $table->drop('stripe_private_key_test');
            $table->drop('stripe_public_key_live');
            $table->drop('stripe_private_key_live');
        });
    }
}
