<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

class AddPayoutToUsersTable extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::table('users', function (Blueprint $table) {
            $table->enum('payout_comment', ['Auto', 'Manual'])->after('reseller')->default('Manual');

            $table->enum('payout_mode', ['Auto', 'Manual'])->after('payout_comment')->default('Manual');
            $table->enum('payout_method', ['Bank', 'Paypal', 'Cash'])->after('payout_mode')->default('Cash');

            $table->enum('archived_payout_mode', ['Auto', 'Manual'])->after('payout_method')->default('Manual');
            $table->enum('archived_payout_method', ['Bank', 'Paypal', 'Cash'])->after('archived_payout_mode')->default('Cash');

            $table->unsignedBigInteger('bank_detail_id')->after('archived_payout_method')->nullable();
            $table->unsignedBigInteger('paypal_detail_id')->after('bank_detail_id')->nullable();

            $table->foreign('bank_detail_id')->references('id')->on('bank_details')->onDelete('set null');
            $table->foreign('paypal_detail_id')->references('id')->on('paypal_details')->onDelete('set null');
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::table('users', function (Blueprint $table) {
            //
        });
    }
}
