<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

class AddRecurringChargesToBusinessCommissionsTable extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::table('business_commissions', function (Blueprint $table) {
            $table->enum('weekly_fee_type', ['flat', 'percentage'])->default('percentage')->after('charge_back_fee');
            $table->double('weekly_fee')->default(0)->after('weekly_fee_type');
            $table->enum('monthly_fee_type', ['flat', 'percentage'])->default('percentage')->after('weekly_fee');
            $table->double('monthly_fee')->default(0)->after('monthly_fee_type');
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::table('business_commissions', function (Blueprint $table) {
            $table->drop('weekly_fee_type');
            $table->drop('weekly_fee');
            $table->drop('monthly_fee_type');
            $table->drop('monthly_fee');
        });
    }
}
