<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Schema;

class CreateBusinessPermissionsTable extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::create('business_permissions', function (Blueprint $table) {
            $table->id();
            $table->unsignedBigInteger('business_id');
            $table->enum('role', ['user', 'admin', 'supervisor'])->default('admin');
            $table->boolean('payworks')->default(0);
            $table->boolean('tips')->default(0);
            $table->boolean('archive')->default(0);
            $table->boolean('archive_list')->default(0);
            $table->boolean('moto_service')->default(0);
            $table->boolean('transaction_list')->default(0);
            $table->boolean('print')->default(0);
            $table->boolean('refund')->default(0);
            $table->boolean('refund_list')->default(0);

            $table->timestamp('created_at')->default(DB::raw('CURRENT_TIMESTAMP'));
            $table->timestamp('updated_at')->default(DB::raw('CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP'));

            $table->foreign('business_id')->references('id')->on('businesses')->onDelete('cascade');
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::dropIfExists('business_permissions');
    }
}
