<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

class AddDbDetailsToBusinessesTable extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::table('businesses', function (Blueprint $table) {
            $table->boolean('epos_service')->default(0)->after('merchant_service');
            $table->string('db_name')->nullable()->after('epos_service');
            $table->unsignedBigInteger('database_server_id')->nullable()->after('db_name');

            $table->foreign('database_server_id')->references('id')->on('database_servers')->onDelete('set null');
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::table('businesses', function (Blueprint $table) {
            //
        });
    }
}
