<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

class AddConnectChargesToStripeTransactionsTable extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::table('stripe_transactions', function (Blueprint $table) {
            $table->enum('connect_card_processing_fee_type', ['flat', 'percentage'])->default('percentage')->after('management_fee');
            $table->double('connect_card_processing_fee')->default(0)->after('connect_card_processing_fee_type');

            $table->enum('connect_card_auth_fee_type', ['flat', 'percentage'])->default('percentage')->after('connect_card_processing_fee');
            $table->double('connect_card_auth_fee')->default(0)->after('connect_card_auth_fee_type');
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::table('stripe_transactions', function (Blueprint $table) {
            //
        });
    }
}
