<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

class AddOtherChargesToResellerPayoutInvoicesTable extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::table('reseller_payout_invoices', function (Blueprint $table) {
            $table->double('handling_fee')->default(0)->after('gross_fee');
            $table->double('management_fee')->default(0)->after('handling_fee');
            $table->double('payout_charge')->default(0)->after('management_fee');
            $table->double('weekly_fee')->default(0)->after('misc_charge');
            $table->double('monthly_fee')->default(0)->after('weekly_fee');
            $table->double('total_service_charge')->default(0)->after('total_non_domestic_transactions');
            $table->integer('total_refund_transactions')->default(0)->after('total_non_domestic_transactions');
            $table->json('payout_invoice_raw')->nullable()->after('payout_account');
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::table('reseller_payout_invoices', function (Blueprint $table) {
            //
        });
    }
}
