<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Schema;

class AddInternetConnectivityToBusinessCardReadersTable extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::table('business_card_readers', function (Blueprint $table) {
            DB::statement("ALTER TABLE business_card_readers MODIFY connectivity ENUM('Bluetooth', 'Wifi', 'Internet') NOT NULL");
            $table->string('s_terminal_id')->nullable()->after('merchant_secret');
            $table->string('s_location_id')->nullable()->after('s_terminal_id');
            $table->string('s_registration_code')->nullable()->after('s_location_id');
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::table('business_card_readers', function (Blueprint $table) {
            //
        });
    }
}
