<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

class AddSBankAccountIdToExternalAccountsTable extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::table('external_accounts', function (Blueprint $table) {
            $table->string('s_bank_account_id')->after('s_account_id')->nullable();
            $table->unsignedBigInteger('business_id')->after('s_bank_account_id')->nullable();

            $table->foreign('business_id')->references('id')->on('businesses')->onDelete('cascade');
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::table('external_accounts', function (Blueprint $table) {
            //
        });
    }
}
