<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Schema;

class CreatePlanProductsTable extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::create('plan_products', function (Blueprint $table) {

            $table->bigIncrements('id');
            $table->string('name');
            $table->string('description')->nullable();
            $table->enum('service_type', ['Epos', 'Merchant', 'Online', 'Connect', 'Card'])->nullable();
            $table->boolean('price_available')->default(1);
            $table->decimal('price', 10, 2)->default(0);
            $table->enum('recurring_type', ['Daily', 'Weekly', 'Monthly', 'Quarterly', 'Half Yearly', 'Yearly'])->nullable();
            $table->boolean('recurring_available')->default(1);
            $table->decimal('recurring_price', 10, 2)->default(0);
            $table->integer('quantity');
            $table->integer('discount');
            $table->boolean('disabled')->default(0);

            $table->timestamp('created_at')->default(DB::raw('CURRENT_TIMESTAMP'));
            $table->timestamp('updated_at')->default(DB::raw('CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP'));
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::dropIfExists('plan_products');
    }
}
