<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Schema;

class CreateTicketsTable extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::create('tickets', function (Blueprint $table) {
            $table->bigIncrements('id');
            $table->string('ticket_number')->nullable();
            $table->longText('name')->nullable();
            $table->longText('email')->nullable();
            $table->longText('phone_number')->nullable();
            $table->longText('subject')->nullable();
            $table->longText('message')->nullable();
            $table->string('otp')->nullable();
            $table->enum('status', ['Pending', 'Progress', 'Issue', 'Solved'])->default('Pending');
            $table->boolean('verified')->default(0);
            $table->boolean('disabled')->default(0);

            $table->timestamp('created_at')->default(DB::raw('CURRENT_TIMESTAMP'));
            $table->timestamp('updated_at')->default(DB::raw('CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP'));
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::dropIfExists('tickets');
    }
}
