<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

class AddOnlineOrderLimitToBusinessesTable extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::table('businesses', function (Blueprint $table) {
            $table->integer('online_order_limit')->default(0)->after('restaurant_name');
            $table->enum('auto_accept_order', ['no', 'yes'])->default('no')->after('online_order_limit');
            $table->enum('auto_accept_reservation', ['no', 'yes'])->default('no')->after('auto_accept_order');
            $table->longText('auto_accept_fields')->nullable()->after('auto_accept_reservation');
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::table('businesses', function (Blueprint $table) {
            //
        });
    }
}
