<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Schema;

class CreateCaxtonCardsTable extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::create('caxton_cards', function (Blueprint $table) {
            $table->bigIncrements('id');
            $table->string('wallet_id')->nullable();
            $table->string('card_id')->nullable();
            $table->string('card_holder_name')->nullable();
            $table->string('expiry')->nullable();
            $table->string('card_number')->nullable();
            $table->string('email')->nullable();
            $table->string('mobile_number')->nullable();
            $table->date('dob')->nullable();
            $table->enum('gender', ['Male', 'Female', 'Other'])->default('Male');
            $table->string('masked_pan')->nullable();
            $table->string('sequence_number')->nullable();
            $table->boolean('is_renewed')->default(0);
            $table->boolean('can_be_renewed')->default(0);
            $table->boolean('reissue_blocked')->default(0);
            $table->boolean('reissue_failure')->default(0);
            $table->boolean('is_expired')->default(0);
            $table->string('date_issued')->nullable();
            $table->boolean('is_expiring')->default(0);
            $table->boolean('is_blocked_by_client')->default(0);
            $table->boolean('is_contactless')->default(0);
            $table->string('pan_type_code')->nullable();
            $table->string('base_pan_type_code')->nullable();
            $table->boolean('is_primary_pan')->default(0);
            $table->string('gps_token')->nullable();

            $table->timestamp('created_at')->default(DB::raw('CURRENT_TIMESTAMP'));
            $table->timestamp('updated_at')->default(DB::raw('CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP'));
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::dropIfExists('caxton_cards');
    }
}
