<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Schema;

class CreateCaxtonWalletTransactionsTable extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::create('caxton_wallet_transactions', function (Blueprint $table) {
            $table->bigIncrements('id');
            $table->string('wallet_id');
            $table->string('card_id');
            $table->string('description');
            $table->decimal('debit_amount', 10, 2)->default(0);
            $table->string('debit_currency')->nullable();
            $table->string('debit_currency_symbol')->nullable();
            $table->decimal('credit_amount', 10, 2)->default(0);
            $table->string('credit_currency')->nullable();
            $table->string('credit_currency_symbol')->nullable();
            $table->string('transaction_category')->nullable();
            $table->string('transaction_type')->nullable();
            $table->string('transaction_type_desc')->nullable();
            $table->string('transaction_date')->nullable();
            $table->boolean('is_authorisation')->default(0);
            $table->boolean('is_transaction')->default(0);
            $table->boolean('is_balance_adjustment')->default(0);
            $table->string('pan_reference_number')->nullable();
            $table->decimal('exchange_rate', 10, 2)->default(0);
            $table->decimal('transaction_amount', 10, 2)->default(0);
            $table->string('transaction_currency')->nullable();
            $table->string('transaction_currency_symbol')->nullable();
            $table->string('valitor_transaction_id')->nullable();
            $table->string('merchant_name')->nullable();
            $table->string('merchant_city')->nullable();
            $table->string('merchant_country')->nullable();
            $table->boolean('is_loyalty_point')->default(0);
            $table->string('authorization_number')->nullable();
            $table->string('card_token_id')->nullable();
            $table->boolean('is_fee')->default(0);
            $table->boolean('is_wallet_alignment')->default(0);

            $table->timestamp('created_at')->default(DB::raw('CURRENT_TIMESTAMP'));
            $table->timestamp('updated_at')->default(DB::raw('CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP'));
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::dropIfExists('caxton_wallet_transactions');
    }
}
