<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Schema;

class CreateCaxtonBeneficiariesTable extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::create('caxton_beneficiaries', function (Blueprint $table) {
            $table->bigIncrements('id');
            $table->string('beneficiary_id')->nullable();
            $table->string('name')->nullable();
            $table->string('bank_name')->nullable();
            $table->string('reference')->nullable();
            $table->string('address1')->nullable();
            $table->string('address2')->nullable();
            $table->string('email')->nullable();
            $table->string('phone')->nullable();
            $table->string('country')->nullable();
            $table->string('currency')->nullable();
            $table->string('iban')->nullable();
            $table->string('swift')->nullable();
            $table->string('sortCode')->nullable();
            $table->string('account_number')->nullable();

            $table->timestamp('created_at')->default(DB::raw('CURRENT_TIMESTAMP'));
            $table->timestamp('updated_at')->default(DB::raw('CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP'));
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::dropIfExists('caxton_beneficiaries');
    }
}
