<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Schema;

class CreateCaxtonTransfersTable extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::create('caxton_transfers', function (Blueprint $table) {
            $table->bigIncrements('id');
            $table->string('pending_transfer_id')->nullable();
            $table->string('transfer_id')->nullable();
            $table->string('beneficiary_id')->nullable();
            $table->string('user_id')->nullable();
            $table->string('buy_ccy_Code')->nullable();
            $table->decimal('buy_amount', 10, 2)->default(0);
            $table->boolean('complete')->default(1);
            $table->boolean('automatic')->default(1);
            $table->string('executed')->nullable();
            $table->string('pay_away')->nullable();
            $table->string('pay_status')->nullable();
            $table->string('account_transaction_id')->nullable();
            $table->string('cash_available')->nullable();
            $table->string('authorisation')->nullable();
            $table->string('authorisation_status')->nullable();
            $table->string('payment_accepted')->nullable();
            $table->string('rejection_reason')->nullable();
            $table->string('payment_reference')->nullable();
            $table->boolean('is_pending')->default(1);
            $table->string('created')->nullable();
            $table->string('payment_provider')->nullable();
            $table->string('compliance_status')->nullable();
            $table->string('eye_check_status')->nullable();
            $table->string('compliance_status_desc')->nullable();
            $table->boolean('is_high_risk_transfer')->default(1);
            $table->string('fee_currency')->nullable();
            $table->string('fee')->nullable();
            $table->string('external_source_id')->nullable();
            $table->string('beneficiary_name')->nullable();

            $table->timestamp('created_at')->default(DB::raw('CURRENT_TIMESTAMP'));
            $table->timestamp('updated_at')->default(DB::raw('CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP'));
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::dropIfExists('caxton_transfers');
    }
}
