<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

class AddMobileNumberToAdminsTable extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::table('admins', function (Blueprint $table) {
            $table->string("email")->after("name")->nullable();
            $table->string("mobile_number")->after("username")->unique()->nullable();
            $table->string("login_otp")->after("disabled")->nullable();
            $table->string("auth_secret")->after("login_otp")->nullable();
            $table->boolean("logged_in")->after("auth_secret")->nullable();
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::table('admins', function (Blueprint $table) {
            $table->dropIfExists("email");
            $table->dropIfExists("mobile_number");
            $table->dropIfExists("login_otp");
            $table->dropIfExists("auth_secret");
            $table->dropIfExists("logged_in");
        });
    }
}
