<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

class AddAllow3rdPartyUseFieldInUsersTable extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::table('users', function (Blueprint $table) {
            $table->boolean("allow_3rd_party_use")->default(0)->after("commission")->comment("0: No, 1: Yes");
            $table->string("secret_key")->nullable()->after("allow_3rd_party_use")->comment("Secret key for 3rd party use");
            $table->string("initial_vector")->nullable()->after("secret_key")->comment("Initial vector for 3rd party use");
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::table('users', function (Blueprint $table) {
            $table->dropColumn("allow_3rd_party_use");
            $table->dropColumn("secret_key");
            $table->dropColumn("initial_vector");
        });
    }
}
