<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Schema;

class CreateInvoicePayLinksTable extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::create('invoice_pay_links', function (Blueprint $table) {
            $table->id();
            $table->unsignedBigInteger('invoice_id')->nullable();
            $table->longText('name')->nullable();
            $table->longText('email')->nullable();
            $table->longText('mobile_number')->nullable();
            $table->string('publishkey')->nullable();
            $table->string('secretkey')->nullable();
            $table->string('description')->nullable();
            $table->string('descriptor')->nullable();
            $table->decimal('amount', 10, 2)->default(0);
            $table->string('shortn')->nullable();
            $table->string('payment_id')->nullable();
            $table->enum('status', ['Pending', 'Success', 'Failed'])->default('Pending');

            $table->timestamp('created_at')->default(DB::raw('CURRENT_TIMESTAMP'));
            $table->timestamp('updated_at')->default(DB::raw('CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP'));

            $table->foreign('invoice_id')->references('id')->on('invoices')->onDelete('cascade');
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::dropIfExists('invoice_pay_links');
    }
}
