<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Schema;

class CreateCaxtonTransactionsTable extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::create('caxton_transactions', function (Blueprint $table) {
            $table->bigIncrements('id');
            $table->string('transactions_id')->nullable();
            $table->string('beneficiary_id')->nullable();
            $table->string('user_id')->nullable();
            $table->string('buy_ccy_code')->nullable();
            $table->string('buy_amount')->nullable();
            $table->string('executed_date')->nullable();
            $table->string('pay_away_date')->nullable();
            $table->string('pay_status')->nullable();
            $table->string('account_transation_id')->nullable();
            $table->string('payment_reference')->nullable();
            $table->string('created_date')->nullable();
            $table->string('payment_provider')->nullable();
            $table->string('compliance_status_desc')->nullable();
            $table->string('beneficiary_name')->nullable();

            $table->timestamp('created_at')->default(DB::raw('CURRENT_TIMESTAMP'));
            $table->timestamp('updated_at')->default(DB::raw('CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP'));
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::dropIfExists('caxton_transactions');
    }
}
