<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

class CreateAamarpayTransactionsTable extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::create('aamarpay_transactions', function (Blueprint $table) {
                $table->bigIncrements('id');
                $table->unsignedBigInteger('business_id')->nullable();
                $table->string('txn_id')->unique();
                $table->string('merchant_id')->nullable();
                $table->longText('description')->nullable();
                $table->integer('amount')->default(0);
                $table->string('currency')->nullable();
                $table->string('currency_merchant')->nullable();
                $table->string('status');
                $table->string('type');
                $table->string('card_type')->nullable();
                $table->string('created');
    
                $table->double('merchant_card_processing_fee')->default(0);
                $table->double('merchant_card_processing_ratio')->nullable();
                $table->enum('charges_refundable', ['no', 'yes'])->default('no');
    
                $table->timestamp('created_at')->default(DB::raw('CURRENT_TIMESTAMP'));
                $table->timestamp('updated_at')->default(DB::raw('CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP'));
                $table->foreign('business_id')->references('id')->on('businesses')->onDelete('set NULL');
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::dropIfExists('aamarpay_transactions');
    }
}
