<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Schema;

class CreateConnectAccountsTable extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::create('connect_accounts', function (Blueprint $table) {
            $table->id();
            $table->string('s_account_id')->nullable();
            $table->unsignedBigInteger('business_id');
            $table->string('account_type')->default('custom');
            $table->enum('business_type', ['company', 'individual', 'non_profit', 'government_entity'])->default('individual');

            $table->string('tos_ip');
            $table->string('tos_date');
            $table->string('country');
            $table->longText('public_key')->nullable();
            $table->longText('private_key')->nullable();

            $table->timestamp('created_at')->default(DB::raw('CURRENT_TIMESTAMP'));
            $table->timestamp('updated_at')->default(DB::raw('CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP'));

            $table->foreign('business_id')->references('id')->on('businesses')->onDelete('cascade');
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::dropIfExists('connect_accounts');
    }
}
