<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Schema;

class CreateCompaniesTable extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::create('companies', function (Blueprint $table) {
            $table->id();
            $table->string('s_account_id')->nullable();
            $table->unsignedBigInteger('connect_account_id');
            $table->enum('structure', ['multi_member_llc', 'private_corporation', 'private_partnership', 'public_corporation', 'public_partnership', 'single_member_llc', 'sole_proprietorship', 'unincorporated_association'])->nullable();
            $table->string('name');
            $table->string('email');
            $table->string('url');
            $table->string('mcc');
            $table->string('tax_id')->nullable();
            $table->string('phone_number')->nullable();

            $table->string('line1');
            $table->string('line2')->nullable();
            $table->string('city');
            $table->string('state')->nullable();
            $table->string('postal_code');

            $table->timestamp('created_at')->default(DB::raw('CURRENT_TIMESTAMP'));
            $table->timestamp('updated_at')->default(DB::raw('CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP'));

            $table->foreign('connect_account_id')->references('id')->on('connect_accounts')->onDelete('cascade');
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::dropIfExists('companies');
    }
}
