<?php

namespace Database\Seeders;

use App\ModelsEpos\EposOrderStatus;
use Illuminate\Database\Seeder;

class OrderStatusSeeder extends Seeder
{
    /**
     * Run the database seeds.
     *
     * @return void
     */
    public function run()
    {
        $items = [
            ['id' => 1, 'status' => 'Taking Order', 'top_color' => '#a1a1a1', 'bottom_color' => '#818181'],
            ['id' => 2, 'status' => 'Order Taken', 'top_color' => '#ffb239', 'bottom_color' => '#f69600'],
            ['id' => 3, 'status' => 'Order Served', 'top_color' => '#d44949', 'bottom_color' => '#c11313'],
            ['id' => 4, 'status' => 'Order Paid', 'top_color' => '#49d470', 'bottom_color' => '#13c144'],
            ['id' => 5, 'status' => 'Order Completed', 'top_color' => '#000000', 'bottom_color' => '#000000'],
            ['id' => 6, 'status' => 'Order In Transit', 'top_color' => '#000000', 'bottom_color' => '#000000'],
            ['id' => 7, 'status' => 'Part Payment Received', 'top_color' => '#000000', 'bottom_color' => '#000000'],
            ['id' => 8, 'status' => 'Complimentary Sale', 'top_color' => '#000000', 'bottom_color' => '#000000'],
            ['id' => 9, 'status' => 'Order Delivered', 'top_color' => '#000000', 'bottom_color' => '#000000'],
            ['id' => 10, 'status' => 'Order Rejected', 'top_color' => '#000000', 'bottom_color' => '#000000'],
            ['id' => 11, 'status' => 'Order Failed', 'top_color' => '#000000', 'bottom_color' => '#000000'],
            ['id' => 12, 'status' => 'Kitchen In Progress', 'top_color' => '#000000', 'bottom_color' => '#000000'],
            ['id' => 13, 'status' => 'Kitchen Overdue', 'top_color' => '#000000', 'bottom_color' => '#000000'],
            ['id' => 14, 'status' => 'Kitchen Ready', 'top_color' => '#000000', 'bottom_color' => '#000000'],
            ['id' => 15, 'status' => 'Web Order Unpaid', 'top_color' => '#000000', 'bottom_color' => '#000000'],
            ['id' => 16, 'status' => 'Web Order Cancelled', 'top_color' => '#000000', 'bottom_color' => '#000000'],
            ['id' => 17, 'status' => 'Web Order Refunded', 'top_color' => '#000000', 'bottom_color' => '#000000'],
            ['id' => 18, 'status' => 'Web Order Accepted', 'top_color' => '#000000', 'bottom_color' => '#000000'],
            ['id' => 19, 'status' => 'Ready To Collect', 'top_color' => '#000000', 'bottom_color' => '#000000'],
            ['id' => 20, 'status' => 'On The Way', 'top_color' => '#000000', 'bottom_color' => '#000000'],
        ];
        foreach ($items as $item) {
            EposOrderStatus::updateOrCreate(['id' => $item['id']], $item);
        }
    }
}
