<?php

namespace Database\Seeders;

use App\ModelsEpos\EposSetting;
use Illuminate\Database\Seeder;

class SettingSeeder extends Seeder
{
    /**
     * Run the database seeds.
     *
     * @return void
     */
    public function run()
    {
        $items = [
            ['id' => 1, 'name' => 'Restaurant Full name', 'key' => 'restaurant_full_name', 'value' => '', 'comment' => 'restaurant Full name', 'hint' => 'restaurant Full name', 'data_type' => 'string', 'expected_values' => '', 'setting_group' => 'business_settings', 'disabled' => true],
            ['id' => 2, 'name' => 'Restaurant Short name', 'key' => 'restaurant_short_name', 'value' => '', 'comment' => 'restaurant Short name', 'hint' => 'restaurant Short name', 'data_type' => 'string', 'expected_values' => '', 'setting_group' => 'business_settings', 'disabled' => true],
            ['id' => 3, 'name' => 'Restaurant City', 'key' => 'restaurant_city', 'value' => '', 'comment' => 'restaurant City', 'hint' => 'restaurant City', 'data_type' => 'string', 'expected_values' => '', 'setting_group' => 'business_settings', 'disabled' => true],
            ['id' => 4, 'name' => 'Restaurant Company', 'key' => 'restaurant_company', 'value' => '', 'comment' => 'restaurant Company', 'hint' => 'restaurant Company', 'data_type' => 'string', 'expected_values' => '', 'setting_group' => 'business_settings', 'disabled' => true],
            ['id' => 5, 'name' => 'Restaurant Country', 'key' => 'restaurant_country', 'value' => '', 'comment' => 'restaurant Country', 'hint' => 'restaurant Country', 'data_type' => 'string', 'expected_values' => '', 'setting_group' => 'business_settings', 'disabled' => true],
            ['id' => 6, 'name' => 'Restaurant Email', 'key' => 'restaurant_email', 'value' => '', 'comment' => 'restaurant Email', 'hint' => 'restaurant Email', 'data_type' => 'string', 'expected_values' => '', 'setting_group' => 'business_settings', 'disabled' => true],
            ['id' => 7, 'name' => 'Restaurant Postcode', 'key' => 'restaurant_postcode', 'value' => 'ws13rb', 'comment' => 'restaurant Postcode', 'hint' => 'restaurant Postcode', 'data_type' => 'string', 'expected_values' => '', 'setting_group' => 'business_settings', 'disabled' => true],
            ['id' => 8, 'name' => 'Restaurant Street', 'key' => 'restaurant_street', 'value' => '', 'comment' => 'restaurant Street', 'hint' => 'restaurant Street', 'data_type' => 'string', 'expected_values' => '', 'setting_group' => 'business_settings', 'disabled' => true],
            ['id' => 9, 'name' => 'Restaurant Telephone', 'key' => 'restaurant_telephone', 'value' => '', 'comment' => 'restaurant Telephone', 'hint' => 'restaurant Telephone', 'data_type' => 'string', 'expected_values' => '', 'setting_group' => 'business_settings', 'disabled' => true],
            ['id' => 10, 'name' => 'Restaurant Town', 'key' => 'restaurant_town', 'value' => '', 'comment' => 'restaurant Town', 'hint' => 'restaurant Town', 'data_type' => 'string', 'expected_values' => '', 'setting_group' => 'business_settings', 'disabled' => true],
            ['id' => 11, 'name' => 'Restaurant website', 'key' => 'restaurant_website', 'value' => '', 'comment' => 'restaurant website', 'hint' => 'restaurant website', 'data_type' => 'string', 'expected_values' => '', 'setting_group' => 'business_settings', 'disabled' => true],
            ['id' => 12, 'name' => 'Logo', 'key' => 'logo', 'value' => '', 'comment' => 'logo', 'hint' => 'logo', 'data_type' => 'string', 'expected_values' => '', 'setting_group' => 'business_settings', 'disabled' => false],
            ['id' => 13, 'name' => 'Service charge', 'key' => 'service_charge', 'value' => '0', 'comment' => 'restaurant service charge', 'hint' => 'restaurant service charge', 'data_type' => 'int', 'expected_values' => '', 'setting_group' => 'business_settings', 'disabled' => false],
            ['id' => 14, 'name' => 'Address', 'key' => 'address', 'value' => '', 'comment' => 'Business Addresss', 'hint' => 'Business Address', 'data_type' => 'string', 'expected_values' => '', 'setting_group' => 'business_settings', 'disabled' => false],
            ['id' => 15, 'name' => 'Address Latitude', 'key' => 'address_latitude', 'value' => '', 'comment' => 'Address Latitude', 'hint' => 'Address Latitude', 'data_type' => 'string', 'expected_values' => '', 'setting_group' => 'business_settings', 'disabled' => false],
            ['id' => 16, 'name' => 'Address Longitude', 'key' => 'address_longitude', 'value' => '', 'comment' => 'Address Longitude', 'hint' => 'Address Longitude', 'data_type' => 'int', 'expected_values' => '', 'setting_group' => 'business_settings', 'disabled' => false],
            ['id' => 20, 'name' => 'Web Restaturant id', 'key' => 'res_id', 'value' => '', 'comment' => 'Web Restaturant id', 'hint' => 'Web Restaturant id', 'data_type' => 'int', 'expected_values' => '', 'is_editable' => '0', 'setting_group' => 'business_settings', 'disabled' => false],
            ['id' => 21, 'name' => 'Business Morning Start Time', 'key' => 'business_morning_start_time', 'value' => '', 'comment' => 'Business Morning Start Time', 'hint' => 'Business Morning Start Time', 'data_type' => 'string', 'expected_values' => '', 'setting_group' => 'business_settings', 'disabled' => true],
            ['id' => 22, 'name' => 'Business Morning End Time', 'key' => 'business_morning_end_time', 'value' => '', 'comment' => 'Business Morning End Time', 'hint' => 'Business Morning End Time', 'data_type' => 'string', 'expected_values' => '', 'setting_group' => 'business_settings', 'disabled' => true],
            ['id' => 23, 'name' => 'Business Evening Start Time', 'key' => 'business_evening_start_time', 'value' => '', 'comment' => 'Business Evening Start Time', 'hint' => 'Business Evening Start Time', 'data_type' => 'string', 'expected_values' => '', 'setting_group' => 'business_settings', 'disabled' => true],
            ['id' => 24, 'name' => 'Business Evening End Time', 'key' => 'business_evening_end_time', 'value' => '', 'comment' => 'Business Evening End Time', 'hint' => 'Business Evening End Time', 'data_type' => 'string', 'expected_values' => '', 'setting_group' => 'business_settings', 'disabled' => true],
            ['id' => 25, 'name' => 'Reservation Start Time', 'key' => 'reservation_start_time', 'value' => '', 'comment' => 'Reservation Start Time', 'hint' => 'Reservation Start Time', 'data_type' => 'string', 'expected_values' => '', 'setting_group' => 'business_settings', 'disabled' => false],
            ['id' => 26, 'name' => 'Reservation End Time', 'key' => 'reservation_end_time', 'value' => '', 'comment' => 'Reservation End Time', 'hint' => 'Reservation End Time', 'data_type' => 'string', 'expected_values' => '', 'setting_group' => 'business_settings', 'disabled' => false],
            ['id' => 27, 'name' => 'Product Background Type', 'key' => 'product_background_type', 'value' => 'half', 'comment' => 'Product Background Type', 'hint' => 'Product Background Type', 'data_type' => 'enum', 'expected_values' => 'half,full', 'setting_group' => 'business_settings', 'disabled' => true],
            ['id' => 30, 'name' => 'Delivery Start Time', 'key' => 'delivery_start_time', 'value' => '', 'comment' => 'Delivery Start Time', 'hint' => 'Delivery Start Time', 'data_type' => 'string', 'expected_values' => '', 'setting_group' => 'business_settings', 'disabled' => true],
            ['id' => 31, 'name' => 'Approximate Dining Hours', 'key' => 'approximate_dining_hours', 'value' => '', 'comment' => 'Approximate Dining Hours', 'hint' => 'Approximate Dining Hours', 'data_type' => 'string', 'expected_values' => '', 'setting_group' => 'business_settings', 'disabled' => true],
            ['id' => 32, 'name' => 'Dinein is Visible', 'key' => 'is_dinein', 'value' => 'true', 'comment' => 'Dinein is Visible', 'hint' => 'Dinein is Visible', 'data_type' => 'bool', 'expected_values' => '', 'is_editable' => '0', 'setting_group' => 'business_settings', 'disabled' => true],
            ['id' => 33, 'name' => 'Bar is Visible', 'key' => 'is_bar', 'value' => 'true', 'comment' => 'Bar is Visible', 'hint' => 'Bar is Visible', 'data_type' => 'bool', 'expected_values' => '', 'is_editable' => '0', 'setting_group' => 'business_settings', 'disabled' => true],
            ['id' => 34, 'name' => 'Delivery is Visible', 'key' => 'is_delivery', 'value' => 'true', 'comment' => 'Delivery is Visible', 'hint' => 'Delivery is Visible', 'data_type' => 'bool', 'expected_values' => '', 'is_editable' => '0', 'setting_group' => 'business_settings', 'disabled' => false],
            ['id' => 35, 'name' => 'Collection is Visible', 'key' => 'is_collection', 'value' => 'true', 'comment' => 'Collection is Visible', 'hint' => 'Collection is Visible', 'data_type' => 'bool', 'expected_values' => '', 'is_editable' => '0', 'setting_group' => 'business_settings', 'disabled' => false],
            ['id' => 36, 'name' => 'Waiting is Visible', 'key' => 'is_waiting', 'value' => 'true', 'comment' => 'Waiting is Visible', 'hint' => 'Waiting is Visible', 'data_type' => 'bool', 'expected_values' => '', 'is_editable' => '0', 'setting_group' => 'business_settings', 'disabled' => false],
            ['id' => 37, 'name' => 'Reservation is visible', 'key' => 'is_reservation', 'value' => 'false', 'comment' => 'Reservation is visible', 'hint' => 'Reservation is visible', 'data_type' => 'bool', 'expected_values' => '', 'is_editable' => '0', 'setting_group' => 'business_settings', 'disabled' => false],
            ['id' => 38, 'name' => 'Map is visible', 'key' => 'map_is_visible', 'value' => 'No', 'comment' => 'map is visible', 'hint' => 'map is visible', 'data_type' => 'enum', 'expected_values' => 'Yes,No', 'setting_group' => 'business_settings', 'disabled' => true],
            ['id' => 39, 'name' => 'Web order visible', 'key' => 'is_weborder', 'value' => 'false', 'comment' => 'Web order visible', 'hint' => 'Web order visible', 'data_type' => 'bool', 'expected_values' => '', 'is_editable' => '0', 'setting_group' => 'business_settings', 'disabled' => false],
            ['id' => 40, 'name' => 'Product Image Visible', 'key' => 'product_image_visible', 'value' => 'No', 'comment' => 'Product Image Visible', 'hint' => 'Product Image Visible', 'data_type' => 'enum', 'expected_values' => 'Yes,No', 'setting_group' => 'business_settings', 'disabled' => false],
            ['id' => 41, 'name' => 'Postcode Look Up Button Visible', 'key' => 'postcode_lookup_visible', 'value' => 'Yes', 'comment' => 'Postcode Look Up Button Visible', 'hint' => 'Postcode Look Up Button Visible', 'data_type' => 'enum', 'expected_values' => 'Yes,No', 'setting_group' => 'business_settings', 'disabled' => false],
            ['id' => 42, 'name' => 'Device Permissions Allow', 'key' => 'device_permission_allow', 'value' => '0', 'comment' => 'Device Permissions Allow', 'hint' => 'Device Permissions Allow', 'data_type' => 'int', 'expected_values' => '', 'is_editable' => '0', 'setting_group' => 'business_settings', 'disabled' => true],
            ['id' => 43, 'name' => 'SMS Setting Enable', 'key' => 'is_sms', 'value' => 'false', 'comment' => 'SMS Setting Enable', 'hint' => 'SMS Setting Enable', 'data_type' => 'bool', 'expected_values' => '', 'setting_group' => 'business_settings', 'disabled' => false],
            ['id' => 44, 'name' => 'Per SMS Charge', 'key' => 'per_sms_charge', 'value' => '', 'comment' => 'Per SMS Charge', 'hint' => 'Per SMS Charge', 'data_type' => 'int', 'expected_values' => '', 'setting_group' => 'business_settings', 'disabled' => false],
            ['id' => 45, 'name' => 'Membership No Length', 'key' => 'membership_no_length', 'value' => '9', 'comment' => 'Membership No Length', 'hint' => 'Membership No Length', 'data_type' => 'string', 'expected_values' => '', 'setting_group' => 'business_settings', 'disabled' => true],
            ['id' => 46, 'name' => 'Date-Time Receipt printing', 'key' => 'date_time_in_receipt_printing', 'value' => 'date_time', 'comment' => 'Date-Time Receipt printing', 'hint' => 'Date-Time Receipt printing', 'data_type' => 'enum', 'expected_values' => 'date_time,date,time,none', 'setting_group' => 'business_settings', 'disabled' => false],
            ['id' => 47, 'name' => 'Display Second Line', 'key' => 'display_second_line', 'value' => 'Yes', 'comment' => 'Display Second Line', 'hint' => 'Display Second Line', 'data_type' => 'enum', 'expected_values' => 'Yes,No', 'setting_group' => 'business_settings', 'disabled' => true],
            ['id' => 48, 'name' => 'Gratuity', 'key' => 'gratuity', 'value' => 'false', 'comment' => 'Gratuity', 'hint' => 'Gratuity', 'data_type' => 'bool', 'expected_values' => '', 'setting_group' => 'business_settings', 'disabled' => true],
            ['id' => 49, 'name' => 'How much Loyalty Points will Construct 1 Pound', 'key' => 'how_much_loyalty_points_will_construct_1_pound', 'value' => '0', 'comment' => 'how much Loyalty Points will Construct 1 Pound', 'hint' => 'how much Loyalty Points will Construct 1 Pound', 'data_type' => 'int', 'expected_values' => '', 'setting_group' => 'business_settings', 'disabled' => false],
            ['id' => 50, 'name' => 'How much purchase in pound will construct one loyalty point', 'key' => 'how_much_purchase_in_pound_will_construct_one_loyalty_point', 'value' => '0', 'comment' => 'how much purchase in pound will construct one loyalty point', 'hint' => 'how much purchase in pound will construct one loyalty point', 'data_type' => 'int', 'expected_values' => '', 'setting_group' => 'business_settings', 'disabled' => false],
            ['id' => 51, 'name' => 'Banquet Day', 'key' => 'banquet_day', 'value' => NULL, 'comment' => 'Banquet Day', 'hint' => 'Banquet Day', 'data_type' => 'json_array', 'expected_values' => '[{"value":"sunday","name":"Sunday"},{"value":"monday","name":"Monday"},{"value":"tuesday","name":"Tuesday"},{"value":"wednesday","name":"Wednesday"},{"value":"thursday","name":"Thursday"},{"value":"friday","name":"Friday"},{"value":"saturday","name":"Saturday"}]', 'setting_group' => 'business_settings', 'disabled' => false],
            ['id' => 52, 'name' => 'Banquet Type', 'key' => 'banquet_type', 'value' => NULL, 'comment' => 'Banquet Type', 'hint' => 'Banquet Type', 'data_type' => 'json_array', 'expected_values' => '[{"value":"dinein","name":"Dine in"},{"value":"collection","name":"Collection"},{"value":"delivery","name":"Delivery"},{"value":"bar","name":"Bar"},{"value":"waiting","name":"Waiting"}]', 'setting_group' => 'business_settings', 'disabled' => false],
            ['id' => 53, 'name' => 'Tax', 'key' => 'tax', 'value' => '0', 'comment' => 'Tax', 'hint' => 'Tax', 'data_type' => 'int', 'expected_values' => '', 'setting_group' => 'business_settings', 'disabled' => false],
            ['id' => 54, 'name' => 'Vat Number', 'key' => 'vat_number', 'value' => '0', 'comment' => 'Vat Number', 'hint' => 'Vat Number', 'data_type' => 'string', 'expected_values' => '', 'setting_group' => 'business_settings', 'disabled' => false],
            ['id' => 55, 'name' => 'Surcharge', 'key' => 'surcharge', 'value' => 'false', 'comment' => 'Surcharge', 'hint' => 'Surcharge', 'data_type' => 'bool', 'expected_values' => '', 'setting_group' => 'business_settings', 'disabled' => true],
            ['id' => 56, 'name' => 'Open cash drawer after send to kitchen', 'key' => 'open_cash_drawer_after_send_to_kitchen', 'value' => 'No', 'comment' => 'open cash drawer after send to kitchen', 'hint' => 'open cash drawer after send to kitchen', 'data_type' => 'enum', 'expected_values' => 'Yes,No', 'setting_group' => 'business_settings', 'disabled' => false],
            ['id' => 57, 'name' => 'Loyalty Point Receipt', 'key' => 'show_loyalty_points_in_receipt', 'value' => 'false', 'comment' => 'Loyalty Point Receipt', 'hint' => 'Loyalty Point Receipt', 'data_type' => 'bool', 'expected_values' => '', 'setting_group' => 'business_settings', 'disabled' => true],
            ['id' => 58, 'name' => 'Maximum Loyalty Point Value', 'key' => 'maximum_loyalty_point', 'value' => '0', 'comment' => 'Maximum Loyalty Point Value', 'hint' => 'Maximum Loyalty Point Value', 'data_type' => 'int', 'expected_values' => '', 'setting_group' => 'business_settings', 'disabled' => false],
            ['id' => 59, 'name' => 'Print on Receipt  table number or order number', 'key' => 'use_table_number_or_order_number', 'value' => 'both', 'comment' => 'Print on Receipt  table number or order number', 'hint' => 'Print on Receipt  table number or order number', 'data_type' => 'enum', 'expected_values' => 'table_number,order_number,both,none', 'setting_group' => 'business_settings', 'disabled' => false],
            ['id' => 60, 'name' => 'No of Beep in Printer for Cashdraw', 'key' => 'no_of_beep_in_cash_draw', 'value' => '0', 'comment' => 'No of Beep in Printer for Cashdraw', 'hint' => 'No of Beep in Printer for Cashdraw', 'data_type' => 'int', 'expected_values' => '', 'setting_group' => 'business_settings', 'disabled' => false],
            ['id' => 61, 'name' => 'Default prep location for online order', 'key' => 'default_prep_location_for_web', 'value' => '', 'comment' => 'Default prep location for online order', 'hint' => 'Default prep location for online order', 'data_type' => 'string', 'expected_values' => '', 'setting_group' => 'business_settings', 'disabled' => false],
            ['id' => 63, 'name' => 'Offer code length', 'key' => 'offer_code_length', 'value' => '9', 'comment' => 'offer code length', 'hint' => 'offer code length', 'data_type' => 'int', 'expected_values' => '', 'setting_group' => 'business_settings', 'disabled' => false],
            ['id' => 64, 'name' => 'Number of times to use a code by a customer', 'key' => 'number_of_times_to_use_a_code_by_a_customer', 'value' => '0', 'comment' => 'Number of times to use a code by a customer', 'hint' => 'Number of times to use a code by a customer', 'data_type' => 'int', 'expected_values' => '', 'setting_group' => 'business_settings', 'disabled' => false],
            ['id' => 65, 'name' => 'Number of times to use a code by all customer', 'key' => 'number_of_times_to_use_a_code_by_all_customers', 'value' => '0', 'comment' => 'number of times to use a code by all customer', 'hint' => 'number of times to use a code by all customer', 'data_type' => 'int', 'expected_values' => '', 'setting_group' => 'business_settings', 'disabled' => true],
            ['id' => 66, 'name' => 'Psconnect credit card system using', 'key' => 'psconnect_credit_card_system_using', 'value' => 'No', 'comment' => 'psconnect credit card system using', 'hint' => 'psconnect credit card system using', 'data_type' => 'enum', 'expected_values' => 'Yes,No', 'setting_group' => 'business_settings', 'disabled' => true],
            ['id' => 67, 'name' => 'Footer a', 'key' => 'footer_a', 'value' => 'Thank You', 'comment' => 'Footer a', 'hint' => 'Footer a', 'data_type' => 'string', 'expected_values' => '', 'setting_group' => 'business_settings', 'disabled' => false],
            ['id' => 68, 'name' => 'Footer b', 'key' => 'footer_b', 'value' => 'Visit Again', 'comment' => 'Footer b', 'hint' => 'Footer b', 'data_type' => 'string', 'expected_values' => '', 'setting_group' => 'business_settings', 'disabled' => false],
            ['id' => 69, 'name' => 'Footer Delivery', 'key' => 'footer_delivery', 'value' => 'Delivery', 'comment' => 'Footer Delivery', 'hint' => 'Footer Delivery', 'data_type' => 'string', 'expected_values' => '', 'setting_group' => 'business_settings', 'disabled' => false],
            ['id' => 70, 'name' => 'Footer Dinein', 'key' => 'footer_dinein', 'value' => 'Dine In', 'comment' => 'Footer Dinein', 'hint' => 'Footer Dinein', 'data_type' => 'string', 'expected_values' => '', 'setting_group' => 'business_settings', 'disabled' => false],
            ['id' => 71, 'name' => 'Footer Takeaway', 'key' => 'footer_takeaway', 'value' => 'Collection', 'comment' => 'Footer Takeaway', 'hint' => 'Footer Takeaway', 'data_type' => 'string', 'expected_values' => '', 'setting_group' => 'business_settings', 'disabled' => false],
            ['id' => 72, 'name' => 'Footer Waiting', 'key' => 'footer_waiting', 'value' => 'Waiting', 'comment' => 'Footer Waiting', 'hint' => 'Footer Waiting', 'data_type' => 'string', 'expected_values' => '', 'setting_group' => 'business_settings', 'disabled' => false],
            ['id' => 73, 'name' => 'Ticket Header', 'key' => 'ticket_header', 'value' => '', 'comment' => 'Ticket Header', 'hint' => 'Ticket Header', 'data_type' => 'json', 'expected_values' => '', 'setting_group' => 'business_settings', 'disabled' => false],
            ['id' => 74, 'name' => 'Print All is Visible', 'key' => 'is_printall', 'value' => 'true', 'comment' => 'Print All is Visible', 'hint' => 'Print All is Visible', 'data_type' => 'bool', 'expected_values' => '', 'is_editable' => '0', 'setting_group' => 'business_settings', 'disabled' => false],
            ['id' => 75, 'name' => 'Print Bill is Visible', 'key' => 'is_printbill', 'value' => 'true', 'comment' => 'Print Bill is Visible', 'hint' => 'Print Bill is Visible', 'data_type' => 'bool', 'expected_values' => '', 'is_editable' => '0', 'setting_group' => 'business_settings', 'disabled' => false],
            ['id' => 76, 'name' => 'Send Duplicate Order is Visible', 'key' => 'is_sendduplicateorder', 'value' => 'true', 'comment' => 'Send Duplicate Order is Visible', 'hint' => 'Send Duplicate Order is Visible', 'data_type' => 'bool', 'expected_values' => '', 'is_editable' => '0', 'setting_group' => 'business_settings', 'disabled' => false],
            ['id' => 77, 'name' => 'Send Duplicate Order Update is Visible', 'key' => 'is_sendduplicateorderupdate', 'value' => 'true', 'comment' => 'Send Duplicate Order Update is Visible', 'hint' => 'Send Duplicate Order Update is Visible', 'data_type' => 'bool', 'expected_values' => '', 'is_editable' => '0', 'setting_group' => 'business_settings', 'disabled' => false],
            ['id' => 78, 'name' => 'Send Order is Visible', 'key' => 'is_sendorder', 'value' => 'true', 'comment' => 'Send Order is Visible', 'hint' => 'Send Order is Visible', 'data_type' => 'bool', 'expected_values' => '', 'is_editable' => '0', 'setting_group' => 'business_settings', 'disabled' => false],
            ['id' => 79, 'name' => 'Send Order Update is Visible', 'key' => 'is_sendorderupdate', 'value' => 'true', 'comment' => 'Send Order Update is Visible', 'hint' => 'Send Order Update is Visible', 'data_type' => 'bool', 'expected_values' => '', 'is_editable' => '0', 'setting_group' => 'business_settings', 'disabled' => false],
            ['id' => 80, 'name' => 'Pay Bill Action', 'key' => 'pay_bill_action', 'value' => 'bill', 'comment' => 'Pay Bill Action', 'hint' => 'Pay Bill Action', 'data_type' => 'enum', 'expected_values' => 'bill,prep_ticket,both,none', 'setting_group' => 'business_settings', 'disabled' => false],
            ['id' => 81, 'name' => 'Send Order Action', 'key' => 'send_order_action', 'value' => 'prep_ticket', 'comment' => 'Send Order Action', 'hint' => 'Send Order Action', 'data_type' => 'enum', 'expected_values' => 'prep_ticket,none', 'setting_group' => 'business_settings', 'disabled' => false],
            ['id' => 82, 'name' => 'Ready to collect is visible', 'key' => 'is_ready_to_collect', 'value' => 'false', 'comment' => 'Ready to collect is visible', 'hint' => 'Ready to collect is visible', 'data_type' => 'bool', 'expected_values' => '', 'is_editable' => '0', 'setting_group' => 'business_settings', 'disabled' => false],
            ['id' => 83, 'name' => 'On the way is visible', 'key' => 'is_on_the_way', 'value' => 'false', 'comment' => 'On the way is visible', 'hint' => 'On the way is visible', 'data_type' => 'bool', 'expected_values' => '', 'is_editable' => '0', 'setting_group' => 'business_settings', 'disabled' => false],
            ['id' => 84, 'name' => 'Service Charge is visible', 'key' => 'is_service_charge', 'value' => 'false', 'comment' => 'Service Charge is visible', 'hint' => 'Service Charge is visible', 'data_type' => 'bool', 'expected_values' => '', 'is_editable' => '0', 'setting_group' => 'business_settings', 'disabled' => false],
            ['id' => 85, 'name' => 'Service Charge Type', 'key' => 'service_charge_type', 'value' => 'flat', 'comment' => 'Service Charge Type', 'hint' => 'Service Charge Type', 'data_type' => 'enum', 'expected_values' => 'percentage,flat', 'setting_group' => 'business_settings', 'disabled' => false],
            ['id' => 86, 'name' => 'Service Charge Type Option', 'key' => 'service_charge_type_option', 'value' => 'auto', 'comment' => 'Service Charge Type Option', 'hint' => 'Service Charge Type Option', 'data_type' => 'enum', 'expected_values' => 'auto,manual', 'setting_group' => 'business_settings', 'disabled' => false],
            ['id' => 87, 'name' => 'Ticket Header Type', 'key' => 'ticket_header_type', 'value' => 'left', 'comment' => 'Ticket Header Type', 'hint' => 'Ticket Header Type', 'data_type' => 'enum', 'expected_values' => 'left,center,right', 'setting_group' => 'business_settings', 'disabled' => false],
            ['id' => 88, 'name' => 'Kitchen Copy Type', 'key' => 'kitchen_copy_type', 'value' => 'auto', 'comment' => 'Kitchen Copy Type', 'hint' => 'Kitchen Copy Type', 'data_type' => 'enum', 'expected_values' => 'auto,manual', 'setting_group' => 'business_settings', 'disabled' => false],
            ['id' => 89, 'name' => 'Pay Bill Action Type', 'key' => 'pay_bill_action_type', 'value' => 'auto', 'comment' => 'Pay Bill Action', 'hint' => 'Pay Bill Action', 'data_type' => 'enum', 'expected_values' => 'auto,manual', 'setting_group' => 'business_settings', 'disabled' => false],
            ['id' => 90, 'name' => 'Kitchen Copy Total Visible', 'key' => 'kitchen_total_visible', 'value' => 'yes', 'comment' => 'Kitchen Copy Total Visible', 'hint' => 'Kitchen Copy Total Visible', 'data_type' => 'enum', 'expected_values' => 'yes,no', 'setting_group' => 'business_settings', 'disabled' => false],
            ['id' => 91, 'name' => 'Open cash drawer after cash payment', 'key' => 'open_cash_drawer_after_cash_payment', 'value' => 'Yes', 'comment' => 'open cash drawer after cash payment', 'hint' => 'Open cash drawer after cash payment', 'data_type' => 'enum', 'expected_values' => 'Yes,No', 'setting_group' => 'business_settings', 'disabled' => false],
            ['id' => 92, 'name' => 'Order Complete Mode', 'key' => 'order_complete_mode', 'value' => 'auto', 'comment' => 'Complete order auto or manually?', 'hint' => 'Complete order mode', 'data_type' => 'enum', 'expected_values' => 'auto,manual', 'setting_group' => 'business_settings', 'disabled' => false],
            ['id' => 93, 'name' => 'Home Theme', 'key' => 'home_theme', 'value' => 'theme1', 'comment' => 'Home Theme', 'hint' => 'Home Theme', 'data_type' => 'enum', 'expected_values' => 'theme1,theme2,theme3,theme4', 'setting_group' => 'business_settings', 'disabled' => false],
            ['id' => 94, 'name' => 'Completed Orders in Home', 'key' => 'show_completed_orders', 'value' => 'false', 'comment' => 'Completed Orders in Home', 'hint' => 'Completed Orders in Home', 'data_type' => 'bool', 'expected_values' => '', 'is_editable' => '0', 'setting_group' => 'business_settings', 'disabled' => false],
            ['id' => 95, 'name' => 'Service Charge as Order Type Wise', 'key' => 'service_charge_order_type', 'value' => 'dine in,collection,delivery,bar,waiting', 'comment' => 'Service Charge as Order Type Wise', 'hint' => 'Service Charge as Order Type Wise', 'data_type' => 'json_array', 'expected_values' => '[{"value":"dine in","name":"Dine in"},{"value":"collection","name":"Collection"},{"value":"delivery","name":"Delivery"},{"value":"bar","name":"Bar"},{"value":"waiting","name":"Waiting"}]', 'setting_group' => 'business_settings', 'disabled' => false],
            ['id' => 96, 'name' => 'Delivery Charge Type Option', 'key' => 'delivery_charge_type_option', 'value' => 'auto', 'comment' => 'Delivery Charge Type Option', 'hint' => 'Delivery Charge Type Option', 'data_type' => 'enum', 'expected_values' => 'auto,manual', 'setting_group' => 'business_settings', 'disabled' => false],
            ['id' => 97, 'name' => 'Dinein Remote Device Setting', 'key' => 'dinein_remote_device_setting', 'value' => 'none', 'comment' => 'Dinein Remote Device Setting', 'hint' => 'Dinein Remote Device Setting', 'data_type' => 'enum', 'expected_values' => 'send_order,print_all,print_bill,none', 'setting_group' => 'business_settings', 'disabled' => false],
            ['id' => 98, 'name' => 'Display Sub Add On Title', 'key' => 'prep_location_subaddon_status', 'value' => 'show', 'comment' => 'Display Sub Add On Title', 'hint' => 'Display Sub Add On Title', 'data_type' => 'enum', 'expected_values' => 'show,hide', 'setting_group' => 'business_settings', 'disabled' => false],
            ['id' => 99, 'name' => 'Print Block Bill', 'key' => 'print_block_bill', 'value' => 'no', 'comment' => 'Print Block Bill', 'hint' => 'Print Block Bill', 'data_type' => 'enum', 'expected_values' => 'yes,no', 'setting_group' => 'business_settings', 'disabled' => false],
            ['id' => 100, 'name' => 'Cloud System', 'key' => 'cloud_system', 'value' => 'no', 'comment' => 'Cloud System', 'hint' => 'Cloud System', 'data_type' => 'enum', 'expected_values' => 'yes,no', 'setting_group' => 'business_settings', 'disabled' => false],
            ['id' => 101, 'name' => 'Customer Search Setting', 'key' => 'customer_search_setting', 'value' => 'yes', 'comment' => 'Customer Search Setting', 'hint' => 'Customer Search Setting', 'data_type' => 'enum', 'expected_values' => 'yes,no', 'setting_group' => 'business_settings', 'disabled' => true],
            ['id' => 102, 'name' => 'Display Discount Popup', 'key' => 'display_discount_setting', 'value' => 'yes', 'comment' => 'Display Discount Popup', 'hint' => 'Display Discount Popup', 'data_type' => 'enum', 'expected_values' => 'yes,no', 'setting_group' => 'business_settings', 'disabled' => false],
            ['id' => 103, 'name' => 'Partial Payment Mode', 'key' => 'partial_payment_mode', 'value' => 'yes', 'comment' => 'Partial Payment Mode', 'hint' => 'Partial Payment Mode', 'data_type' => 'enum', 'expected_values' => 'yes,no', 'setting_group' => 'business_settings', 'disabled' => false],
            ['id' => 104, 'name' => 'Delivery Pay Bill Action', 'key' => 'delivery_pay_bill_action', 'value' => 'bill', 'comment' => 'Delivery Pay Bill Action', 'hint' => 'Delivery Pay Bill Action', 'data_type' => 'enum', 'expected_values' => 'bill,prep_ticket,both,none', 'setting_group' => 'business_settings', 'disabled' => false],
            ['id' => 105, 'name' => 'Pickup Pay Bill Action', 'key' => 'pickup_pay_bill_action', 'value' => 'bill', 'comment' => 'Pickup Pay Bill Action', 'hint' => 'Pickup Pay Bill Action', 'data_type' => 'enum', 'expected_values' => 'bill,prep_ticket,both,none', 'setting_group' => 'business_settings', 'disabled' => false],
            ['id' => 106, 'name' => 'Waiting Pay Bill Action', 'key' => 'waiting_pay_bill_action', 'value' => 'bill', 'comment' => 'Waiting Pay Bill Action', 'hint' => 'Waiting Pay Bill Action', 'data_type' => 'enum', 'expected_values' => 'bill,prep_ticket,both,none', 'setting_group' => 'business_settings', 'disabled' => false],
            ['id' => 107, 'name' => 'Paid Payment Title', 'key' => 'paid_payment_title', 'value' => 'Paid', 'comment' => 'Paid Payment Title', 'hint' => 'Paid Payment Title', 'data_type' => 'string', 'expected_values' => '', 'setting_group' => 'business_settings', 'disabled' => false],
            ['id' => 108, 'name' => 'Unpaid Payment Title', 'key' => 'unpaid_payment_title', 'value' => 'Unpaid', 'comment' => 'Unpaid Payment Title', 'hint' => 'Unpaid Payment Title', 'data_type' => 'string', 'expected_values' => '', 'setting_group' => 'business_settings', 'disabled' => false],
            ['id' => 109, 'name' => 'Partial Payment Title', 'key' => 'partial_payment_title', 'value' => 'Partial', 'comment' => 'Partial Payment Title', 'hint' => 'Partial Payment Title', 'data_type' => 'string', 'expected_values' => '', 'setting_group' => 'business_settings', 'disabled' => false],
            ['id' => 110, 'name' => 'Card Payment Type', 'key' => 'card_payment_type', 'value' => 'Credit Card', 'comment' => 'Card Payment Type', 'hint' => 'Card Payment Type', 'data_type' => 'string', 'expected_values' => '', 'setting_group' => 'business_settings', 'disabled' => false],
            ['id' => 111, 'name' => 'Cash Payment Type', 'key' => 'cash_payment_type', 'value' => 'Cash', 'comment' => 'Cash Payment Type', 'hint' => 'Cash Payment Type', 'data_type' => 'string', 'expected_values' => '', 'setting_group' => 'business_settings', 'disabled' => false],

            ['id' => 112, 'name' => 'Product Background Color', 'key' => 'product_background_color', 'value' => 'blank', 'comment' => 'Product Background Color', 'hint' => 'Product Background Color', 'data_type' => 'enum', 'expected_values' => 'blank,color,image', 'setting_group' => 'business_settings', 'disabled' => false],
            ['id' => 113, 'name' => 'Dinein is Visible', 'key' => 'dinein_visible', 'value' => 'show', 'comment' => 'Dinein is Visible', 'hint' => 'Dinein is Visible', 'data_type' => 'enum', 'expected_values' => 'show,hide', 'setting_group' => 'business_settings', 'disabled' => false],
            ['id' => 114, 'name' => 'Gratuity', 'key' => 'is_gratuity', 'value' => 'enable', 'comment' => 'Gratuity', 'hint' => 'Gratuity', 'data_type' => 'enum', 'expected_values' => 'enable,disable', 'setting_group' => 'business_settings', 'disabled' => false],
            ['id' => 115, 'name' => 'Loyalty Point Receipt', 'key' => 'is_show_loyalty_points_in_receipt', 'value' => 'no', 'comment' => 'Loyalty Point Receipt', 'hint' => 'Loyalty Point Receipt', 'data_type' => 'enum', 'expected_values' => 'yes,no', 'setting_group' => 'business_settings', 'disabled' => false],
            ['id' => 116, 'name' => 'Maximum Redeemable Point', 'key' => 'maximum_redeemable_point', 'value' => 'all', 'comment' => 'Maximum Redeemable Point', 'hint' => 'Maximum Redeemable Point', 'data_type' => 'enum', 'expected_values' => 'all,value', 'setting_group' => 'business_settings', 'disabled' => false],
            ['id' => 117, 'name' => 'Display Complete In Home Screen ', 'key' => 'display_completed_in_home_screen', 'value' => 'no', 'comment' => 'Display Complete In Home Screen', 'hint' => 'Display Complete In Home Screen', 'data_type' => 'enum', 'expected_values' => 'yes,no', 'is_editable' => '0', 'setting_group' => 'business_settings', 'disabled' => false],
            ['id' => 118, 'name' => 'Intelligent Customer Search', 'key' => 'intelligent_customer_search', 'value' => 'enable', 'comment' => 'Intelligent Customer Search', 'hint' => 'Intelligent Customer Search', 'data_type' => 'enum', 'expected_values' => 'enable,disable', 'setting_group' => 'business_settings', 'disabled' => false],
            ['id' => 118, 'name' => 'Product Description', 'key' => 'product_description', 'value' => 'show', 'comment' => 'Product Description', 'hint' => 'Product Description', 'data_type' => 'enum', 'expected_values' => 'show,hide', 'setting_group' => 'business_settings', 'disabled' => false],
            ['id' => 119, 'name' => 'SMS Setting', 'key' => 'is_sms_setting', 'value' => 'active', 'comment' => 'SMS Setting', 'hint' => 'SMS Setting', 'data_type' => 'enum', 'expected_values' => 'active,inactive', 'setting_group' => 'business_settings', 'disabled' => false],
            ['id' => 120, 'name' => 'Auto Order Reset', 'key' => 'order_reset_auto', 'value' => 'Yes', 'comment' => 'Auto Order Reset', 'hint' => 'Auto Order Reset', 'data_type' => 'enum', 'expected_values' => 'Yes,No', 'setting_group' => 'business_settings', 'disabled' => false],
            ['id' => 121, 'name' => 'Partial Payment Print', 'key' => 'partial_payment_print', 'value' => 'Yes', 'comment' => 'Partial Payment Print', 'hint' => 'Partial Payment Print', 'data_type' => 'enum', 'expected_values' => 'Yes,No', 'setting_group' => 'business_settings', 'disabled' => false],
            ['id' => 122, 'name' => 'Addon Theme', 'key' => 'addon_theme', 'value' => 'theme1', 'comment' => 'Addon Theme', 'hint' => 'Addon Theme', 'data_type' => 'enum', 'expected_values' => 'theme1,theme2,theme3,theme4', 'setting_group' => 'business_settings', 'disabled' => false],
            ['id' => 123, 'name' => 'Auto Delivery Time Slot', 'key' => 'auto_delivery_time_slot', 'value' => 'false', 'comment' => 'Auto Delivery Time Slot', 'hint' => 'Auto Delivery Time Slot', 'data_type' => 'bool', 'expected_values' => '', 'setting_group' => 'business_settings', 'disabled' => false],
            ['id' => 124, 'name' => 'Default printer for cash drawer', 'key' => 'default_printer_for_cash_drawer', 'value' => '', 'comment' => 'Default printer for cash drawer', 'hint' => 'Default printer for cash drawer', 'data_type' => 'string', 'expected_values' => '', 'setting_group' => 'business_settings', 'disabled' => false],
            ['id' => 125, 'name' => 'Download Android Latest App Url Link', 'key' => 'download_android_latest_app_url_link', 'value' => '', 'comment' => 'Download Android Latest App Url Link', 'hint' => 'Download Android Latest App Url Link', 'data_type' => 'string', 'expected_values' => '', 'setting_group' => 'business_settings', 'disabled' => false],
            ['id' => 126, 'name' => 'Delete Item is Visible', 'key' => 'delete_item_visible', 'value' => 'false', 'comment' => 'Delete Item is Visible', 'hint' => 'Delete Item is Visible', 'data_type' => 'bool', 'expected_values' => '', 'setting_group' => 'business_settings', 'disabled' => false],
            ['id' => 127, 'name' => 'Clear Item Count After Send Order', 'key' => 'clear_item_count_send_order', 'value' => 'false', 'comment' => 'Clear Item Count After Send Order', 'hint' => 'Clear Item Count After Send Order', 'data_type' => 'bool', 'expected_values' => '', 'setting_group' => 'business_settings', 'disabled' => false],
            ['id' => 128, 'name' => 'Default printer for card payment', 'key' => 'default_printer_for_card_payment', 'value' => '', 'comment' => 'Default printer for card payment', 'hint' => 'Default printer for card payment', 'data_type' => 'string', 'expected_values' => '', 'setting_group' => 'business_settings', 'disabled' => false],
        ];
        foreach ($items as $item) {
            EposSetting::updateOrCreate(['id' => $item['id']], $item);
        }
    }
}
