<?php

namespace Database\Seeders;

use App\ModelsEpos\EposTableStatus;
use Illuminate\Database\Seeder;

class TableStatusSeeder extends Seeder
{
    /**
     * Run the database seeds.
     *
     * @return void
     */
    public function run()
    {
        $items = [
            ['id' => 1, 'status' => 'Vacant', 'top_color' => '#FFFFFF', 'bottom_color' => '#FFFFFF'],
            ['id' => 2, 'status' => 'Taking Order', 'top_color' => '#DE6733', 'bottom_color' => '#DE6733'],
            ['id' => 3, 'status' => 'Order Taken', 'top_color' => '#23A299', 'bottom_color' => '#23A299'],
            ['id' => 4, 'status' => 'Served', 'top_color' => '#32954B', 'bottom_color' => '#32954B'],
            ['id' => 5, 'status' => 'Served and paid', 'top_color' => '#32954B', 'bottom_color' => '#32954B'],
            ['id' => 6, 'status' => 'Merged', 'top_color' => '#ff0000', 'bottom_color' => '#ff0000'],
        ];
        foreach ($items as $item) {
            EposTableStatus::updateOrCreate(['id' => $item['id']], $item);
        }
    }
}
