var url_string = window.location.href;
var geturl = new URL(url_string);
var decrypt = atob(geturl.searchParams.get('key'));
var full_url = url_string.replace(/\key=.*/, '') + decrypt;
var url = new URL(full_url);

var baseUrl = "https://testrms.tiffintom.com/public/";
if (url.hostname.includes("ubsidi")) {
    baseUrl = "https://www.ubsidi.com/api/public/"
}

var key = 'pk_test_51IrrKlIa6rlUIwjl9je80bHmFyIfIB6a236GR5JqGpUdX1NVvtPGgBO0LmUnMn0ggjpHmDlUTYFz8jr6VMN2YrxZ00SSRruIEe';

fetchKey();

function fetchKey() {
    return fetch(baseUrl + "api/site-settings/stripe-connect-public-key")
        .then(function (result) {
            return result.json();
        })
        .then(function (data) {
            if (data.value) {
                payment(data.value);
            } else {
                payment(key);
            }
        });
}

var paramSuccessUrl = url.searchParams.get("payment_success_url");
var paramFailedUrl = url.searchParams.get("payment_failed_url");

function payment(key) {
    var stripe = Stripe(key);

    // Create an instance of Elements
    var elements = stripe.elements();
    var paramAmount = parseInt(url.searchParams.get("payment_direct_amount"));
    var paramBusinessId = url.searchParams.get("payment_direct_business_id");
    var paramCurrency = url.searchParams.get("payment_currency");
    var cardholderName = url.searchParams.get("payment_customer_name");
    var cardholderEmail = url.searchParams.get("payment_customer_email");
    // var paramSuccessUrl = url.searchParams.get("payment_success_url");
    var currency = "£";

    loader = document.getElementById("loader");
    amountText = document.getElementById("amountText");
    proceed = document.getElementById("proceed");
    messageText = document.getElementById("message");
    counterText = document.getElementById("counter");
    buttonResponse = document.getElementById("response_button");
    buttonResponseText = document.getElementById("response_button_text");

    if (paramAmount == null || isNaN(paramAmount) || paramAmount <= 0) {
        messageText.innerHTML = "Invalid amount";
        messageText.classList.remove("invisible");

        proceed.innerHTML = "Pay Now";
        proceed.classList.add("disabled");
    }

    amountText.innerHTML = currency + " " + parseFloat(paramAmount / 100).toFixed(2);

    // Custom styling can be passed to options when creating an Element.
    // (Note that this demo uses a wider set of styles than the guide below.)
    var style = {
        base: {
            color: '#32325d',
            lineHeight: '18px',
            fontFamily: '"Helvetica Neue", Helvetica, sans-serif',
            fontSmoothing: 'antialiased',
            fontSize: '16px',
            '::placeholder': {
                color: '#aab7c4'
            }
        },
        invalid: {
            color: '#fa755a',
            iconColor: '#fa755a'
        }
    };

    // Create an instance of the card Element
    var card = elements.create('card', {
        hidePostalCode: true,
        style: style
    });

    // Add an instance of the card Element into the `card-element` <div>
    card.mount('#card-element');

    // Handle real-time validation errors from the card Element.
    card.addEventListener('change', function (event) {
        var displayError = document.getElementById('card-errors');
        if (event.error) {
            displayError.textContent = event.error.message;
        } else {
            displayError.textContent = '';
        }
    });

    // Handle form submission
    var form = document.getElementById('payment-form');

    form.addEventListener('submit', function (event) {
        event.preventDefault();
        stripe.createPaymentMethod('card', card).then(function (result) {
            if (result.error) {
                // Inform the user if there was an error
                var errorElement = document.getElementById('card-errors');
                errorElement.textContent = result.error.message;
            } else {
                loader.classList.remove('d-none');
                proceed.classList.add('disabled');

                // Send the token to your server
                var bodyParams = {}
                bodyParams['business_id'] = paramBusinessId;
                bodyParams['currency'] = paramCurrency;
                bodyParams['amount'] = paramAmount;
                bodyParams['payment_method_id'] = result.paymentMethod.id;
                if (cardholderName != '') bodyParams['customer_name'] = cardholderName;
                if (cardholderEmail != '') bodyParams['customer_email'] = cardholderEmail;
                bodyParams['transaction_type'] = 'connect';
                bodyParams['auto_confirm'] = '0';

                return fetch(baseUrl + "api/pg/payment-intent", {
                        method: "POST",
                        headers: {
                            "Content-Type": "application/json"
                        },
                        body: JSON.stringify(bodyParams),
                    })
                    .then(function (result) {
                        return result.json();
                    })
                    .then(function (data) {
                        if (data.payment_intent_id) {
                            stripe.confirmCardPayment(data.payment_intent_id).then((result) => {
                                if (result.error) {
                                    showMessage(result.error.message, 'error');
                                    showResponseButton("Payment failed", "error");
                                    proceed.classList.remove('disabled');
                                    loader.classList.add('d-none');
                                } else {
                                    if (result.paymentIntent.status === 'succeeded') {
                                        showMessage("Payment successful", 'success', result.paymentIntent);
                                        showResponseButton("Payment successful", "success");
                                    } else {
                                        showMessage(result.error.message, 'error');
                                        showResponseButton("Payment failed", "error");
                                        proceed.classList.remove('disabled');
                                        loader.classList.add('d-none');
                                    }
                                }
                            });
                        } else {
                            showMessage(data.message, 'error');
                            showResponseButton("Payment failed", "error");
                            proceed.classList.remove('disabled');
                            loader.classList.add('d-none');
                            return null;
                        }
                        return null;
                    });
            }
        });
    });
}

function showResponseButton(message, status) {
    buttonResponse.classList.remove("d-none");
    buttonResponse.classList.remove('disabled');
    buttonResponseText.innerHTML = message
    if (status == 'error') {
        buttonResponse.classList.remove('btn-success');
        buttonResponse.classList.add('btn-danger');

    } else if (status == 'success') {
        proceed.classList.add("d-none");
        buttonResponse.classList.add('btn-success');
        buttonResponse.classList.remove('btn-danger');
    }
    buttonResponse.classList.add('d-none');
}

function showMessage(message, status, data = null) {
    messageText.innerHTML = message;
    messageText.classList.remove("invisible");
    if (status == "success") {
        keyval = btoa("success_amount=" + data.amount + "&after_url=" + paramSuccessUrl + "&transaction_id=" + data.id);
        window.location.href = "./direct-payment-success?status=" + keyval;
    } else if (status == "error") {
        messageText.classList.add("alert-danger");
        counterText.classList.remove("invisible");
        document.getElementById("click").href = paramFailedUrl;
        var i = 10;
        var tim;
        tim = setInterval(function () {
            if (i == 1) {
                window.location.href = paramFailedUrl;
            }
            document.getElementById('count').innerHTML = --i;
        }, 1000);

    } else {}
}
