var url_string = window.location.href;
var geturl = new URL(url_string);
var decrypt = atob(geturl.searchParams.get('key'));
var full_url = url_string.replace(/\key=.*/, '') + decrypt;
var url = new URL(full_url);

// var baseUrl = "http://192.168.1.23:8300/";
var baseUrl = "https://testrms.tiffintom.com/V2/public/";
if (url.hostname.includes("ubsidi")) {
    baseUrl = "https://www.ubsidi.com/api/public/"
}
// var key = 'pk_test_51IrrKlIa6rlUIwjl9je80bHmFyIfIB6a236GR5JqGpUdX1NVvtPGgBO0LmUnMn0ggjpHmDlUTYFz8jr6VMN2YrxZ00SSRruIEe';

fetchLink();
// fetchKey();

function fetchKey() {
    return fetch(baseUrl + "api/site-settings/stripe-connect-public-key")
        .then(function (result) {
            return result.json();
        })
        .then(function (data) {
            if (data.value) {
                payment(data.value);
            } else {
                payment(key);
            }
        });
}

var paramId = '';
var paramStatus = '';
var paramAmount = '';
var paramBusinessId = '';
var paramCurrency = '';
var cardholderName = '';
var cardholderEmail = '';
var paramBusinessName = '';
var paramSecretKey = '';
var paramPublishKey = '';
var paramDescription = '';
var paramDescriptor = '';

paymentheaderText = document.getElementById("payment-header");

function fetchLink() {
    var paramCode = url.searchParams.get("code");
    messageText = document.getElementById("message");

    return fetch(baseUrl + "tiffintom/payment-message/find/" + paramCode)
        .then(function (result) {
            return result.json();
        })
        .then(function (data) {
            if (data.id) {
                paramId = data.id;
                paramStatus = data.status;
                paramAmount = data.amount;
                paramBusinessId = data.business_id;
                paramCurrency = 'gbp';
                paramBusinessName = data.name;
                paramSecretKey = data.secretkey;
                paramPublishKey = data.publishkey;
                paramDescription = data.description;
                paramDescriptor = data.descriptor;
                paymentheaderText.innerHTML = paramBusinessName;
                if (paramStatus == 'Success') {
                    document.getElementById("payment-form").style.display = "none";
                    document.getElementById("link-payment-form").classList.remove('d-none');
                    document.getElementById("link-payment-form").style.display = "block";
                    return false;
                }
                payment(paramPublishKey);
            } else {
                messageText.innerHTML = "Invalid payment URL";
                messageText.classList.remove("invisible");

                proceed.innerHTML = "Pay Now";
                proceed.classList.add("disabled");
            }
        });
}

var paramSuccessUrl = 'https://www.tiffintom.com/';
var paramFailedUrl = url;

function payment(key) {
    var stripe = Stripe(key);

    // Create an instance of Elements
    var elements = stripe.elements();
    var currency = "£";

    loader = document.getElementById("loader");
    amountText = document.getElementById("amountText");
    proceed = document.getElementById("proceed");
    messageText = document.getElementById("message");
    counterText = document.getElementById("counter");
    buttonResponse = document.getElementById("response_button");
    buttonResponseText = document.getElementById("response_button_text");

    if (paramAmount == null || isNaN(paramAmount) || paramAmount <= 0) {
        messageText.innerHTML = "Invalid amount";
        messageText.classList.remove("invisible");

        proceed.innerHTML = "Pay Now";
        proceed.classList.add("disabled");
    }

    amountText.innerHTML = currency + " " + parseFloat(paramAmount).toFixed(2);

    // Custom styling can be passed to options when creating an Element.
    // (Note that this demo uses a wider set of styles than the guide below.)
    var style = {
        base: {
            color: '#32325d',
            lineHeight: '18px',
            fontFamily: '"Helvetica Neue", Helvetica, sans-serif',
            fontSmoothing: 'antialiased',
            fontSize: '16px',
            '::placeholder': {
                color: '#aab7c4'
            }
        },
        invalid: {
            color: '#fa755a',
            iconColor: '#fa755a'
        }
    };

    // Create an instance of the card Element
    var card = elements.create('card', {
        hidePostalCode: true,
        style: style
    });

    // Add an instance of the card Element into the `card-element` <div>
    card.mount('#card-element');

    // Handle real-time validation errors from the card Element.
    card.addEventListener('change', function (event) {
        var displayError = document.getElementById('card-errors');
        if (event.error) {
            displayError.textContent = event.error.message;
        } else {
            displayError.textContent = '';
        }
    });

    // Handle form submission
    var form = document.getElementById('payment-form');

    form.addEventListener('submit', function (event) {
        event.preventDefault();
        stripe.createPaymentMethod('card', card).then(function (result) {
            if (result.error) {
                // Inform the user if there was an error
                var errorElement = document.getElementById('card-errors');
                errorElement.textContent = result.error.message;
            } else {
                loader.classList.remove('d-none');
                proceed.classList.add('disabled');
                // Send the token to your server
                var bodyParams = {}
                bodyParams['id'] = paramId;
                bodyParams['business_id'] = paramBusinessId;
                bodyParams['publishkey'] = paramPublishKey;
                bodyParams['secretkey'] = paramSecretKey;
                bodyParams['description'] = paramDescription;
                bodyParams['descriptor'] = paramDescriptor;
                bodyParams['currency'] = paramCurrency;
                bodyParams['amount'] = paramAmount * 100;
                bodyParams['payment_method_id'] = result.paymentMethod.id;
                bodyParams['customer_email'] = document.getElementById('email').value;
                bodyParams['transaction_type'] = 'connect';
                bodyParams['auto_confirm'] = '0';

                return fetch(baseUrl + "tiffintom/payment-message/payment-intent", {
                        method: "POST",
                        headers: {
                            "Content-Type": "application/json"
                        },
                        body: JSON.stringify(bodyParams),
                    })
                    .then(function (result) {
                        return result.json();
                    })
                    .then(function (data) {
                        if (data.payment_intent_id) {
                            stripe.confirmCardPayment(data.payment_intent_id).then((result) => {
                                if (result.error) {
                                    showMessage(result.error.message, 'error');
                                    showResponseButton("Payment failed", "error");
                                    proceed.classList.remove('disabled');
                                    loader.classList.add('d-none');
                                } else {
                                    if (result.paymentIntent.status === 'succeeded') {
                                        showMessage("Payment successful", 'success', result.paymentIntent);
                                        showResponseButton("Payment successful", "success");
                                    } else {
                                        showMessage(result.error.message, 'error');
                                        showResponseButton("Payment failed", "error");
                                        proceed.classList.remove('disabled');
                                        loader.classList.add('d-none');
                                    }
                                }
                            });
                        } else {
                            showMessage(data.message, 'error');
                            showResponseButton("Payment failed", "error");
                            proceed.classList.remove('disabled');
                            loader.classList.add('d-none');
                            return null;
                        }
                        return null;
                    });
            }
        });
    });
}

function showResponseButton(message, status) {
    buttonResponse.classList.remove("d-none");
    buttonResponse.classList.remove('disabled');
    buttonResponseText.innerHTML = message
    if (status == 'error') {
        buttonResponse.classList.remove('btn-success');
        buttonResponse.classList.add('btn-danger');

    } else if (status == 'success') {
        proceed.classList.add("d-none");
        buttonResponse.classList.add('btn-success');
        buttonResponse.classList.remove('btn-danger');
    }
    buttonResponse.classList.add('d-none');
}

function showMessage(message, status, data = null) {
    messageText.innerHTML = message;
    messageText.classList.remove("invisible");
    if (status == "success") {
        keyval = btoa("success_amount=" + data.amount + "&after_url=" + paramSuccessUrl + "&transaction_id=" + data.id);

        var bodyParams = {}
        bodyParams['status'] = "Success";
        bodyParams['payment_id'] = data.id;
        return fetch(baseUrl + "tiffintom/payment-message/" + paramId + "/change-status", {
                method: "POST",
                headers: {
                    "Content-Type": "application/json"
                },
                body: JSON.stringify(bodyParams),
            })
            .then(function (result) {
                return result.json();
            })
            .then(function (data) {
                window.location.href = baseUrl + "epos-payment-success?status=" + keyval;
            });
    } else if (status == "error") {
        messageText.classList.add("alert-danger");
        if (isEmail(document.getElementById('email').value) == true) {
            counterText.classList.remove("invisible");
            document.getElementById("click").href = paramFailedUrl;
            var i = 10;
            var tim;
            tim = setInterval(function () {
                if (i == 1) {
                    location.reload();
                }
                document.getElementById('count').innerHTML = --i;
            }, 1000);
        }

    } else {}
}
