var url_string = window.location.href;
var geturl = new URL(url_string);
var decrypt = atob(geturl.searchParams.get('key'));
var full_url = url_string.replace(/\key=.*/, '') + decrypt;
var url = new URL(full_url);

// var baseUrl = "http://192.168.1.40:8300/";
var baseUrl = "https://testrms.tiffintom.com/V2/public/";
if (url.hostname.includes("ubsidi")) {
    baseUrl = "https://www.ubsidi.com/V2/public/"
}

var paramId = '';
var paramStatus = '';
var paramAmount = '';
var paramBusinessId = '';
var paramCurrency = '';
var cardholderName = '';
var cardholderEmail = '';
var paramBusinessName = '';
var paramSecretKey = '';
var paramPublishKey = '';
var paramDescription = '';
var paramDescriptor = '';
var paramSuccessUrl = 'https://www.tiffintom.com/';
var paramFailedUrl = url;

loader = document.getElementById("loader");
amountText = document.getElementById("amountText");
proceed = document.getElementById("payment-submit");
messageText = document.getElementById("card-errors");
counterText = document.getElementById("counter");
buttonResponse = document.getElementById("response_button");
buttonResponseText = document.getElementById("response_button_text");
paymentheaderText = document.getElementById("payment-header");

$(document).ready(function () {
    fetchLink().then(function () {
        // Create a Stripe client
        var stripe = Stripe(paramPublishKey);

        // Create an instance of Elements
        var elements = stripe.elements();

        // Try to match bootstrap 4 styling
        var style = {
            base: {
                'lineHeight': '1.35',
                'fontSize': '25px',
                'color': '#495057',
                'fontFamily': 'apple-system,BlinkMacSystemFont,"Segoe UI",Roboto,"Helvetica Neue",Arial,sans-serif'
            }
        };

        // Card number
        var card = elements.create('cardNumber', {
            'placeholder': '',
            'style': style
        });
        card.mount('#card-number');

        // CVC
        var cvc = elements.create('cardCvc', {
            'placeholder': '',
            'style': style
        });
        cvc.mount('#card-cvc');

        // Card number
        var exp = elements.create('cardExpiry', {
            'placeholder': '',
            'style': style
        });
        exp.mount('#card-exp');

        // Postal Code
        var postalCode = elements.create('postalCode', {
            'placeholder': '',
            'style': style
        });
        postalCode.mount('#postalCode');

        // Submit
        $('#payment-submit').on('click', function (e) {
            e.preventDefault();
            var cardData = {
                'email': $('#email').val()
            };
            stripe.createPaymentMethod('card', card).then(function (result) {
                if (result.error) {
                    var errorElement = document.getElementById('card-errors');
                    errorElement.textContent = result.error.message;
                    proceed.classList.remove("disabled");
                } else {
                    loader.classList.remove('d-none');
                    proceed.classList.add('disabled');

                    var bodyParams = {}
                    bodyParams['id'] = paramId;
                    bodyParams['business_id'] = paramBusinessId;
                    bodyParams['publishkey'] = paramPublishKey;
                    bodyParams['secretkey'] = paramSecretKey;
                    bodyParams['description'] = paramDescription;
                    bodyParams['descriptor'] = paramDescriptor;
                    bodyParams['currency'] = paramCurrency;
                    bodyParams['amount'] = paramAmount * 100;
                    bodyParams['payment_method_id'] = result.paymentMethod.id;
                    bodyParams['customer_email'] = document.getElementById('email').value;
                    bodyParams['transaction_type'] = 'connect';
                    bodyParams['auto_confirm'] = '0';

                    return fetch(baseUrl + "tiffintom/payment-message/payment-intent", {
                            method: "POST",
                            headers: {
                                "Content-Type": "application/json",
                                "link": "direct",
                            },
                            body: JSON.stringify(bodyParams),
                        })
                        .then(function (result) {
                            return result.json();
                        })
                        .then(function (data) {
                            if (data.payment_intent_id) {
                                stripe.confirmCardPayment(data.payment_intent_id).then((result) => {
                                    if (result.error) {
                                        showMessage(result.error.message, 'error');
                                        proceed.classList.remove('disabled');
                                        loader.classList.add('d-none');
                                    } else {
                                        if (result.paymentIntent.status === 'succeeded') {
                                            showMessage("Payment successful", 'success', result.paymentIntent);
                                        } else {
                                            showMessage(result.error.message, 'error');
                                            proceed.classList.remove('disabled');
                                            loader.classList.add('d-none');
                                        }
                                    }
                                });
                            } else {
                                showMessage(data.message, 'error');
                                proceed.classList.remove('disabled');
                                loader.classList.add('d-none');
                                return null;
                            }
                            return null;
                        });
                }
            });
        });
    });
});

async function fetchLink() {
    var paramCode = url.searchParams.get("code");
    messageText = document.getElementById("card-errors");

    return await fetch(baseUrl + "tiffintom/payment-message/find/" + paramCode, {
            headers: {
                "Content-Type": "application/json",
                "link": "direct",
            }
        })
        .then(function (result) {
            console.log(result);
            return result.json();
        })
        .then(function (data) {
            console.log(data);
            if (data.id) {
                $('#email').val(data.email);
                $(".business-logo").attr("src", data.image_url);
                paramId = data.id;
                paramStatus = data.status;
                paramAmount = data.amount;
                proceed.innerHTML = "Pay £ " + parseFloat(paramAmount).toFixed(2);
                $('#amount').val('£ ' + paramAmount);
                paramBusinessId = data.business_id;
                paramCurrency = 'gbp';
                paramBusinessName = data.name;
                paramSecretKey = data.secretkey;
                paramPublishKey = data.publishkey;
                paramDescription = data.description;
                paramDescriptor = data.descriptor;
                paymentheaderText.innerHTML = paramBusinessName;
                if (paramStatus == 'Success') {
                    document.getElementById("payment-form").style.display = "none";
                    document.getElementById("link-payment-form").classList.remove('d-none');
                    document.getElementById("link-payment-form").style.display = "block";
                    return false;
                }
            } else {
                messageText.innerHTML = "Invalid payment URL";
                messageText.classList.remove("invisible");
                proceed.classList.add("disabled");
            }
        });
}

function showMessage(message, status, data = null) {
    messageText.innerHTML = message;
    messageText.classList.remove("invisible");
    if (status == "success") {
        keyval = btoa("success_amount=" + data.amount + "&after_url=" + paramSuccessUrl + "&transaction_id=" + data.id + "&business_name=" + paramBusinessName + "&business_descriptor=" + paramDescriptor);

        var bodyParams = {}
        bodyParams['status'] = "Success";
        bodyParams['payment_id'] = data.id;
        return fetch(baseUrl + "tiffintom/payment-message/" + paramId + "/change-status", {
                method: "POST",
                headers: {
                    "Content-Type": "application/json",
                    "link": "direct",
                },
                body: JSON.stringify(bodyParams),
            })
            .then(function (result) {
                return result.json();
            })
            .then(function (data) {
                window.location.href = baseUrl + "epos-payment-success?status=" + keyval;
            });
    } else if (status == "error") {
        messageText.classList.add("alert-danger");
        if (isEmail(document.getElementById('email').value) == true) {
            counterText.classList.remove("invisible");
            document.getElementById("click").href = paramFailedUrl;
            location.reload();
        }

    } else {}
}
