<?php ?>
<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>EPOS Connection</title>
    <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.0.2/dist/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-EVSTQN3/azprG1Anm3QDgpJLIm9Nao0Yz1ztcQTwFspd3yD65VohhpuuCOmLASjC" crossorigin="anonymous">
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.0.2/dist/js/bootstrap.bundle.min.js" integrity="sha384-MrcW6ZMFYlzcLA8Nl+NtUVF0sA7MsXsP1UyJoMp4YLEuNSfAP+JcXn/tWtIaxVXM" crossorigin="anonymous">
    </script>
    <script src="https://js.stripe.com/terminal/v1/"></script>

</head>

<body style="padding: 10px; margin:auto 0px">
    <div class="container">
        <div class="card shadow rounded-5">
            <div class="card-header">
                <h5 class="text-center">Pay using your card</h5>
            </div>
            <div class="card-body w-100">

                <h2 id="amount" class="text-center alert alert-success m-4">£ 0.00</h2>

                <button type="button" class="d-flex align-items-center justify-content-center disabled btn btn-primary text-center w-100 shadow rounded-5 my-3" id="pay_now_button" onclick="payNowButton()">
                    <div class="spinner-border spinner-border-sm mx-2 d-none" id="loader" role="status">
                        <span class="visually-hidden">Loading...</span>
                    </div>
                    <span id="pay_now_button_text">Please wait</span>
                </button>

                <div id="card_readers" class="d-none">

                </div>
                <button type="button" class="d-none d-flex align-items-center justify-content-center disabled btn btn-primary text-center w-100 shadow rounded-5 my-3" id="response_button" onclick="finish()">
                    <span id="response_button_text">Payment Successful</span>
                </button>
            </div>
        </div>
        <p id="message" class="mt-1 alert alert-secondary p-2 invisible text-center rounded-bottom border-top-0 mx-2 ">
            Please show your
            card
        </p>
        <button type="button" class="d-none d-flex align-items-center justify-content-center  btn btn-primary text-center w-100 shadow rounded-5 my-3" id="action_button" onclick="action()">

            <span id="action_button_text">Payment Successful</span>
        </button>
    </div>
    <p id="log"></p>
    <button type="button" id="btn_token" onclick="fetchConnectionToken()" class="btn btn-primary d-none">Primary</button>
    <button type="button" id="btn_discover" onclick="discoverReaders()" class="btn btn-primary d-none">Discover</button>
    <!-- <button type="button" id="btn_discover" onclick="discoverReaders()" class="btn btn-primary">Discover</button> -->
    <div class="p-2" id="readers">

    </div>

    <div id="payments" class="d-none p-2">
        <div class="input-group mb-3">
            <span class="input-group-text">£</span>
            <input type="number" min="0" id="amount" class="form-control" aria-label="Amount (to the nearest pound)">
            <span class="input-group-text">.00</span>
        </div>
        <button type="button" id="btn_pay" onclick="pay()" class="btn btn-success">Pay</button>
    </div>
    <script src="./cad-reader-payment.js"></script>
</body>

</html>