<!DOCTYPE html>
<html>

<head>
    <title>Epos Payment</title>
    <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.0.2/dist/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-EVSTQN3/azprG1Anm3QDgpJLIm9Nao0Yz1ztcQTwFspd3yD65VohhpuuCOmLASjC" crossorigin="anonymous">
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.0.2/dist/js/bootstrap.bundle.min.js" integrity="sha384-MrcW6ZMFYlzcLA8Nl+NtUVF0sA7MsXsP1UyJoMp4YLEuNSfAP+JcXn/tWtIaxVXM" crossorigin="anonymous">
    </script>
    <script src="https://js.stripe.com/v3"></script>
</head>

<body style="padding: 10px;padding-top: 1.8cm; margin:auto 0px">

    <div class="container" style="padding-top: 2cm;">
        <div class="card shadow rounded-5">
            <div class="card-header">
                <h5 class="text-center">
                    <span id="payment-header"></span>
                </h5>
            </div>
            <div class="card-body w-100">
                <form action="" method="post" id="payment-form">
                    <p class="text-center">Please click the button below to confirm your payment.</p>
                    <input type="hidden" value="addCard" name="action">
                    <input type="hidden" min="0" id="amount" class="form-control" aria-label="Amount (to the nearest pound)">
                    <div class="form-row" style="padding-bottom: 15px;">
                        <div class='col-xs-12 col-md-12 form-group pb-3'>
                            <label class='control-label'>Email</label>
                            <input class='form-control' placeholder='Enter Your Email' name="email" id="email" type='text'>
                        </div>
                        <div id="card-element" class="body-box-shadow py-3" style='box-shadow: 0 2px 4px #0000001a, 0 8px 16px #0000001a;height: 2.6em !important; padding: .8em !important;'>
                        </div>
                        <div id="card-errors" role="alert"></div>
                    </div>
                    <div class="text-center">
                        <button class="btn" style="border: none !important;background-color: #3a606e;color:#fff" id="proceed">
                            <div class="spinner-border spinner-border-sm mx-2 d-none" style="color:#fff" id="loader" role="status">
                                <span class="visually-hidden">Loading...</span>
                            </div>
                            Pay Now <span id="amountText"> </span>
                        </button>
                    </div>
                </form>
                <div class="d-none" id="link-payment-form">
                    <div class="alert alert-success" id="successAlert">
                        <strong>Thank you! </strong>Your payment has been processed Successfully.
                    </div>
                </div>
                <button type="button" class="d-none d-flex align-items-center justify-content-center disabled btn btn-primary text-center w-100 shadow rounded-5 my-3" id="response_button" onclick="finish()">
                    <span id="response_button_text">Payment Successful</span>
                </button>
            </div>
        </div>

        <p id="message" class="mt-1 alert alert-secondary p-2 invisible text-center rounded-bottom border-top-0 mx-2 ">
            Please show your card
        </p>
        <p id="counter" class="mt-1 alert alert-secondary p-2 invisible text-center rounded-bottom border-top-0 mx-2 ">
            this will be redirect on site <span id="count"></span> sec. if you want now <a href="" id="click">click here</a>
        </p>
    </div>
    <script src="./epos-payment.js"></script>

</body>
<script>
    function isEmail(email) {
        var EmailRegex = /^([a-zA-Z0-9_.+-])+\@(([a-zA-Z0-9-])+\.)+([a-zA-Z0-9]{2,4})+$/;
        return EmailRegex.test(email);
    }
</script>

</html>