<html>

<head>
    <title>Invoice Payment</title>
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <link href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.0/css/bootstrap.min.css" rel="stylesheet"
        id="bootstrap-css">
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.0/js/bootstrap.min.js"></script>
    <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.0.2/dist/css/bootstrap.min.css" rel="stylesheet"
        integrity="sha384-EVSTQN3/azprG1Anm3QDgpJLIm9Nao0Yz1ztcQTwFspd3yD65VohhpuuCOmLASjC" crossorigin="anonymous">
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.0.2/dist/js/bootstrap.bundle.min.js"
        integrity="sha384-MrcW6ZMFYlzcLA8Nl+NtUVF0sA7MsXsP1UyJoMp4YLEuNSfAP+JcXn/tWtIaxVXM" crossorigin="anonymous">
    </script>
    <script src="https://code.jquery.com/jquery-1.11.1.min.js"></script>

    <!-- If you're using Stripe for payments -->
    <style>
    .business-logo {
        width: 170px !important;
    }

    .form-control {
        font-size: 16px;
    }

    .form-control {
        font-size: 25px !important;
        height: 45px !important;
        border-radius: 6px !important;
    }

    .hr {
        border: none;
        border-top: 2px dashed #000;
        color: #000;
        width: 100%;
    }

    .bold {
        font-weight: bold !important;
    }
    </style>
</head>

<body>
    <div class="container-fluid">
        <div class="row">

            <div class="text-center" style="padding-top: 10px;padding-bottom: 10px;">
                @if($business->image_url != '')
                <img class="business-logo" src="{{$business->image_url}}" alt="Business Logo">
                @endif
            </div>

            <div class="col-12 text-center" style="font-size: 15px;">
                @if($business->door_no != '' || $business->address != '')
                <span class="bold" style="padding-top: 5px;">
                    {{$business->door_no}} {{$business->address}}
                </span><br>
                @endif
                @if($business->city != '' || $business->state != '' || $business->postcode != '')
                <span class="bold" style="padding-top: 5px;">
                    {{$business->city}} {{$business->state}} {{$business->postcode}}
                </span><br>
                @endif
                @if($business->email != '')
                <span class="bold" style="padding-top: 5px;">
                    {{$business->email}}
                </span><br>
                @endif
                @if($business->contact_numbers != '')
                <span class="bold" style="padding-top: 5px;">
                    <a href="tel:{{$business->contact_numbers}}">{{$business->contact_numbers}}</a>
                </span><br>
                @endif
            </div>

            <div class="col-12 text-center bold" style="font-size: 20px;padding-top: 15px;padding-bottom:10px">
                PAYMENT RECEIPT
            </div>

            <div class="col-12 hr"></div>

            <div class="col-12 text-center bold" style="font-size: 22px;padding-top: 10px;padding-bottom:15px">
                {{$stripeTransactions->amount / 100}} {{strtoupper($stripeTransactions->currency)}}
            </div>

            @if($stripeTransactions->card_brand != '')
            <div class="row py-2" style="padding-left:15px;padding-right:15px">
                <div class="col-3 bold" style="font-size: 18px;">
                    Card
                </div>
                <div class="col-9" style="font-size: 18px;">
                    {{$stripeTransactions->card_brand}}
                </div>
            </div>
            @endif

            @if($stripeTransactions->id != '')
            <div class="row py-2" style="padding-left:15px;padding-right:15px">
                <div class="col-3 bold" style="font-size: 18px;">
                    Account
                </div>
                <div class="col-9" style="font-size: 18px;">
                    {{$stripeTransactions->id}}
                </div>
            </div>
            @endif

            @if($stripeTransactions->txn_id != '')
            <div class="row py-2" style="padding-left:15px;padding-right:15px">
                <div class="col-3 bold" style="font-size: 18px;">
                    TID
                </div>
                <div class="col-9" style="font-size: 18px;">
                    {{$stripeTransactions->txn_id}}
                </div>
            </div>
            @endif

            <div class="row py-2" style="padding-left:15px;padding-right:15px">
                <div class="col-3 bold" style="font-size: 18px;">
                    Status
                </div>
                @if($stripeTransactions->reporting_category == 'charge')
                <div class="col-9" style="font-size: 18px;">
                    Approved
                </div>
                @else
                <div class="col-9" style="font-size: 18px;">
                    Refund
                </div>
                @endif
            </div>

            <div class="col-12 text-center" style="font-size: 16px;padding-top: 10px;padding-bottom:15px">
                <span style="padding-top: 5px;">
                    Please Retain Receipt
                </span><br>
                <span style="padding-top: 5px;">
                    For Your Record
                </span><br>
                <span style="padding-top: 5px;">
                    {{date('d-m-Y h:i A', strtotime($stripeTransactions->transaction_date_time))}}
                </span><br>
            </div>

            <div class="col-12 hr"></div>

            <div class="col-12 text-center" style="font-size: 16px;padding-top: 10px;">
                @if($business->footer_a != '')
                <span style="padding-top: 5px;">
                    {{$business->footer_a}}
                </span><br>
                @endif
                @if($business->footer_b != '')
                <span style="padding-top: 5px;">
                    {{$business->footer_b}}
                </span>
                @endif
            </div>

        </div>
    </div>
</body>

</html>