<html>

<head>
    <title>Epos Payment</title>
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <link href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.0/css/bootstrap.min.css" rel="stylesheet" id="bootstrap-css">
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.0/js/bootstrap.min.js"></script>
    <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.0.2/dist/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-EVSTQN3/azprG1Anm3QDgpJLIm9Nao0Yz1ztcQTwFspd3yD65VohhpuuCOmLASjC" crossorigin="anonymous">
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.0.2/dist/js/bootstrap.bundle.min.js" integrity="sha384-MrcW6ZMFYlzcLA8Nl+NtUVF0sA7MsXsP1UyJoMp4YLEuNSfAP+JcXn/tWtIaxVXM" crossorigin="anonymous">
    </script>
    <script src="https://code.jquery.com/jquery-1.11.1.min.js"></script>

    <!-- If you're using Stripe for payments -->
    <script type="text/javascript" src="https://js.stripe.com/v3/"></script>
    <style>
        /* Blue outline on focus */
        .StripeElement--focus {
            border-color: #80BDFF;
        }

        /* Can't see what I type without this */
        #card-number.form-control,
        #card-cvc.form-control,
        #card-exp.form-control {
            display: block;
        }

        .business-logo {
            width: 170px !important;
        }

        .amount-label {
            color: hsla(0, 0%, 10%, .6);
            font-weight: 600;
            font-size: 16px;
        }

        #amount {
            font-size: 36px !important;
            height: 56px !important;
            border-radius: 6px;
        }

        #payment-submit {
            font-size: 25px;
            font-weight: 500;
            border: none !important;
            background-color: #3a606e;
            color: #fff;
            position: fixed;
            display: -webkit-box;
            bottom: 0px;
            z-index: 10;
            display: flex;
            justify-content: space-around;
        }

        .fm-lable {
            color: hsla(0, 0%, 10%, .7);
            font-weight: 500;
            font-size: 17px;
        }

        .form-control {
            font-size: 15px;
        }

        #card-errors {
            font-size: 15px;
            font-weight: 500;
        }

        #successAlert {
            font-size: 16px;
        }

        .form-control {
            font-size: 25px !important;
            height: 45px !important;
            border-radius: 6px !important;
        }
    </style>
</head>

<body>
    <div class="container-fluid">
        <div class="row">
            <form id="payment-form">

                <div class="text-center py-5">
                    <img class="business-logo" src="" onerror="this.src='./images/logo-primary.png';" alt="Business Logo">
                    <h5 id="payment-header" class="pt-3"></h5>
                </div>

                <div class="col-12 form-group text-center">
                    <label for="amount" class="amount-label">PAY</label>
                    <div class="input-group">
                        <input type="text" class="form-control text-center" name="amount" id="amount" value="0" readonly>
                    </div>
                </div>

                <div class="col-12 form-group pt-3">
                    <label for="name" class="fm-lable">Email</label>
                    <div class="input-group">
                        <input type="text" class="form-control rounded" id="email">
                    </div>
                </div>

                <div class="col-12 form-group pt-1">
                    <label for="card-number" class="fm-lable">Credit Card Number</label>
                    <div class="input-group">
                        <span id="card-number" class="form-control rounded">
                        </span>
                    </div>
                </div>
                <div class="d-flex justify-content-between pt-1">
                    <div class="col-6 form-group">
                        <label for="card-exp" class="fm-lable">Expiration</label>
                        <div class="input-group" style="width: 97%;">
                            <span id="card-exp" class="form-control rounded">
                            </span>
                        </div>
                    </div>
                    <div class="col-6 form-group">
                        <label for="card-cvc" class="fm-lable">CVC Number</label>
                        <div class="input-group" style="width: 97%;float: right;">
                            <span id="card-cvc" class="form-control rounded">
                            </span>
                        </div>
                    </div>
                </div>
                <div class="col-12 form-group">
                    <label for="postalCode" class="fm-lable">Postal Code / Zipcode</label>
                    <div class="input-group">
                        <span id="postalCode" class="form-control rounded">
                        </span>
                    </div>
                </div>

                <div id="card-errors" class="text-danger pt-0 pb-3" role="alert"></div>
                <div class="mt-3 mb-5"></div>
                <!-- <div class="col-12 form-group text-center pt-1"> -->
                <button id="payment-submit" class="btn btn-primary w-100 ">
                    <div class="spinner-border spinner-border-sm mx-2 d-none" style="color:#fff" id="loader" role="status">
                        <span class="visually-hidden">Loading...</span>
                    </div>
                    Pay
                </button>
                <!-- </div> -->

            </form>
            <div class="d-none pt-5" id="link-payment-form">
                <div class="alert alert-success" id="successAlert">
                    <strong>Thank you! </strong>Your payment has been processed Successfully.
                </div>
            </div>
        </div>
    </div>
    <script type="text/javascript" src="./payment.js"></script>

</body>

</html>