<?php

/*
|--------------------------------------------------------------------------
| API Routes
|--------------------------------------------------------------------------
*/

use App\BusinessTip;
use App\Events\Event;
use App\Events\SendSocketMessage;
use App\Http\Controllers\PayoutReportController;
use App\Jobs\PrintJob;
use App\Services\CaxtonFxService;
use Carbon\Carbon;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Log;
use Illuminate\Support\Facades\Queue;
use Stripe\StripeClient;
use GuzzleHttp\Client;
use Textmagic\Services\TextmagicRestClient;

$router->get('/', function (Request $reqq) use ($router) {

    $stripe = new \Stripe\StripeClient(
        'sk_test_5J87rf5MsZJYIK36Jt9bveuI'
    );

    $stripe1 = new \Stripe\StripeClient(
        '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'
    );

    return $carbon = Carbon::today();

    $currentDayOfWeek = $carbon->dayOfWeek;
    if ($currentDayOfWeek <= 1) {
        $from_date = date('Y-m-d', strtotime('tuesday previous week', $carbon->getTimestamp()));
        $to_date = date('Y-m-d', strtotime('monday this week', $carbon->getTimestamp()));
    } else {
        $from_date = date('Y-m-d', strtotime('tuesday this week', $carbon->getTimestamp()));
        $to_date = date('Y-m-d', strtotime('monday next week', $carbon->getTimestamp()));
    }
    return ['current_invoice_cycle' => ['from_date' => $from_date, 'to_date' => $to_date]];

    function nextDate($start_date, $interval_days, $output_format)
    {
        $start = strtotime($start_date);
        $end = strtotime(date('Y-m-d'));
        $days_ago = ($end - $start) / 24 / 60 / 60;
        if ($days_ago < 0) return date($output_format, $start);
        $remainder_days = $days_ago % $interval_days;
        if ($remainder_days > 0) {
            $new_date_string = "+" . ($interval_days - $remainder_days) . " days";
        } else {
            $new_date_string = "today";
        }
        return date($output_format, strtotime($new_date_string));
    }
    return nextDate('20210717', 28, 'Ymd');
});

$router->group(['prefix' => 'dashboard'], function () use ($router) {
    $router->get('', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'Dashboard1Controller@index']);
    $router->get('domain-expire', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'Dashboard1Controller@domain_expire_business']);
    $router->get('admin-report', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'ExtraController@admin_report']);
    $router->get('bank-report', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'ExtraController@bank_report']);
    $router->get('bank-report/export', ['uses' => 'ExtraController@bank_export']);
    $router->get('financial-report', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'ExtraController@financial_report']);
    $router->get('financial-report/export', ['uses' => 'ExtraController@export']);
});

$router->group(['prefix' => 'stripe'], function () use ($router) {
    $router->get('transactions', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'ExtraController@transactions']);
    $router->post('payment-intent', ['middleware' => 'role:admin,epos_admin,user', 'middleware' => 'role:guest,epos_admin,admin', 'uses' => 'Connect\StripeController@payment_intent']);
});

$router->group(['prefix' => 'restaurants'], function () use ($router) {
    $router->get('{restaurant_id}', ['uses' => 'RestaurantController@gallery_fetch']);
});
$router->group(['prefix' => 'online-orders'], function () use ($router) {
    $router->get('', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'OnlineOrderController@index']);
    $router->get('fetch', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'OnlineOrderController@fetch']);
    $router->get('history', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'OnlineOrderController@history']);
    $router->post('archive', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'OnlineOrderController@archive']);
    $router->post('unarchive', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'OnlineOrderController@unarchive']);
    $router->delete('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'OnlineOrderController@delete']);
    $router->post('{id}/refund', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'OnlineOrderController@refund']);
    // $router->get('fetch', ['uses' => 'ExtraController@getOrders']);
    // $router->get('payments-history', ['uses' => 'ExtraController@getPaypalTransactionHistory']);
});
$router->group(['prefix' => 'admins'], function () use ($router) {
    $router->get('', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'AdminController@index']);
    $router->post('', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'AdminController@create']);
    $router->post('login', ['uses' => 'AdminController@login']);
    $router->post('confirm-otp', ['uses' => 'AdminController@confirm_otp']);
    $router->get('me', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'AdminController@show']);

    $router->get('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'AdminController@show']);
    $router->post('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'AdminController@update']);
    $router->delete('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'AdminController@delete']);
    $router->post('{id}/enable', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'AdminController@enable']);
    $router->post('{id}/disable', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'AdminController@disable']);

    $router->post('me/password', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'AdminController@password']);
});

$router->group(['prefix' => 'users'], function () use ($router) {
    $router->get('', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'UserController@index']);
    $router->get('mini', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'UserController@mini']);
    $router->post('', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'UserController@create']);
    $router->post('direct-create', ['middleware' => 'role:admin,guest', 'uses' => 'UserController@direct_create']);

    $router->post('login', ['uses' => 'UserController@login']);
    $router->post('reset-password', ['uses' => 'UserController@resetPassword']);
    $router->post('forget-password', ['uses' => 'UserController@forgetPassword']);
    $router->post('me/password', ['middleware' => 'role:user', 'uses' => 'UserController@password']);

    $router->get('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'UserController@show']);
    $router->post('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'UserController@update']);
    $router->post('{id}/direct-update', ['uses' => 'UserController@direct_update']);
    $router->post('{id}/all-update', ['uses' => 'UserController@merchant_user_update']);
    $router->post('{id}/direct-resend-otp', ['uses' => 'UserController@direct_resend_otp']);
    $router->post('{id}/change-password', ['middleware' => 'role:admin,epos_admin,user,guest', 'uses' => 'UserController@chage_password']);
    $router->post('{id}/send-otp-both', ['uses' => 'UserController@send_otp_both']);
    $router->post('{id}/verify-otp-both', ['uses' => 'UserController@verify_otp']);
    $router->post('{id}/password-check', ['uses' => 'UserController@password_check']);
    $router->post('{id}/enable', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'UserController@enable']);
    $router->post('{id}/disable', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'UserController@disable']);
    $router->delete('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'UserController@delete']);

    // User business
    $router->get('{user_id}/businesses', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'UserController@businesses_index']);
    $router->post('{user_id}/businesses', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'UserController@businesses_create']);
    $router->post('{user_id}/businesses/{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'UserController@businesses_update']);
    $router->delete('{user_id}/businesses/{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'UserController@businesses_delete']);

    // User Id Proofs
    $router->get('{user_id}/proofs', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'UserController@proofs_index']);
    $router->post('{user_id}/proofs', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'UserController@proofs_create']);
    $router->post('{user_id}/proofs/{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'UserController@proofs_update']);
    $router->delete('{user_id}/proofs/{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'UserController@proofs_delete']);

    // User bank details
    $router->get('{user_id}/bank-details', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'UserController@bank_details_index']);
    $router->post('{user_id}/bank-details', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'UserController@bank_details_create']);
    $router->post('{user_id}/bank-details/{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'UserController@bank_details_update']);
    $router->post('{user_id}/bank-details/{id}/default', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'UserController@bank_details_default']);
    $router->delete('{user_id}/bank-details/{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'UserController@bank_details_delete']);

    // User paypal details
    $router->get('{user_id}/paypal-details', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'UserController@paypal_details_index']);
    $router->post('{user_id}/paypal-details', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'UserController@paypal_details_create']);
    $router->post('{user_id}/paypal-details/{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'UserController@paypal_details_update']);
    $router->post('{user_id}/paypal-details/{id}/default', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'UserController@paypal_details_default']);
    $router->delete('{user_id}/paypal-details/{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'UserController@paypal_details_delete']);

    // Report
    $router->get('{user_id}/report', ['uses' => 'PayoutReportController@quick_report']);
    $router->get('{user_id}/report/{business_id}', ['uses' => 'ResellerPayoutReportController@quick_report']);

    // User Payout charges
    $router->get('{user_id}/payout-charges', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'UserController@payout_charges_index']);
    $router->post('{user_id}/payout-charges', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'UserController@payout_charges_create']);
    $router->post('{user_id}/payout-charges/{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'UserController@payout_charges_update']);
    $router->delete('{user_id}/payout-charges/{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'UserController@payout_charges_delete']);


    // User payout invoices
    $router->get('{user_id}/payout-invoices', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'UserController@payout_invoice_index']);
    $router->get('{user_id}/payout-invoices/groups', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'UserController@payout_invoice_groups']);
    $router->get('{user_id}/payout-invoices/groups/{id}', ['uses' => 'UserController@payout_invoice_group_show']);
    $router->get('{user_id}/payout-invoices/{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'UserController@payout_invoice_show']);
    $router->get('{user_id}/payout-invoices/{id}/download', ['uses' => 'UserController@payout_invoice_download']);
    $router->post('{user_id}/payout-invoices', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'UserController@payout_invoice_create']);
    $router->delete('{user_id}/payout-invoices/{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'UserController@payout_invoice_delete']);

    // User payout_requests
    $router->get('{user_id}/payout-requests', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'UserController@payout_requests_index']);
    $router->post('{user_id}/payout-requests', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'UserController@payout_requests_create']);
    $router->get('{user_id}/payout-requests/{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'UserController@payout_requests_show']);
    $router->post('{user_id}/payout-requests/{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'UserController@payout_requests_update']);
    $router->delete('{user_id}/payout-requests/{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'UserController@payout_requests_delete']);

    // Reseller Payout Requests
    $router->get('{user_id}/reseller-payout-requests', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'UserController@reseller_payout_requests_index']);
    $router->post('{user_id}/reseller-payout-requests', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'UserController@reseller_payout_requests_create']);
    $router->get('{user_id}/reseller-payout-requests/export', ['uses' => 'UserController@reseller_payout_requests_export']);
    $router->get('{user_id}/reseller-payout-requests/{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'UserController@reseller_payout_requests_show']);
    $router->post('{user_id}/reseller-payout-requests/{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'UserController@reseller_payout_requests_update']);
    $router->delete('{user_id}/reseller-payout-requests/{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'UserController@reseller_payout_requests_delete']);

    // User passbook
    $router->get('{user_id}/passbook', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'UserController@passbook_index']);
    $router->post('{user_id}/passbook', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'UserController@passbook_create']);
    $router->get('{user_id}/passbook/{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'UserController@passbook_show']);
    $router->post('{user_id}/passbook/{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'UserController@passbook_update']);
    $router->delete('{user_id}/passbook/{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'UserController@passbook_delete']);


    // User misc charges
    $router->get('{user_id}/misc-charges', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'UserController@misc_charges_index']);
    $router->post('{user_id}/misc-charges', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'UserController@misc_charges_create']);
    $router->post('{user_id}/misc-charges/{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'UserController@misc_charges_update']);
    $router->delete('{user_id}/misc-charges/{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'UserController@misc_charges_delete']);
});

$router->group(['prefix' => 'contact-groups'], function () use ($router) {
    $router->get('', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'ContactGroupController@index']);
    $router->post('', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'ContactGroupController@create']);

    $router->get('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'ContactGroupController@show']);
    $router->post('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'ContactGroupController@update']);
    $router->delete('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'ContactGroupController@delete']);
});
$router->group(['prefix' => 'user-contacts'], function () use ($router) {
    $router->get('', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'UserContactController@index']);
    $router->post('', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'UserContactController@create']);

    $router->get('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'UserContactController@show']);
    $router->post('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'UserContactController@update']);
    $router->delete('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'UserContactController@delete']);
});

$router->group(['prefix' => 'businesses'], function () use ($router) {
    $router->get('', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@index']);
    $router->get('mini', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@mini']);
    $router->get('company-number/{id}', ['uses' => 'BusinessController@fetch_company_detail']);
    $router->get('extension-account/{id}', ['uses' => 'BusinessController@extension_account']);
    $router->post('', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@create']);
    $router->post('direct-create', ['uses' => 'BusinessController@direct_create']);
    $router->get('restaurants', ['uses' => 'BusinessController@fetchRestaurants']);

    $router->get('{id}', ['middleware' => 'role:admin,epos_admin,user,guest', 'uses' => 'BusinessController@show']);
    $router->post('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@update']);
    $router->post('direct-update/{id}', ['middleware' => 'role:admin,epos_admin,user,guest', 'uses' => 'BusinessController@direct_update']);

    // To generate Epos Database for selected Business
    $router->post('{id}/schema', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@schema']);

    // To load data into Epos Database for selected Business
    $router->post('{id}/load-data', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@load_data']);

    // Empty all tables from epos database for selected business
    $router->post('{id}/reset-schema', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@reset_schema']);

    $router->post('{id}/enable', ['middleware' => 'role:admin,epos_admin,user,guest', 'uses' => 'BusinessController@enable']);
    $router->post('{id}/disable', ['middleware' => 'role:admin,epos_admin,user,guest', 'uses' => 'BusinessController@disable']);
    $router->delete('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@delete']);

    // Business EPOS Related
    $router->get('{business_id}/epos-devices', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@epos_devices']);
    $router->post('{business_id}/epos-devices/{id}/enable-weborder', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@epos_enable_device_weborder']);
    $router->post('{business_id}/epos-devices/{id}/enable-callerid', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@epos_enable_device_callerid']);
    $router->post('{business_id}/epos-devices/{id}/enable-sunmi-printer', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@epos_enable_device_sunmi_printer']);
    $router->post('{business_id}/epos-devices/{id}/tap-to-pay', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@epos_device_tap_pay']);
    $router->post('{business_id}/epos-devices/{id}/enable', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@epos_enable_device']);
    $router->post('{business_id}/epos-devices/{id}/disable', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@epos_disable_device']);
    $router->delete('{business_id}/epos-devices/{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@epos_delete']);
    $router->get('{business_id}/epos-settings', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@epos_settings']);
    $router->post('{business_id}/epos-settings/setting-bulk', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@epos_settings_update_bulk']);
    $router->post('{business_id}/epos-settings/{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@epos_settings_update']);

    // Business bank details
    $router->get('{business_id}/bank-details', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@bank_details_index']);
    $router->post('{business_id}/bank-details', ['middleware' => 'role:admin,epos_admin,user,guest', 'uses' => 'BusinessController@bank_details_create']);
    $router->post('{business_id}/bank-details/{id}', ['middleware' => 'role:admin,epos_admin,user,guest', 'uses' => 'BusinessController@bank_details_update']);
    $router->post('{business_id}/bank-details/{id}/default', ['middleware' => 'role:admin,epos_admin,user,guest', 'uses' => 'BusinessController@bank_details_default']);
    $router->delete('{business_id}/bank-details/{id}', ['middleware' => 'role:admin,epos_admin,user,guest', 'uses' => 'BusinessController@bank_details_delete']);

    // Business paypal details
    $router->get('{business_id}/paypal-details', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@paypal_details_index']);
    $router->post('{business_id}/paypal-details', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@paypal_details_create']);
    $router->post('{business_id}/paypal-details/{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@paypal_details_update']);
    $router->post('{business_id}/paypal-details/{id}/default', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@paypal_details_default']);
    $router->delete('{business_id}/paypal-details/{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@paypal_details_delete']);

    // User Business details
    $router->get('{business_id}/users', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@users_index']);
    $router->post('{business_id}/users', ['middleware' => 'role:admin,guest', 'uses' => 'BusinessController@users_create']);
    $router->post('{business_id}/users/{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@users_update']);
    $router->delete('{business_id}/users/{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@users_delete']);

    // Business online orders
    $router->get('{business_id}/online-orders', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@online_orders_index']);
    $router->post('{business_id}/online-orders/archive', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@online_orders_archive']);
    $router->post('{business_id}/online-orders/unarchive', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@online_orders_unarchive']);
    $router->get('{business_id}/online-orders/{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@online_orders_show']);

    // Business stripe transactions
    $router->get('{business_id}/stripe-transactions', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@stripe_transactions_index']);
    $router->post('{business_id}/stripe-transactions', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@stripe_transactions_create']);
    $router->post('{business_id}/stripe-transactions/transfer', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@stripe_transactions_transfer']);
    $router->get('{business_id}/stripe-transactions/connect', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@stripe_transactions_connect']);
    $router->post('{business_id}/stripe-transactions/archive', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@stripe_transactions_archive']);
    $router->post('{business_id}/stripe-transactions/unarchive', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@stripe_transactions_unarchive']);
    $router->get('{business_id}/stripe-transactions/{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@stripe_transactions_show']);
    $router->get('{business_id}/stripe-transactions/retrive/{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@retrive_stripe_transactions_show']);

    //business paypal transactions
    $router->get('{business_id}/paypal-transactions', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@paypal_transactions_index']);
    $router->post('{business_id}/paypal-transactions/archive', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@paypal_transactions_archive']);
    $router->post('{business_id}/paypal-transactions/unarchive', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@paypal_transactions_unarchive']);
    $router->get('{business_id}/paypal-transactions/{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@paypal_transactions_show']);

    // Business Country wise commissions
    $router->get('{business_id}/country-commissions', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@country_commissions_index']);
    $router->post('{business_id}/country-commissions', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@country_commissions_create']);
    $router->post('{business_id}/country-commissions/{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@country_commissions_update']);
    $router->delete('{business_id}/country-commissions/{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@country_commissions_delete']);

    // Business Payout charges
    $router->get('{business_id}/payout-charges', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@payout_charges_index']);
    $router->post('{business_id}/payout-charges', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@payout_charges_create']);
    $router->post('{business_id}/payout-charges/{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@payout_charges_update']);
    $router->delete('{business_id}/payout-charges/{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@payout_charges_delete']);


    // Card brand wise commissions
    $router->get('{business_id}/card-brand-commissions', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@card_brand_commissions_index']);
    $router->post('{business_id}/card-brand-commissions', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@card_brand_commissions_create']);
    $router->post('{business_id}/card-brand-commissions/{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@card_brand_commissions_update']);
    $router->delete('{business_id}/card-brand-commissions/{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@card_brand_commissions_delete']);

    // Business misc charges
    $router->get('{business_id}/misc-charges', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@misc_charges_index']);
    $router->post('{business_id}/misc-charges', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@misc_charges_create']);
    $router->post('{business_id}/misc-charges/{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@misc_charges_update']);
    $router->delete('{business_id}/misc-charges/{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@misc_charges_delete']);

    // Report
    $router->get('{business_id}/report', ['uses' => 'PayoutReportController@quick_report']);

    // Business payout invoices
    $router->get('{business_id}/payout-invoices', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@payout_invoice_index']);
    $router->get('{business_id}/payout-invoices/{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@payout_invoice_show']);
    $router->get('{business_id}/payout-invoices/{id}/download', ['uses' => 'BusinessController@payout_invoice_download']);
    $router->post('{business_id}/payout-invoices', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@payout_invoice_create']);
    $router->delete('{business_id}/payout-invoices/{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@payout_invoice_delete']);

    // Business notes
    $router->get('{business_id}/notes', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@notes_index']);
    $router->post('{business_id}/notes', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@notes_create']);
    $router->get('{business_id}/notes/{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@notes_show']);
    $router->post('{business_id}/notes/{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@notes_update']);
    $router->delete('{business_id}/notes/{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@notes_delete']);

    // Business devices
    $router->get('{business_id}/device-registrations', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@device_registrations_index']);
    $router->post('{business_id}/device-registrations', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@device_registrations_create']);
    $router->get('{business_id}/device-registrations/{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@device_registrations_show']);
    $router->post('{business_id}/device-registrations/{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@device_registrations_update']);
    $router->delete('{business_id}/device-registrations/{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@device_registrations_delete']);

    // Business printers
    $router->get('{business_id}/printers', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@printers_index']);
    $router->post('{business_id}/printers', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@printers_create']);
    $router->get('{business_id}/printers/{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@printers_show']);
    $router->post('{business_id}/printers/{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@printers_update']);
    $router->post('{business_id}/printers/{id}/enable', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@printers_enable']);
    $router->post('{business_id}/printers/{id}/disable', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@printers_disable']);
    $router->delete('{business_id}/printers/{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@printers_delete']);
    $router->post('{business_id}/printers/{id}/select', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@printer_select']);

    // Business card_readers
    $router->get('{business_id}/card-readers', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@card_readers_index']);
    $router->post('{business_id}/card-readers', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@card_readers_create']);
    $router->get('{business_id}/card-readers/{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@card_readers_show']);
    $router->post('{business_id}/card-readers/{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@card_readers_update']);
    $router->post('{business_id}/card-readers/{id}/enable', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@card_readers_enable']);
    $router->post('{business_id}/card-readers/{id}/disable', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@card_readers_disable']);
    $router->post('{business_id}/card-readers/{id}/enable-usb', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@card_readers_usb_enable']);
    $router->post('{business_id}/card-readers/{id}/disable-usb', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@card_readers_usb_disable']);
    $router->delete('{business_id}/card-readers/{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@card_readers_delete']);

    // Business card_readers
    $router->get('{business_id}/surcharges', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@surcharges_index']);
    $router->post('{business_id}/surcharges', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@surcharges_create']);
    $router->get('{business_id}/surcharges/{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@surcharges_show']);
    $router->post('{business_id}/surcharges/{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@surcharges_update']);
    $router->post('{business_id}/surcharges/{id}/enable', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@surcharges_enable']);
    $router->post('{business_id}/surcharges/{id}/disable', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@surcharges_disable']);
    $router->delete('{business_id}/surcharges/{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@surcharges_delete']);

    // Business payout_requests
    $router->get('{business_id}/payout-requests', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@payout_requests_index']);
    $router->post('{business_id}/payout-requests', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@payout_requests_create']);
    $router->get('{business_id}/payout-requests/{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@payout_requests_show']);
    $router->post('{business_id}/payout-requests/{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@payout_requests_update']);
    $router->delete('{business_id}/payout-requests/{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@payout_requests_delete']);

    // Business passbook
    $router->get('{business_id}/passbook', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@passbook_index']);
    $router->get('{business_id}/passbook/statement', ['uses' => 'BusinessController@passbook_statement']);
    $router->post('{business_id}/passbook', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@passbook_create']);
    $router->get('{business_id}/passbook/{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@passbook_show']);
    $router->post('{business_id}/passbook/{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@passbook_update']);
    $router->delete('{business_id}/passbook/{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@passbook_delete']);

    // Business Gallery
    $router->get('{business_id}/galleries', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@gallery_index']);
    $router->post('{business_id}/galleries', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@gallery_create']);
    $router->get('{business_id}/galleries/{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@gallery_show']);
    $router->post('{business_id}/galleries/{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@gallery_update']);
    $router->delete('{business_id}/galleries/{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@gallery_delete']);

    //Download Database
    $router->get('{business_id}/download-database', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@download_database']);
    //Upload Database
    $router->post('{business_id}/upload-database', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@upload_database']);

    // Business Card Holders
    $router->get('{business_id}/card-holders', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@card_holders_index']);
    $router->post('{business_id}/card-holders', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@card_holders_create']);
    $router->post('{business_id}/card-holders/{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@card_holders_update']);
    $router->delete('{business_id}/card-holders/{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@card_holders_delete']);

    // Business Issuing Cards
    $router->get('{business_id}/issuing-cards', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@issuing_cards_index']);
    $router->get('{business_id}/issuing-cards/reveal/{card_id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@issuing_cards_reveal']);
    $router->post('{business_id}/issuing-cards', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@issuing_cards_create']);
    $router->post('{business_id}/issuing-cards/{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@issuing_cards_update']);
    $router->delete('{business_id}/issuing-cards/{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@issuing_cards_delete']);
    $router->post('{business_id}/issuing-cards/{id}/enable', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@issuing_cards_enable']);
    $router->post('{business_id}/issuing-cards/{id}/disable', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@issuing_cards_disable']);

    // Business plans
    $router->get('{business_id}/plans', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@plans_index']);
    $router->post('{business_id}/plans', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@plans_create']);
    $router->get('{business_id}/plans/{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@plans_show']);
    $router->post('{business_id}/plans/{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@plans_update']);
    $router->delete('{business_id}/plans/{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@plans_delete']);

    // Business tips
    $router->get('{business_id}/tips', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@tips_index']);
    $router->post('{business_id}/tips', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@tips_create']);
    $router->get('{business_id}/tips/{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@tips_show']);
    $router->post('{business_id}/tips/{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@tips_update']);
    $router->delete('{business_id}/tips/{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@tips_delete']);

    // Business card wallet
    $router->get('{business_id}/card-wallets', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@card_wallets_index']);
    $router->post('{business_id}/card-wallets', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@card_wallets_create']);
    $router->get('{business_id}/card-wallets/{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@card_wallets_show']);
    $router->post('{business_id}/card-wallets/{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@card_wallets_update']);
    $router->delete('{business_id}/card-wallets/{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@card_wallets_delete']);
    $router->post('{business_id}/card-wallets/{id}/enable', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@card_wallets_enable']);
    $router->post('{business_id}/card-wallets/{id}/disable', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@card_wallets_disable']);

    // Business Stripe Bacs direct debit payments
    $router->get('{business_id}/bacs-debits', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@bacs_debit_index']);
    $router->post('{business_id}/bacs-debits', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@bacs_debit_create']);
    $router->get('{business_id}/bacs-debits/{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@bacs_debit_show']);
    $router->post('{business_id}/bacs-debits/payment', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@bacs_debit_payment']);
    $router->post('{business_id}/bacs-debits/{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@bacs_debit_update']);
    $router->delete('{business_id}/bacs-debits/{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BusinessController@bacs_debit_delete']);
});
$router->group(['prefix' => 'payout-invoices'], function () use ($router) {
    $router->get('', ['uses' => 'PayoutInvoiceController@index']);
    $router->get('multiple/export', ['uses' => 'PayoutInvoiceController@export_all']);
    $router->get('modern', ['uses' => 'PayoutInvoiceController@modern']);
    $router->get('modern/export', ['uses' => 'PayoutInvoiceController@export']);
    $router->get('wallet-load/export', ['uses' => 'PayoutInvoiceController@walletLoadExport']);
    $router->get('payment/export', ['uses' => 'PayoutInvoiceController@paymentExport']);
    $router->get('misc-report', ['uses' => 'PayoutInvoiceController@modern_misc']);
    $router->get('misc-report/export', ['uses' => 'PayoutInvoiceController@export_misc']);
    $router->get('report', ['uses' => 'PayoutReportController@all_business_quick_report']);
    $router->get('generate-report', ['uses' => 'PayoutReportController@generate_report']);
    $router->get('generate-report/{userId}', ['uses' => 'PayoutReportController@generateReportByUser']);
    $router->post('', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'PayoutInvoiceController@create']);
    $router->post('pay-bulk', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'PayoutInvoiceController@pay_bulk_invoices']);

    $router->get('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'PayoutInvoiceController@show']);
    $router->get('{id}/download', ['uses' => 'PayoutInvoiceController@download']);
    $router->post('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'PayoutInvoiceController@update']);
    $router->delete('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'PayoutInvoiceController@delete']);
});
$router->group(['prefix' => 'reseller-payout-invoices'], function () use ($router) {
    $router->get('', ['uses' => 'ResellerPayoutInvoiceController@index']);
    $router->get('groups', ['uses' => 'ResellerPayoutInvoiceController@groups']);
    $router->post('groups/pay-bulk', ['uses' => 'ResellerPayoutInvoiceController@group_pay_bulk_invoices']);
    $router->get('groups/{id}', ['uses' => 'ResellerPayoutInvoiceController@group_show']);
    $router->get('multiple/export', ['uses' => 'ResellerPayoutInvoiceController@export_all']);
    $router->get('modern', ['uses' => 'ResellerPayoutInvoiceController@modern']);
    $router->get('modern/export', ['uses' => 'ResellerPayoutInvoiceController@export']);
    $router->post('', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'ResellerPayoutInvoiceController@create']);
    $router->post('pay-bulk', ['uses' => 'ResellerPayoutInvoiceController@pay_bulk_invoices']);

    $router->get('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'ResellerPayoutInvoiceController@show']);
    $router->get('{id}/download', ['uses' => 'ResellerPayoutInvoiceController@download']);
    $router->post('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'ResellerPayoutInvoiceController@update']);
    $router->delete('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'ResellerPayoutInvoiceController@delete']);
});
$router->group(['prefix' => 'stripe-transactions'], function () use ($router) {
    $router->get('', ['uses' => 'StripeTransactionController@index']);
    $router->get('update-transactions', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'StripeTransactionController@updateTransactionDetails']);
    $router->post('', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'StripeTransactionController@create']);
    $router->post('webhook', ['uses' => 'StripeTransactionController@handleWebhook']);

    $router->get('retrive/{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'StripeTransactionController@showTransaction']);
    // Hard Refresh
    $router->get('transaction', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'StripeTransactionController@transaction']);

    //card-brand and country updte
    $router->get('charge-update', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'StripeTransactionController@saveBlankChargeDetail']);
    $router->get('miss-transaction', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'StripeTransactionController@missTransactions']);

    $router->get('update-dispute-status', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'StripeTransactionController@updateDisputeTransaction']);
    $router->post('transfer', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'StripeTransactionController@transfer']);

    $router->get('link-business', ['middleware' => 'role:admin,epos_admin,user', 'middleware' => 'role:admin,epos_admin,user', 'uses' => 'StripeTransactionController@link_business']);
    $router->post('link-business-bulk', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'StripeTransactionController@link']);

    $router->post('archive', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'StripeTransactionController@archive']);
    $router->post('unarchive', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'StripeTransactionController@unarchive']);

    $router->get('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'StripeTransactionController@show']);
    $router->post('{id}/refund', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'StripeTransactionController@refund']);
});

$router->group(['prefix' => 'pg'], function () use ($router) {
    $router->post('payment-intent', ['middleware' => 'role:epos_admin,admin,guest', 'uses' => 'Connect\StripeController@payment_intent']);
    $router->post('payment-intent-capture', ['middleware' => 'role:epos_admin,admin,guest', 'uses' => 'Connect\StripeController@capture_payment_intent']);
    $router->post('calculate-application-fee', ['middleware' => 'role:epos_admin,admin,epos_user', 'uses' => 'Connect\StripeController@calculate_application_fee']);
    // $router->post('card-reader-connection-token', ['middleware' => 'role:epos_admin,admin,epos_user', 'uses' => 'Connect\StripeController@card_reader_connection_token']);

    $router->get('registered-card-readers', ['uses' => 'ExtraController@registered_card_readers']);
    $router->post('card-reader-connection-token', ['uses' => 'ExtraController@card_reader_connection_token']);
    $router->post('card-reader-intent', ['uses' => 'ExtraController@card_reader_intent']);
    $router->post('card-reader-intent-capture', ['uses' => 'ExtraController@card_reader_intent_capture']);
});

$router->group(['prefix' => 'paypal-payments'], function () use ($router) {
    $router->get('', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'PaypalPaymentController@index']);
    $router->get('transaction', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'PaypalPaymentController@transaction']);

    $router->post('archive', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'PaypalPaymentController@archive']);
    $router->post('unarchive', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'PaypalPaymentController@unarchive']);
    $router->get('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'PaypalPaymentController@show']);
    $router->post('{id}/refund', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'PaypalPaymentController@refund']);
});
$router->group(['prefix' => 'id-proofs'], function () use ($router) {
    $router->get('', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'IdProofController@index']);
    $router->post('', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'IdProofController@create']);

    $router->get('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'IdProofController@show']);
    $router->post('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'IdProofController@update']);
    $router->delete('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'IdProofController@delete']);
});
$router->group(['prefix' => 'user-businesses'], function () use ($router) {
    $router->get('', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'UserBusinessController@index']);
    $router->post('', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'UserBusinessController@create']);

    $router->get('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'UserBusinessController@show']);
    $router->post('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'UserBusinessController@update']);
    $router->delete('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'UserBusinessController@delete']);
});
$router->group(['prefix' => 'bank-details'], function () use ($router) {
    $router->get('', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BankDetailController@index']);
    $router->post('', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BankDetailController@create']);

    $router->get('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BankDetailController@show']);
    $router->post('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BankDetailController@update']);
    $router->post('{id}/default', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BankDetailController@default']);
    $router->delete('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BankDetailController@delete']);
});
$router->group(['prefix' => 'countries'], function () use ($router) {
    $router->get('', ['uses' => 'CountryController@index']);
    $router->post('', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'CountryController@create']);

    $router->get('{id}', ['uses' => 'CountryController@show']);
    $router->post('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'CountryController@update']);
    $router->delete('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'CountryController@delete']);
});
$router->group(['prefix' => 'country-commissions'], function () use ($router) {
    $router->get('', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'CountryCommissionController@index']);
    $router->post('', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'CountryCommissionController@create']);

    $router->get('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'CountryCommissionController@show']);
    $router->post('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'CountryCommissionController@update']);
    $router->delete('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'CountryCommissionController@delete']);
});
$router->group(['prefix' => 'card-brands'], function () use ($router) {
    $router->get('', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'CardBrandController@index']);
    $router->post('', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'CardBrandController@create']);

    $router->get('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'CardBrandController@show']);
    $router->post('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'CardBrandController@update']);
    $router->delete('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'CardBrandController@delete']);
});
$router->group(['prefix' => 'printers'], function () use ($router) {
    $router->get('', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'PrinterController@index']);
    $router->post('', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'PrinterController@create']);

    $router->post('load-printers', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'PrinterController@load_printers']);

    $router->get('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'PrinterController@show']);
    $router->post('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'PrinterController@update']);
    $router->post('{id}/enable', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'PrinterController@enable']);
    $router->post('{id}/disable', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'PrinterController@disable']);
    $router->delete('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'PrinterController@delete']);
});
$router->group(['prefix' => 'device-registrations'], function () use ($router) {
    $router->get('', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'DeviceRegistrationController@index']);
    $router->post('', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'DeviceRegistrationController@create']);

    $router->post('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'DeviceRegistrationController@update']);
    $router->delete('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'DeviceRegistrationController@delete']);
});
$router->group(['prefix' => 'card-readers'], function () use ($router) {
    $router->get('', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'CardReaderController@index']);
    $router->post('', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'CardReaderController@create']);

    $router->get('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'CardReaderController@show']);
    $router->post('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'CardReaderController@update']);
    $router->post('{id}/enable', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'CardReaderController@enable']);
    $router->post('{id}/disable', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'CardReaderController@disable']);
    $router->delete('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'CardReaderController@delete']);
});
$router->group(['prefix' => 'payout-requests'], function () use ($router) {
    $router->get('', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'PayoutRequestController@index']);
    $router->get('/fetch', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'PayoutRequestController@fetch']);
    $router->get('/export', ['uses' => 'PayoutRequestController@export']);
    $router->post('bulk', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'PayoutRequestController@bulk_create']);
    $router->post('', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'PayoutRequestController@create']);
    $router->post('payout-summary', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'PayoutRequestController@create_summary']);

    $router->get('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'PayoutRequestController@show']);
    $router->post('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'PayoutRequestController@update']);
    $router->delete('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'PayoutRequestController@delete']);
});
$router->group(['prefix' => 'reseller-payout-requests'], function () use ($router) {
    $router->get('', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'ResellerPayoutRequestController@index']);
    $router->get('/fetch', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'ResellerPayoutRequestController@fetch']);
    $router->get('/export', ['uses' => 'ResellerPayoutRequestController@export']);
    $router->post('bulk', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'ResellerPayoutRequestController@bulk_create']);
    $router->post('', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'ResellerPayoutRequestController@create']);
    $router->get('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'ResellerPayoutRequestController@show']);
    $router->post('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'ResellerPayoutRequestController@update']);
    $router->delete('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'ResellerPayoutRequestController@delete']);
});
$router->group(['prefix' => 'passbook'], function () use ($router) {
    $router->get('', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'PassbookController@index']);

    $router->post('', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'PassbookController@create']);

    $router->get('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'PassbookController@show']);
    $router->post('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'PassbookController@update']);
    $router->delete('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'PassbookController@delete']);
});
$router->group(['prefix' => 'site-settings'], function () use ($router) {
    $router->get('', ['uses' => 'SiteSettingController@index']);
    $router->post('', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'SiteSettingController@create']);

    $router->post('load-settings', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'SiteSettingController@load_settings']);
    $router->get('stripe-public-key', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'SiteSettingController@stripe_public_key']);
    $router->get('stripe-connect-public-key', ['middleware' => 'role:admin,guest', 'uses' => 'SiteSettingController@stripe_connect_public_key']);
    $router->get('default-account', ['middleware' => 'role:admin,guest', 'uses' => 'SiteSettingController@default_account']);
    $router->get('find-bank-string/{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'SiteSettingController@find_bank_string']);
    $router->get('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'SiteSettingController@show']);
    $router->post('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'SiteSettingController@update']);
    $router->delete('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'SiteSettingController@delete']);
});
$router->group(['prefix' => 'misc-invoices'], function () use ($router) {
    $router->get('', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'MiscInvoiceController@index']);
    $router->post('', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'MiscInvoiceController@create']);

    $router->get('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'MiscInvoiceController@show']);
    $router->post('{id}/pay', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'MiscInvoiceController@pay']);
    $router->post('{id}/send-message', ['uses' => 'MiscInvoiceController@send_message']);
    $router->post('{id}/send-mail', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'MiscInvoiceController@send_mail']);
    $router->get('{id}/print', ['uses' => 'MiscInvoiceController@print']);
    $router->get('{id}/download', ['uses' => 'MiscInvoiceController@download']);

    $router->post('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'MiscInvoiceController@update']);
    $router->delete('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'MiscInvoiceController@delete']);
});
$router->group(['prefix' => 'reseller-misc-invoices'], function () use ($router) {
    $router->get('', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'ResellerMiscInvoiceController@index']);
    $router->post('', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'ResellerMiscInvoiceController@create']);

    $router->get('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'ResellerMiscInvoiceController@show']);
    $router->post('{id}/pay', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'ResellerMiscInvoiceController@pay']);
    $router->get('{id}/print', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'ResellerMiscInvoiceController@print']);
    $router->get('{id}/download', ['uses' => 'ResellerMiscInvoiceController@download']);

    $router->post('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'ResellerMiscInvoiceController@update']);
    $router->delete('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'ResellerMiscInvoiceController@delete']);
});

$router->group(['prefix' => 'postcodes'], function () use ($router) {
    $router->get('', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'PostcodeController@index']);
    $router->post('', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'PostcodeController@create']);

    $router->get('find/{code}', ['uses' => 'PostcodeController@find']);
    $router->post('bulk-accept', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'PostcodeController@bulk_accept']);
    $router->post('bulk-delete', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'PostcodeController@bulk_delete']);
    $router->post('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'PostcodeController@update']);
    $router->post('{id}/accept', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'PostcodeController@accept']);
    $router->post('{id}/pending', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'PostcodeController@pending']);
    $router->delete('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'PostcodeController@delete']);
});
$router->group(['prefix' => 'database-servers'], function () use ($router) {
    $router->get('', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'DatabaseServerController@index']);
    $router->get('mini', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'DatabaseServerController@mini']);
    $router->post('', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'DatabaseServerController@create']);

    $router->get('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'DatabaseServerController@show']);
    $router->post('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'DatabaseServerController@update']);
    $router->delete('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'DatabaseServerController@delete']);
});

$router->group(['prefix' => 'roles'], function () use ($router) {
    $router->get('', ['uses' => 'RoleController@index']);
    $router->post('', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'RoleController@create']);

    $router->get('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'RoleController@show']);
    $router->post('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'RoleController@update']);
    $router->delete('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'RoleController@delete']);
});

$router->group(['prefix' => 'tiffintom-site-settings'], function () use ($router) {
    $router->get('{id}', ['uses' => 'TiffintomController@sitesettng_show']);

    $router->post('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'TiffintomController@sitesettng_update']);
});

$router->group(['prefix' => 'tiffintom-sms-ports'], function () use ($router) {
    $router->get('', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'TiffintomController@sms_port_index']);
    $router->post('', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'TiffintomController@sms_port_create']);

    $router->get('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'TiffintomController@sms_port_show']);
    $router->post('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'TiffintomController@sms_port_update']);
    $router->delete('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'TiffintomController@sms_port_delete']);

    $router->post('{id}/enable', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'TiffintomController@sms_port_enable']);
    $router->post('{id}/disable', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'TiffintomController@sms_port_disable']);
});

$router->group(['prefix' => 'tiffintom-urls'], function () use ($router) {
    $router->get('', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'TiffintomController@urls_index']);
    $router->post('', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'TiffintomController@urls_create']);

    $router->get('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'TiffintomController@urls_show']);
    $router->post('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'TiffintomController@urls_update']);
    $router->delete('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'TiffintomController@urls_delete']);
});

$router->group(['prefix' => 'issuing-cards'], function () use ($router) {
    $router->get('', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'IssuingCardController@index']);
    $router->post('', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'IssuingCardController@create']);

    $router->get('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'IssuingCardController@show']);
    $router->post('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'IssuingCardController@update']);
    $router->post('{id}/change-pin', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'IssuingCardController@change_pin']);
    $router->delete('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'IssuingCardController@delete']);

    $router->post('{id}/enable', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'IssuingCardController@enable']);
    $router->post('{id}/disable', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'IssuingCardController@disable']);
});

$router->group(['prefix' => 'pay-via-direct'], function () use ($router) {
    $router->get('', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'PayViaDirectController@index']);
    $router->post('{id}/refund', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'PayViaDirectController@refund']);
});

$router->group(['prefix' => 'plans'], function () use ($router) {
    $router->get('', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'PlanController@index']);
    $router->post('', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'PlanController@create']);

    $router->get('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'PlanController@show']);
    $router->post('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'PlanController@update']);
    $router->delete('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'PlanController@delete']);
});

$router->group(['prefix' => 'plan-products'], function () use ($router) {
    $router->get('', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'PlanProductController@index']);
    $router->post('', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'PlanProductController@create']);

    $router->get('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'PlanProductController@show']);
    $router->post('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'PlanProductController@update']);
    $router->delete('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'PlanProductController@delete']);
    $router->post('{id}/enable', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'PlanProductController@enable']);
    $router->post('{id}/disable', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'PlanProductController@disable']);
});

//Ticket
$router->group(['prefix' => 'tickets'], function () use ($router) {
    $router->get('', ['uses' => 'TicketController@index']);
    $router->post('', ['uses' => 'TicketController@create']);

    $router->get('{id}', ['uses' => 'TicketController@show']);
    $router->post('{id}', ['uses' => 'TicketController@update']);
    $router->post('{id}/update', ['uses' => 'TicketController@all_update']);
    $router->post('{id}/resend-otp', ['uses' => 'TicketController@resend_otp']);
    $router->delete('{id}', ['uses' => 'TicketController@delete']);
});

//Ticket Message
$router->group(['prefix' => 'ticket-messages'], function () use ($router) {
    $router->get('', ['uses' => 'TicketMessageController@index']);
    $router->post('', ['uses' => 'TicketMessageController@create']);

    $router->get('{id}', ['uses' => 'TicketMessageController@show']);
    $router->post('{id}', ['uses' => 'TicketMessageController@update']);
    $router->post('{id}/close', ['uses' => 'TicketMessageController@close']);
    $router->delete('{id}', ['uses' => 'TicketMessageController@delete']);
});

// Secure Ips 
$router->group(['prefix' => 'secure-ips'], function () use ($router) {
    $router->get('', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'SecureIpController@index']);
    $router->post('', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'SecureIpController@create']);

    $router->get('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'SecureIpController@show']);
    $router->post('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'SecureIpController@update']);
    $router->delete('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'SecureIpController@delete']);

    $router->post('{id}/enable', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'SecureIpController@enable']);
    $router->post('{id}/disable', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'SecureIpController@disable']);
});

// Hardware Product
$router->group(['prefix' => 'hardware-products'], function () use ($router) {
    $router->get('', ['uses' => 'HardwareProductController@index']);
    $router->post('', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'HardwareProductController@create']);

    $router->get('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'HardwareProductController@show']);
    $router->post('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'HardwareProductController@update']);
    $router->delete('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'HardwareProductController@delete']);

    $router->post('{id}/enable', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'HardwareProductController@enable']);
    $router->post('{id}/disable', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'HardwareProductController@disable']);
});

// Hardware Product Images
$router->group(['prefix' => 'hardware-product-images'], function () use ($router) {
    $router->get('', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'HardwareProductImageController@index']);
    $router->post('', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'HardwareProductImageController@create']);

    $router->get('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'HardwareProductImageController@show']);
    $router->post('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'HardwareProductImageController@update']);
    $router->delete('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'HardwareProductImageController@delete']);
});

// Hardware Order
$router->group(['prefix' => 'hardware-orders'], function () use ($router) {
    $router->get('', ['middleware' => 'role:admin,epos_admin,epos_user,user', 'uses' => 'HardwareOrderController@index']);
    $router->post('', ['middleware' => 'role:admin,epos_admin,user,guest', 'uses' => 'HardwareOrderController@create']);

    $router->get('{id}', ['middleware' => 'role:admin,epos_admin,epos_user,user', 'uses' => 'HardwareOrderController@show']);
    $router->post('payment-intent', ['middleware' => 'role:admin,epos_admin,epos_user,user', 'uses' => 'HardwareOrderController@payment_intent']);
    $router->post('{id}', ['middleware' => 'role:admin,epos_admin,epos_user,user', 'uses' => 'HardwareOrderController@update']);
    $router->delete('{id}', ['middleware' => 'role:admin,epos_admin,epos_user,user', 'uses' => 'HardwareOrderController@delete']);
});

// Hardware Order Item 
$router->group(['prefix' => 'hardware-order-items'], function () use ($router) {
    $router->get('', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'HardwareOrderItemController@index']);
    $router->post('', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'HardwareOrderItemController@create']);

    $router->get('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'HardwareOrderItemController@show']);
    $router->post('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'HardwareOrderItemController@update']);
    $router->delete('delete-all/{id}', ['middleware' => 'role:epos_admin,admin', 'uses' => 'HardwareOrderItemController@delete_all']);
    $router->delete('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'HardwareOrderItemController@delete']);
});

// Weekly Charges
$router->group(['prefix' => 'weekly-charges'], function () use ($router) {
    $router->get('', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'WeeklyChargeController@index']);
    $router->post('', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'WeeklyChargeController@create']);

    $router->get('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'WeeklyChargeController@show']);
    $router->post('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'WeeklyChargeController@update']);
    $router->delete('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'WeeklyChargeController@delete']);
});

// FAQ
$router->group(['prefix' => 'faqs'], function () use ($router) {
    $router->get('', ['uses' => 'FaqController@index']);
    $router->get('home', ['uses' => 'FaqController@home']);
    $router->post('', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'FaqController@create']);

    $router->get('{id}', ['uses' => 'FaqController@show']);
    $router->post('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'FaqController@update']);
    $router->delete('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'FaqController@delete']);

    $router->post('{id}/enable', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'FaqController@enable']);
    $router->post('{id}/disable', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'FaqController@disable']);
});

// tutorials
$router->group(['prefix' => 'tutorials'], function () use ($router) {
    $router->get('', ['uses' => 'TutorialController@index']);
    $router->post('', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'TutorialController@create']);

    $router->get('{id}', ['uses' => 'TutorialController@show']);
    $router->post('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'TutorialController@update']);
    $router->delete('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'TutorialController@delete']);

    $router->post('{id}/enable', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'TutorialController@enable']);
    $router->post('{id}/disable', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'TutorialController@disable']);
});

$router->group(['prefix' => 'action-logs'], function () use ($router) {
    $router->get('', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'ActionLogController@index']);
    $router->post('', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'ActionLogController@create']);

    $router->get('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'ActionLogController@show']);
    $router->post('bulk-delete', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'ActionLogController@bulk_delete']);
    $router->post('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'ActionLogController@update']);

    $router->delete('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'ActionLogController@delete']);
});

// careers
$router->group(['prefix' => 'careers'], function () use ($router) {
    $router->get('', ['uses' => 'CareerController@index']);
    $router->post('', ['uses' => 'CareerController@create']);

    $router->get('{id}', ['uses' => 'CareerController@show']);
    $router->post('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'CareerController@update']);
    $router->delete('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'CareerController@delete']);
});

// positions
$router->group(['prefix' => 'positions'], function () use ($router) {
    $router->get('', ['uses' => 'PositionController@index']);
    $router->get('mini', ['uses' => 'PositionController@mini']);
    $router->post('', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'PositionController@create']);

    $router->get('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'PositionController@show']);
    $router->post('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'PositionController@update']);
    $router->post('{id}/enable', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'PositionController@enable']);
    $router->post('{id}/disable', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'PositionController@disable']);
    $router->delete('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'PositionController@delete']);
});

//Hard ware Vouchers
$router->group(['prefix' => 'vouchers'], function () use ($router) {
    $router->get('', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'HardwareVoucherController@index']);
    $router->post('', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'HardwareVoucherController@create']);

    $router->post('find/{code}', ['middleware' => 'role:admin,epos_admin,user,tiffintom_user', 'uses' => 'HardwareVoucherController@find']);
    $router->get('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'HardwareVoucherController@show']);
    $router->post('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'HardwareVoucherController@update']);
    $router->delete('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'HardwareVoucherController@delete']);

    $router->post('{id}/enable', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'HardwareVoucherController@enable']);
    $router->post('{id}/disable', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'HardwareVoucherController@disable']);
});

// support-contacts
$router->group(['prefix' => 'support-contacts'], function () use ($router) {
    $router->get('', ['uses' => 'SupportContactController@index']);
    $router->post('', ['uses' => 'SupportContactController@create']);

    $router->get('{id}', ['uses' => 'SupportContactController@show']);
    $router->post('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'SupportContactController@update']);
    $router->delete('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'SupportContactController@delete']);
});

// subscription-emails
$router->group(['prefix' => 'subscription-emails'], function () use ($router) {
    $router->get('', ['uses' => 'SubscriptionEmailController@index']);
    $router->get('/export', ['uses' => 'SubscriptionEmailController@export']);
    $router->post('', ['uses' => 'SubscriptionEmailController@create']);

    $router->get('{id}', ['uses' => 'SubscriptionEmailController@show']);
    $router->post('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'SubscriptionEmailController@update']);
    $router->delete('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'SubscriptionEmailController@delete']);
});

// SMS Logs
$router->group(['prefix' => 'sms-logs'], function () use ($router) {
    $router->get('', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'SMSLogController@index']);
    $router->post('', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'SMSLogController@create']);

    $router->get('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'SMSLogController@show']);
    $router->post('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'SMSLogController@update']);
    $router->delete('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'SMSLogController@delete']);
});

// Caxton Admin Wallet And Card Services
$router->group(['prefix' => 'finance'], function () use ($router) {
    $router->get('', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'CaxtonfxController@index']);
    $router->get('wallets-fetch', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'CaxtonfxController@get_wallets']);
    $router->get('cards-fetch', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'CaxtonfxController@get_cards']);
    $router->get('wallet-transaction-fetch', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'CaxtonfxController@get_wallet_transactions']);
    $router->get('wallet-transaction-fetch-count', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'CaxtonfxController@get_wallet_transactions_count']);
    $router->get('wallets-transactions-export', ['uses' => 'CaxtonfxController@export_wallet_transaction']);
    $router->get('beneficiary-fetch', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'CaxtonfxController@get_beneficiary']);
    $router->get('transfer-fetch', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'CaxtonfxController@get_transfer']);
    $router->get('transfer-transaction-fetch', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'CaxtonfxController@get_transfer_transaction']);
    $router->get('transfer-transactions-export', ['uses' => 'CaxtonfxController@export_transfer_transaction']);
    $router->get('wallet-payout', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'CaxtonfxController@wallet_payout_fetch']);
    $router->get('beneficiary-payout', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'CaxtonfxController@beneficiary_payout_fetch']);
    $router->get('generate-token', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'CaxtonfxController@setting_generate_token']);
    $router->get('generate-login-token', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'CaxtonfxController@login']);

    $router->get('account-wallets', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'CaxtonfxController@fetch_all_wallet']);
    $router->get('account-cards', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'CaxtonfxController@fetch_all_card']);
    $router->get('account-wallet-transaction', ['uses' => 'CaxtonfxController@fetch_all_wallet_transaction']);
    $router->get('account-beneficiaries', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'CaxtonfxController@fetch_all_beneficiaries']);
    $router->get('account-transfer-transaction', ['uses' => 'CaxtonfxController@fetch_all_transfer_transactions']);
    $router->get('main-balance', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'CaxtonfxController@admin_balance']);
    $router->get('get-bank-details', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'CaxtonfxController@get_bank_details']);
    $router->get('admin-bank-details', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'CaxtonfxController@admin_bank_details']);

    $router->get('get-pin/{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'CaxtonfxController@get_pin']);
    $router->get('card-block/{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'CaxtonfxController@card_block']);
    $router->get('card-unblock/{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'CaxtonfxController@card_unblock']);
    $router->get('card-stolen/{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'CaxtonfxController@card_stolen']);
    $router->get('card-lost/{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'CaxtonfxController@card_lost']);
    $router->get('get-balance/{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'CaxtonfxController@get_balance']);
    $router->get('get-transfer/{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'CaxtonfxController@show_transfer']);
    $router->get('wallet/{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'CaxtonfxController@show_wallet']);
    $router->get('unsigned-business/{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'CaxtonfxController@unsigned_business']);
    $router->get('unsigned-group/{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'CaxtonfxController@unsigned_group']);

    $router->post('wallet-create', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'CaxtonfxController@wallet_create']);
    $router->post('bulk-wallet-payout', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'CaxtonfxController@wallet_bulk_payout']);
    $router->post('bulk-beneficiary-payout', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'CaxtonfxController@beneficiary_bulk_payout']);
    $router->post('card-create', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'CaxtonfxController@card_create']);
    $router->post('beneficiary-create', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'CaxtonfxController@beneficiary_create']);
    $router->post('beneficiary-lookup', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'CaxtonfxController@beneficiary_lookup']);
    $router->post('load-balance', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'CaxtonfxController@load_balance']);
    $router->post('transfer', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'CaxtonfxController@transfer']);
    $router->post('transfer-load', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'CaxtonfxController@transfer_load']);
    $router->post('redeem-balance', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'CaxtonfxController@redeem_balance']);
    $router->post('wallet-update/{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'CaxtonfxController@wallet_update']);
    $router->post('wallet-archive/{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'CaxtonfxController@wallet_archived']);
    $router->post('card-active/{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'CaxtonfxController@card_active']);
    $router->post('card-generate-token/{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'CaxtonfxController@card_active_token_generate']);
    $router->post('card-move/{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'CaxtonfxController@card_move']);
    $router->post('beneficiary-update/{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'CaxtonfxController@beneficiary_update']);
    $router->delete('beneficiary-delete/{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'CaxtonfxController@delete_beneficiary']);
    $router->post('{id}/beneficiary-enable-archive', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'CaxtonfxController@enable_archive_beneficiary']);
    $router->post('{id}/beneficiary-disable-archive', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'CaxtonfxController@disable_archive_beneficiary']);

    // Standing Instruction
    $router->get('standing-instructions', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'CaxtonfxController@standing_instruction_index']);
    $router->post('standing-instructions', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'CaxtonfxController@standing_instruction_create']);
    $router->get('standing-instructions/{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'CaxtonfxController@standing_instruction_show']);
    $router->post('standing-instructions/{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'CaxtonfxController@standing_instruction_update']);
    $router->delete('standing-instructions/{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'CaxtonfxController@standing_instruction_delete']);
    $router->post('standing-instructions/{id}/enable', ['middleware' => 'role:admin,epos_admin,user,guest', 'uses' => 'CaxtonfxController@standing_instruction_enable']);
    $router->post('standing-instructions/{id}/disable', ['middleware' => 'role:admin,epos_admin,user,guest', 'uses' => 'CaxtonfxController@standing_instruction_disable']);

    // Wallet Group
    $router->get('wallet-groups', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'CaxtonfxController@wallet_group_index']);
    $router->post('wallet-groups', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'CaxtonfxController@wallet_group_create']);
    $router->get('wallet-groups/{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'CaxtonfxController@wallet_group_show']);
    $router->post('wallet-groups/{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'CaxtonfxController@wallet_group_update']);
    $router->delete('wallet-groups/{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'CaxtonfxController@wallet_group_delete']);

    // Payout Request
    $router->get('payout-requests', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'CaxtonfxController@payout_request_index']);
    $router->post('payout-requests', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'CaxtonfxController@payout_request_create']);
    $router->get('payout-requests/export', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'CaxtonfxController@payout_request_show']);
    $router->get('payout-requests/{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'CaxtonfxController@payout_request_export']);
    $router->get('payout-requests/{id}/status', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'CaxtonfxController@payout_request_status_fetch']);
    $router->post('payout-requests/{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'CaxtonfxController@payout_request_update']);
    $router->delete('payout-requests/{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'CaxtonfxController@payout_request_delete']);


    // Transactions
    $router->get('transaction-fetch', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'CaxtonfxController@get_transaction']);
    $router->get('account-transaction', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'CaxtonfxController@fetch_all_transactions']);
    $router->get('transactions-export', ['uses' => 'CaxtonfxController@export_transaction']);
});

// Caxton User Banking Services
$router->group(['prefix' => 'finance-users'], function () use ($router) {
    $router->get('', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'CaxtonfxUserController@index']);
    $router->post('', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'CaxtonfxUserController@create']);

    $router->get('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'CaxtonfxUserController@show']);
    $router->get('{id}/token-generate', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'CaxtonfxUserController@generate_token']);
    $router->get('{id}/login', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'CaxtonfxUserController@login']);
    $router->get('{id}/balance', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'CaxtonfxUserController@get_balance']);
    $router->get('{id}/send-otp', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'CaxtonfxUserController@send_otp']);
    $router->post('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'CaxtonfxUserController@update']);
    $router->delete('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'CaxtonfxUserController@delete']);

    // User Beneficiary details
    $router->get('{user_id}/beneficiary', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'CaxtonfxUserController@beneficiary_index']);
    $router->post('{user_id}/beneficiary', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'CaxtonfxUserController@beneficiary_create']);
    $router->post('{user_id}/beneficiary/lookup', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'CaxtonfxUserController@beneficiary_lookup']);
    $router->get('{user_id}/beneficiary/sync', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'CaxtonfxUserController@beneficiary_sync']);
    $router->post('{user_id}/beneficiary/{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'CaxtonfxUserController@beneficiary_update']);
    $router->delete('{user_id}/beneficiary/{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'CaxtonfxUserController@beneficiary_delete']);

    // User Standing Instruction
    $router->get('{user_id}/standing-instructions', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'CaxtonfxUserController@standing_instruction_index']);
    $router->post('{user_id}/standing-instructions', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'CaxtonfxUserController@standing_instruction_create']);
    $router->get('{user_id}/standing-instructions/{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'CaxtonfxUserController@standing_instruction_show']);
    $router->post('{user_id}/standing-instructions/{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'CaxtonfxUserController@standing_instruction_update']);
    $router->post('{user_id}/standing-instructions/{id}/enable', ['middleware' => 'role:admin,epos_admin,user,guest', 'uses' => 'CaxtonfxUserController@standing_instruction_enable']);
    $router->post('{user_id}/standing-instructions/{id}/disable', ['middleware' => 'role:admin,epos_admin,user,guest', 'uses' => 'CaxtonfxUserController@standing_instruction_disable']);
    $router->delete('{user_id}/standing-instructions/{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'CaxtonfxUserController@standing_instruction_delete']);

    // User Bank details
    $router->get('{user_id}/bank-details', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'CaxtonfxUserController@get_bank_details']);

    // User Transfer
    $router->get('{user_id}/transfer', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'CaxtonfxUserController@transfer_index']);
    $router->post('{user_id}/transfer', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'CaxtonfxUserController@transfer_create']);
    $router->get('{user_id}/show-transfer/{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'CaxtonfxUserController@show_transfer']);

    // Transfer Same Bank
    $router->post('{user_id}/transfer-load', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'CaxtonfxUserController@transfer_load']);

    // User Transfer Transactions
    $router->get('{user_id}/transfer-transactions', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'CaxtonfxUserController@transfer_transaction_index']);
    $router->get('{user_id}/transfer-transactions/sync', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'CaxtonfxUserController@transfer_transaction_sync']);
    $router->get('{user_id}/transfer-transactions-count', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'CaxtonfxUserController@transfer_transaction_count']);
    $router->get('{user_id}/transfer-transactions-export', ['uses' => 'CaxtonfxUserController@transfer_transaction_export']);

    // User Transactions
    $router->get('{user_id}/transactions', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'CaxtonfxUserController@transaction_index']);
    $router->get('{user_id}/transactions/sync', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'CaxtonfxUserController@transaction_sync']);
    $router->get('{user_id}/transactions-count', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'CaxtonfxUserController@transaction_count']);
    $router->get('{user_id}/transactions-export', ['uses' => 'CaxtonfxUserController@transaction_export']);
});

// banking-requests
$router->group(['prefix' => 'banking-requests'], function () use ($router) {
    $router->get('', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BankingRequestController@index']);
    $router->post('', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BankingRequestController@create']);

    $router->get('/count', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BankingRequestController@count']);
    $router->get('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BankingRequestController@show']);
    $router->post('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BankingRequestController@update']);
    $router->delete('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'BankingRequestController@delete']);
});

$router->group(['prefix' => 'pouch-histories'], function () use ($router) {
    $router->get('', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'PouchHistoryController@index']);
    $router->post('', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'PouchHistoryController@create']);
    $router->post('load-main-pouch', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'PouchHistoryController@load_main_pouch']);
    $router->post('unload-main-pouch', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'PouchHistoryController@unload_main_pouch']);
    $router->post('wallet-transfer', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'PouchHistoryController@wallet_create']);
    $router->post('bank-transfer', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'PouchHistoryController@bank_create']);
    $router->post('wallet-load', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'PouchHistoryController@wallet_load']);
    $router->post('bank-load', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'PouchHistoryController@bank_load']);
    $router->post('bulk-payout', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'PouchHistoryController@bulk_payout']);


    $router->get('payout', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'PouchHistoryController@payout_fetch']);
    $router->get('export', ['uses' => 'PouchHistoryController@export_index']);
    $router->get('count', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'PouchHistoryController@index_count']);
    $router->get('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'PouchHistoryController@show']);
    $router->get('beneficiary/{business_id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'PouchHistoryController@beneficiary_index']);
    $router->get('wallet/{business_id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'PouchHistoryController@wallet_index']);
    $router->post('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'PouchHistoryController@update']);
    $router->delete('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'PouchHistoryController@delete']);
});

$router->group(['prefix' => 'invoices'], function () use ($router) {
    $router->get('', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'InvoiceController@index']);
    $router->post('', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'InvoiceController@create']);

    $router->get('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'InvoiceController@show']);
    $router->post('{id}/send-message', ['uses' => 'InvoiceController@send_message']);
    $router->post('{id}/send-mail', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'InvoiceController@send_mail']);
    $router->get('{id}/print', ['uses' => 'InvoiceController@print']);
    $router->get('{id}/download', ['uses' => 'InvoiceController@download']);

    $router->post('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'InvoiceController@update']);
    $router->post('{id}/status-change', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'InvoiceController@update_status']);
    $router->delete('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'InvoiceController@delete']);
});

// Invoice Payment Link
$router->group(['prefix' => 'invoice-pay-links'], function () use ($router) {
    $router->get('', ['middleware' => 'role:admin,epos_admin,tiffintom_user,epos_user,user,guest', 'uses' => 'InvoicePayLinkController@index']);
    $router->post('', ['middleware' => 'role:admin,epos_admin,tiffintom_user,epos_user,user,guest', 'uses' => 'InvoicePayLinkController@create']);
    $router->post('payment-intent', ['middleware' => 'role:admin,epos_admin,tiffintom_user,epos_user,user,guest', 'uses' => 'InvoicePayLinkController@payment_intent']);
    $router->get('find/{code}', ['uses' => 'InvoicePayLinkController@find']);
    $router->post('{id}/resend', ['middleware' => 'role:admin,epos_admin,tiffintom_user,epos_user,user,guest', 'uses' => 'InvoicePayLinkController@resend']);
    $router->post('{id}/change-status', ['uses' => 'InvoicePayLinkController@change_status']);
    $router->post('{id}/cancel-payment', ['uses' => 'InvoicePayLinkController@change_cancel']);
});

//AWS SES Mail Service
$router->group(['prefix' => 'email-services'], function () use ($router) {
    $router->get('', ['middleware' => 'role:admin,epos_admin,tiffintom_user,epos_user,user', 'uses' => 'ServiceEmailController@index']);
    $router->post('', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'ServiceEmailController@create']);

    $router->get('receive', ['uses' => 'ServiceEmailController@index_receive']);
    $router->get('send', ['uses' => 'ServiceEmailController@index_send']);
    $router->get('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'ServiceEmailController@show']);
    $router->get('sent/{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'ServiceEmailController@show_sent']);
    $router->get('receive/{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'ServiceEmailController@show_receive']);
    $router->post('send-mail', ['middleware' => 'role:admin,epos_admin,epos_user,user', 'uses' => 'ServiceEmailController@send_mail']);
    $router->post('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'ServiceEmailController@update']);
    $router->post('change-status/{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'ServiceEmailController@change_status']);

    $router->delete('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'ServiceEmailController@delete']);
    $router->delete('{id}/receive', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'ServiceEmailController@delete_receive']);
    $router->delete('{id}/send', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'ServiceEmailController@delete_send']);
});

// banking-requests
$router->group(['prefix' => 'tap-to-pay-requests'], function () use ($router) {
    $router->get('', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'TapRequestController@index']);
    $router->post('', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'TapRequestController@create']);

    $router->get('/count', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'TapRequestController@count']);
    $router->get('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'TapRequestController@show']);
    $router->post('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'TapRequestController@update']);
    $router->delete('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'TapRequestController@delete']);
});

// Cash Transactions routes
$router->group(['prefix' => 'cash-transactions'], function () use ($router) {
    $router->get('', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'CashTransactionController@index']);
    $router->post('', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'CashTransactionController@create']);
    $router->get('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'CashTransactionController@show']);
    $router->post('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'CashTransactionController@edit']);
    $router->delete('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'CashTransactionController@delete']);
});

// Factory Reset Logs
$router->group(['prefix' => 'factory-logs'], function () use ($router) {
    $router->get('', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'FactoryResetLogController@index']);
    $router->post('', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'FactoryResetLogController@create']);

    $router->get('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'FactoryResetLogController@show']);
    $router->post('bulk-delete', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'FactoryResetLogController@bulk_delete']);
    $router->post('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'FactoryResetLogController@edit']);

    $router->delete('{id}', ['middleware' => 'role:admin,epos_admin,user', 'uses' => 'FactoryResetLogController@delete']);
});

// socket
$router->group(['prefix' => 'sockets'], function () use ($router) {
    $router->get('', ['uses' => 'SocketController@index']);
    $router->post('', ['uses' => 'SocketController@create']);
});

// Ubsidi Payment Gateway apis
$router->group(['prefix' => 'ubsidi'], function () use ($router) {
    $router->post('payment-schema', ['uses' => 'UbsidiPaymentGatewayController@paymentSchema']);
    $router->post('generate-keys', ['uses' => 'UbsidiPaymentGatewayController@generateKeys']);
    $router->post('refund', ['uses' => 'UbsidiPaymentGatewayController@refund']);
    $router->get('transactions', ['uses' => 'UbsidiPaymentGatewayController@transactions']);
    $router->post('confirm-schema', ['uses' => 'UbsidiPaymentGatewayController@confirmSchema']);
    $router->get('get-key', ['uses' => 'UbsidiPaymentGatewayController@getStripeKey']);
});

// aamarpay payment method
$router->group(['prefix' => 'aamarpay'], function () use ($router) {
    $router->post('', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'AamarPayController@payment']);
});
