<?php

/*
|--------------------------------------------------------------------------
| API Routes
|--------------------------------------------------------------------------
*/

use App\Http\Controllers\PayoutReportController;
use App\Jobs\PrintJob;
use Carbon\Carbon;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Queue;

$router->group(['prefix' => '/'], function () use ($router) {
    $router->get('dashboard', ['middleware' => 'role:user', 'uses' => 'AppResellerController@dashboard']);

    $router->post('login', ['uses' => 'AppResellerController@login']);
    $router->get('me', ['middleware' => 'role:user', 'uses' => 'AppResellerController@show']);

    $router->get('businesses', ['middleware' => 'role:user', 'uses' => 'AppResellerController@businesses_index']);
    $router->get('businesses/{business_id}', ['uses' => 'AppResellerController@businesses_show']);

    $router->get('payout-invoices/groups', ['middleware' => 'role:user', 'uses' => 'AppResellerController@invoice_groups']);
    $router->get('payout-invoices/groups/{id}', ['middleware' => 'role:user', 'uses' => 'AppResellerController@invoice_group_show']);

    $router->get('payout-invoices/grouped', ['middleware' => 'role:user', 'uses' => 'AppResellerController@invoices_group']);
    $router->get('payout-invoices/details', ['middleware' => 'role:user', 'uses' => 'AppResellerController@invoices_details']);
    $router->get('payout-invoices/{id}', ['middleware' => 'role:user', 'uses' => 'AppResellerController@invoices_show']);
});
