<?php

/*
|--------------------------------------------------------------------------
| API Routes
|--------------------------------------------------------------------------
*/

$router->group(['prefix' => 'users'], function () use ($router) {
    $router->get('', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomUserController@index']);
    $router->get('mini', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user,guest', 'uses' => 'TiffintomUserController@mini']);
    $router->get('dashboard', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomUserController@dashboard']);
    $router->get('count', ['uses' => 'TiffintomUserController@count']);
    $router->get('send-referral', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomUserController@send_referral']);
    $router->get('send-referral-email', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomUserController@send_referral_email']);
    $router->get('verify-email', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomUserController@verify_email']);
    $router->get('validate-email', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomUserController@validate_email']);
    $router->get('send-otp', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomUserController@send_otp']);
    $router->post('login', ['uses' => 'TiffintomUserController@login']);
    $router->post('login-admin', ['uses' => 'TiffintomUserController@login_admin']);
    $router->post('signup', ['uses' => 'TiffintomUserController@signup']);
    $router->post('subadmin', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomUserController@subadmin_create']);
    $router->get('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomUserController@show']);
    $router->post('forgot-password', ['uses' => 'TiffintomUserController@forgot_password']);
    $router->post('forgot-password-direct', ['uses' => 'TiffintomUserController@forgot_password_direct']);
    $router->post('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomUserController@update']);
    $router->delete('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomUserController@delete']);
    $router->post('{id}/verify', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomUserController@verify_status']);
    $router->post('{id}/send-otp-both', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomUserController@send_otp_both']);
    $router->post('{id}/remove-image', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomUserController@remove_image']);
    $router->post('{id}/change-password', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user,guest', 'uses' => 'TiffintomUserController@chage_password']);
    $router->post('{id}/change-user-password', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user,guest', 'uses' => 'TiffintomUserController@chage_user_password']);
    $router->post('{id}/verify-otp', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomUserController@verify_otp']);
    $router->post('{id}/verify-otp-both', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user,guest', 'uses' => 'TiffintomUserController@verify_otp_both']);
    $router->post('{id}/email-verify-otp', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomUserController@email_verify_otp']);

    $router->post('{id}/enable', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomUserController@enable']);
    $router->post('{id}/disable', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomUserController@disable']);
});

// Restaurant
$router->group(['prefix' => 'restaurants'], function () use ($router) {
    $router->get('', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user,guest', 'uses' => 'TiffintomRestaurantController@index']);
    $router->post('', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user,guest', 'uses' => 'TiffintomRestaurantController@create']);
    $router->get('mini', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user,guest', 'uses' => 'TiffintomRestaurantController@mini']);
    $router->get('time-slot', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user,guest', 'uses' => 'TiffintomRestaurantController@restaurant_timeslot']);
    $router->get('booking-time-slot', ['uses' => 'TiffintomRestaurantController@restaurant_booking_timeslot']);
    $router->get('fetch', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user,guest', 'uses' => 'TiffintomRestaurantController@fetch']);
    $router->get('offer-all', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user,guest', 'uses' => 'TiffintomRestaurantController@restaurant_offer']);
    $router->get('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user,guest', 'uses' => 'TiffintomRestaurantController@show']);
    $router->get('{name}/fetch', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user,guest', 'uses' => 'TiffintomRestaurantController@show_name']);
    $router->get('{id}/all', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user,guest', 'uses' => 'TiffintomRestaurantController@show_all']);
    $router->get('{id}/counts', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user,guest', 'uses' => 'TiffintomRestaurantController@restaurant_pending_count']);
    $router->post('fetch-city', ['uses' => 'TiffintomRestaurantController@find_city']);
    $router->post('search', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user,guest', 'uses' => 'TiffintomRestaurantController@search']);
    $router->post('nearby', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user,guest', 'uses' => 'TiffintomRestaurantController@nearby']);
    $router->post('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomRestaurantController@update']);

    $router->delete('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user,tiffintom_user,epos_user', 'uses' => 'TiffintomRestaurantController@delete']);

    $router->post('{id}/enable', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomRestaurantController@enable']);
    $router->post('{id}/disable', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomRestaurantController@disable']);

    $router->post('{id}/enable-featured', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomRestaurantController@enable_featured']);
    $router->post('{id}/disable-featured', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomRestaurantController@disable_featured']);
});
// Menu
$router->group(['prefix' => 'menu'], function () use ($router) {
    $router->get('', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomMenuController@index']);
    $router->post('', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomMenuController@create']);

    $router->get('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user,guest', 'uses' => 'TiffintomMenuController@show']);
    $router->post('bulk', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomMenuController@bulk_menu']);
    $router->post('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomMenuController@update']);
    $router->delete('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomMenuController@delete']);
    $router->delete('{id}/variant', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomMenuController@delete_variant']);

    $router->post('{id}/enable', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomMenuController@enable']);
    $router->post('{id}/disable', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomMenuController@disable']);
});
// Dinein Menu
$router->group(['prefix' => 'dinein-menu'], function () use ($router) {
    $router->get('', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user,guest', 'uses' => 'TiffintomDineinMenuController@index']);
    $router->post('', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomDineinMenuController@create']);

    $router->get('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user,guest', 'uses' => 'TiffintomDineinMenuController@show']);
    $router->post('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomDineinMenuController@update']);
    $router->delete('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomDineinMenuController@delete']);

    $router->post('{id}/enable', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomDineinMenuController@enable']);
    $router->post('{id}/disable', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomDineinMenuController@disable']);
});
// Cart
$router->group(['prefix' => 'cart'], function () use ($router) {
    $router->get('', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user,tiffintom_user,epos_user', 'uses' => 'TiffintomCartController@index']);
    $router->get('history', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user,tiffintom_user,epos_user', 'uses' => 'TiffintomCartController@history']);
    $router->post('', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomCartController@create']);

    $router->post('cart-bulk', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomCartController@cart_bulk']);
    $router->delete('delete-all', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomCartController@delete_all']);

    $router->get('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user,tiffintom_user,epos_user', 'uses' => 'TiffintomCartController@show']);
    $router->post('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomCartController@update']);
    $router->delete('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user,tiffintom_user,epos_user', 'uses' => 'TiffintomCartController@delete']);
});
// Address-Book
$router->group(['prefix' => 'address-book'], function () use ($router) {
    $router->get('', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user,tiffintom_user,epos_user', 'uses' => 'TiffintomAddressBookController@index']);
    $router->post('', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomAddressBookController@create']);

    $router->get('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user,tiffintom_user,epos_user', 'uses' => 'TiffintomAddressBookController@show']);
    $router->post('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomAddressBookController@update']);
    $router->delete('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user,tiffintom_user,epos_user', 'uses' => 'TiffintomAddressBookController@delete']);

    $router->post('{id}/enable', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomAddressBookController@enable']);
    $router->post('{id}/disable', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomAddressBookController@disable']);
});
// Category
$router->group(['prefix' => 'categories'], function () use ($router) {
    $router->get('', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user,guest', 'uses' => 'TiffintomCategoryController@index']);
    $router->post('', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomCategoryController@create']);

    $router->get('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user,guest', 'uses' => 'TiffintomCategoryController@show']);
    $router->get('{id}/get-addon', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user,guest', 'uses' => 'TiffintomCategoryController@get_addon']);
    $router->post('bulk', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomCategoryController@bulk_category']);
    $router->post('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomCategoryController@update']);
    $router->delete('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomCategoryController@delete']);

    $router->post('{id}/enable', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomCategoryController@enable']);
    $router->post('{id}/disable', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomCategoryController@disable']);
});
// Category
$router->group(['prefix' => 'dinein-categories'], function () use ($router) {
    $router->get('', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user,guest', 'uses' => 'TiffintomDineinCategoryController@index']);
    $router->post('', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomDineinCategoryController@create']);

    $router->get('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user,guest', 'uses' => 'TiffintomDineinCategoryController@show']);
    $router->post('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomDineinCategoryController@update']);
    $router->delete('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomDineinCategoryController@delete']);

    $router->post('{id}/enable', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomDineinCategoryController@enable']);
    $router->post('{id}/disable', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomDineinCategoryController@disable']);
});
// Addon
$router->group(['prefix' => 'addons'], function () use ($router) {
    $router->get('', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomMainAddonController@index']);
    $router->post('', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomMainAddonController@create']);

    $router->get('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomMainAddonController@show']);
    $router->post('bulk', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomMainAddonController@bulk_addon']);
    $router->post('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomMainAddonController@update']);
    $router->delete('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomMainAddonController@delete']);
    $router->delete('{id}/sub_addon', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomMainAddonController@delete_subaddon']);

    $router->post('{id}/enable', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomMainAddonController@enable']);
    $router->post('{id}/disable', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomMainAddonController@disable']);
});
// Card // Stripe Customers Change Enadpoint
$router->group(['prefix' => 'card'], function () use ($router) {
    $router->get('', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user,tiffintom_user,epos_user', 'uses' => 'TiffintomStripeCustomerController@index']);
    $router->post('', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomStripeCustomerController@create']);

    $router->post('payment-intent', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomStripeCustomerController@payment_intent']);

    $router->get('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user,tiffintom_user,epos_user', 'uses' => 'TiffintomStripeCustomerController@show']);
    $router->post('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomStripeCustomerController@update']);
    $router->delete('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user,tiffintom_user,epos_user', 'uses' => 'TiffintomStripeCustomerController@delete']);
});
// Offer 
$router->group(['prefix' => 'offers'], function () use ($router) {
    $router->get('', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomOfferController@index']);
    $router->post('', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomOfferController@create']);

    $router->get('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomOfferController@show']);
    $router->post('bulk', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomOfferController@bulk_offer']);
    $router->post('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomOfferController@update']);
    $router->delete('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomOfferController@delete']);

    $router->post('{id}/enable', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomOfferController@enable']);
    $router->post('{id}/disable', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomOfferController@disable']);
});
// Product Offer 
$router->group(['prefix' => 'product-offers'], function () use ($router) {
    $router->get('', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomOfferProductController@index']);
    $router->post('', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomOfferProductController@create']);

    $router->get('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomOfferProductController@show']);
    $router->post('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomOfferProductController@update']);
    $router->delete('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomOfferProductController@delete']);

    $router->post('{id}/enable', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomOfferProductController@enable']);
    $router->post('{id}/disable', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomOfferProductController@disable']);
});
// Price Offer 
$router->group(['prefix' => 'price-offers'], function () use ($router) {
    $router->get('', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomOfferPriceController@index']);
    $router->post('', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomOfferPriceController@create']);

    $router->get('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomOfferPriceController@show']);
    $router->post('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomOfferPriceController@update']);
    $router->delete('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomOfferPriceController@delete']);

    $router->post('{id}/enable', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomOfferPriceController@enable']);
    $router->post('{id}/disable', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomOfferPriceController@disable']);
});
// Day Offer 
$router->group(['prefix' => 'day-offers'], function () use ($router) {
    $router->get('', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomOfferDayController@index']);
    $router->post('', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomOfferDayController@create']);

    $router->get('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomOfferDayController@show']);
    $router->post('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomOfferDayController@update']);
    $router->delete('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomOfferDayController@delete']);

    $router->post('{id}/enable', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomOfferDayController@enable']);
    $router->post('{id}/disable', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomOfferDayController@disable']);
});
// Day Price Offer 
$router->group(['prefix' => 'day-price-offers'], function () use ($router) {
    $router->get('', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomOfferDayPriceController@index']);
    $router->post('', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomOfferDayPriceController@create']);

    $router->get('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomOfferDayPriceController@show']);
    $router->post('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomOfferDayPriceController@update']);
    $router->delete('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomOfferDayPriceController@delete']);

    $router->post('{id}/enable', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomOfferDayPriceController@enable']);
    $router->post('{id}/disable', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomOfferDayPriceController@disable']);
});
// Day Product Offer 
$router->group(['prefix' => 'day-product-offers'], function () use ($router) {
    $router->get('', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomOfferDayProductController@index']);
    $router->post('', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomOfferDayProductController@create']);

    $router->get('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomOfferDayProductController@show']);
    $router->post('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomOfferDayProductController@update']);
    $router->delete('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomOfferDayProductController@delete']);

    $router->post('{id}/enable', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomOfferDayProductController@enable']);
    $router->post('{id}/disable', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomOfferDayProductController@disable']);
});
// Multiple Price Offer
$router->group(['prefix' => 'multiple-price-offers'], function () use ($router) {
    $router->get('', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomOfferMultiplePriceController@index']);
    $router->post('', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomOfferMultiplePriceController@create']);

    $router->get('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomOfferMultiplePriceController@show']);
    $router->post('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomOfferMultiplePriceController@update']);
    $router->delete('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomOfferMultiplePriceController@delete']);

    $router->post('{id}/enable', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomOfferMultiplePriceController@enable']);
    $router->post('{id}/disable', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomOfferMultiplePriceController@disable']);
});
// Restaurant Voucher
$router->group(['prefix' => 'restaurant-vouchers'], function () use ($router) {
    $router->get('', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomRestaurantVoucherController@index']);
    $router->post('', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomRestaurantVoucherController@create']);

    $router->get('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomRestaurantVoucherController@show']);
    $router->post('bulk', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomRestaurantVoucherController@bulk_restaurant_voucher']);
    $router->post('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomRestaurantVoucherController@update']);
    $router->delete('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomRestaurantVoucherController@delete']);

    $router->post('{id}/enable', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomRestaurantVoucherController@enable']);
    $router->post('{id}/disable', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomRestaurantVoucherController@disable']);
});
// User Voucher
$router->group(['prefix' => 'user-vouchers'], function () use ($router) {
    $router->get('', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomUserVoucherController@index']);
    $router->post('', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomUserVoucherController@create']);

    $router->get('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomUserVoucherController@show']);
    $router->post('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomUserVoucherController@update']);
    $router->delete('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomUserVoucherController@delete']);

    $router->post('{id}/enable', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomUserVoucherController@enable']);
    $router->post('{id}/disable', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomUserVoucherController@disable']);
});
// Vouchers
$router->group(['prefix' => 'vouchers'], function () use ($router) {
    $router->get('', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomVoucherController@index']);
    $router->post('', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomVoucherController@create']);

    $router->get('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomVoucherController@show']);
    $router->post('find/{code}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomVoucherController@find']);
    $router->post('bulk', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomVoucherController@bulk_restaurant_voucher']);
    $router->post('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomVoucherController@update']);
    $router->delete('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomVoucherController@delete']);

    $router->post('{id}/enable', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomVoucherController@enable']);
    $router->post('{id}/disable', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomVoucherController@disable']);
});
// Order Change Enadpoint
$router->group(['prefix' => 'order'], function () use ($router) {

    $router->get('', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomOrderController@index']);
    $router->get('re-order/{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomOrderController@reOrder']);
    $router->get('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomOrderController@show']);

    $router->post('', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomOrderController@create']);
    $router->post('offer-check', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomOrderController@offer_check']);
});
// Order Change Enadpoint
$router->group(['prefix' => 'dinein-order'], function () use ($router) {

    $router->get('', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomDineinOrderController@index']);
    $router->get('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomDineinOrderController@show']);

    $router->post('', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomDineinOrderController@create']);
});
// Restaurant Booking Change Enadpoint
$router->group(['prefix' => 'booking'], function () use ($router) {
    $router->get('', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomBookingController@index']);
    $router->post('', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomBookingController@create']);

    $router->get('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomBookingController@show']);
    $router->post('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomBookingController@update']);
    $router->post('{id}/cancel', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomBookingController@cancel_booking']);
    $router->delete('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomBookingController@delete']);
});
// Rewards
$router->group(['prefix' => 'rewards'], function () use ($router) {
    $router->get('', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomRewardsController@index']);
    $router->get('points', ['uses' => 'TiffintomRewardsController@points']);
    $router->get('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomRewardsController@show']);

    $router->post('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomRewardsController@update']);
    $router->post('{id}/reward', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomRewardsController@update_reward']);
});

// Rewards 
$router->group(['prefix' => 'reward'], function () use ($router) {
    $router->get('', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomCustomerRewardController@index']);
    $router->post('', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomCustomerRewardController@create']);

    $router->get('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomCustomerRewardController@show']);
    $router->post('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomCustomerRewardController@update']);
    $router->delete('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomCustomerRewardController@delete']);
});
// Wallet History
$router->group(['prefix' => 'wallet-history'], function () use ($router) {
    $router->get('', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomWalletHistoryController@index']);
    $router->post('', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomWalletHistoryController@create']);

    $router->get('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomWalletHistoryController@show']);
    $router->post('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomWalletHistoryController@update']);
    $router->delete('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomWalletHistoryController@delete']);
});
// Review Change Enadpoint
$router->group(['prefix' => 'review'], function () use ($router) {
    $router->get('', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user,guest', 'uses' => 'TiffintomReviewController@index']);
    $router->post('', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomReviewController@create']);

    $router->get('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user,guest', 'uses' => 'TiffintomReviewController@show']);
    $router->post('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomReviewController@update']);
    $router->delete('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomReviewController@delete']);
});
// Referral Change Enadpoint
$router->group(['prefix' => 'referral'], function () use ($router) {
    $router->get('', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user,guest', 'uses' => 'TiffintomReferralController@index']);
    $router->get('referral-pending', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomReferralController@refferal_pending']);
    $router->post('', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomReferralController@create']);

    $router->get('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomReferralController@show']);
    $router->post('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomReferralController@update']);
    $router->delete('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomReferralController@delete']);
});
// Site Setting Change Enadpoint
$router->group(['prefix' => 'site-setting'], function () use ($router) {
    $router->get('', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user,guest', 'uses' => 'TiffintomSiteSettingController@index']);
    $router->get('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user,guest', 'uses' => 'TiffintomSiteSettingController@show']);
});
// App-Feedback
$router->group(['prefix' => 'app-feedback'], function () use ($router) {
    $router->get('', ['middleware' => 'role:admin,epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomAppFeedbackController@index']);
    $router->get('history', ['middleware' => 'role:admin,epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomAppFeedbackController@history']);
    $router->post('', ['middleware' => 'role:admin,epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomAppFeedbackController@create']);

    $router->get('{id}', ['middleware' => 'role:admin,epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomAppFeedbackController@show']);
    $router->post('{id}', ['middleware' => 'role:admin,epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomAppFeedbackController@update']);
    $router->delete('{id}', ['middleware' => 'role:admin,epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomAppFeedbackController@delete']);
});
// Account Help 
$router->group(['prefix' => 'account-help'], function () use ($router) {
    $router->get('', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user,guest', 'uses' => 'TiffintomAccountHelpController@index']);
    $router->get('history', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user,guest', 'uses' => 'TiffintomAccountHelpController@history']);
    $router->post('', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomAccountHelpController@create']);

    $router->get('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomAccountHelpController@show']);
    $router->post('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomAccountHelpController@update']);
    $router->delete('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomAccountHelpController@delete']);

    $router->post('{id}/enable', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomAccountHelpController@enable']);
    $router->post('{id}/disable', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomAccountHelpController@disable']);
});
// Account Answer 
$router->group(['prefix' => 'account-answers'], function () use ($router) {
    $router->get('', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user,guest', 'uses' => 'TiffintomAccountAnswerController@index']);
    $router->get('history', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user,guest', 'uses' => 'TiffintomAccountAnswerController@history']);
    $router->post('', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomAccountAnswerController@create']);

    $router->get('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomAccountAnswerController@show']);
    $router->post('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomAccountAnswerController@update']);
    $router->delete('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomAccountAnswerController@delete']);

    $router->post('{id}/enable', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomAccountAnswerController@enable']);
    $router->post('{id}/disable', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomAccountAnswerController@disable']);
});
// Order Help
$router->group(['prefix' => 'order-help'], function () use ($router) {
    $router->get('', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomOrderHelpController@index']);
    $router->post('', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomOrderHelpController@create']);

    $router->get('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomOrderHelpController@show']);
    $router->post('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomOrderHelpController@update']);
    $router->delete('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomOrderHelpController@delete']);
    $router->delete('{id}/delete-user', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomOrderHelpController@delete_user']);
});
// Chat
$router->group(['prefix' => 'chat'], function () use ($router) {
    $router->get('', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomChatController@index']);
    $router->post('', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomChatController@create']);

    $router->get('chat-all-count', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomChatController@chat_all_count']);
    $router->get('chat-order-question', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomChatController@order_question_chat']);
    $router->get('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomChatController@show']);
    $router->post('chat-general-question', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomChatController@order_general_chat']);
    $router->post('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomChatController@update']);
    $router->delete('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomChatController@delete']);
    $router->delete('{id}/delete-user', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomChatController@delete_user']);
});
// complaint
$router->group(['prefix' => 'complaints'], function () use ($router) {
    $router->get('', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomComplaintController@index']);
    $router->post('', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomComplaintController@create']);

    $router->get('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomComplaintController@show']);
    $router->post('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomComplaintController@update']);
    $router->delete('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomComplaintController@delete']);

    $router->delete('{id}/delete-user', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomComplaintController@delete_user']);


    $router->post('{id}/open', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomComplaintController@open']);
    $router->post('{id}/close', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomComplaintController@close']);
});
// Checkout List 
$router->group(['prefix' => 'checkout-list'], function () use ($router) {
    $router->get('', ['uses' => 'TiffintomCheckoutListController@index']);
    $router->get('history', ['uses' => 'TiffintomCheckoutListController@history']);
    $router->post('', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomCheckoutListController@create']);

    $router->get('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomCheckoutListController@show']);
    $router->post('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomCheckoutListController@update']);
    $router->delete('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomCheckoutListController@delete']);

    $router->post('{id}/enable', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomCheckoutListController@enable']);
    $router->post('{id}/disable', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomCheckoutListController@disable']);
});

// Amrish use the endpoint multiple name change 

// Card // Stripe Customers
$router->group(['prefix' => 'cards'], function () use ($router) {
    $router->get('', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user,tiffintom_user,epos_user', 'uses' => 'TiffintomStripeCustomerController@index']);
    $router->post('', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomStripeCustomerController@create']);

    $router->post('payment-intent', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomStripeCustomerController@payment_intent']);
    $router->post('payment-intent-without-customer', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user,guest', 'uses' => 'TiffintomStripeCustomerController@payment_intent_wihout_customer']);

    $router->get('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user,tiffintom_user,epos_user', 'uses' => 'TiffintomStripeCustomerController@show']);
    $router->post('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomStripeCustomerController@update']);
    $router->delete('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user,tiffintom_user,epos_user', 'uses' => 'TiffintomStripeCustomerController@delete']);
});
// Order
$router->group(['prefix' => 'orders'], function () use ($router) {

    $router->get('home', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomOrderController@home']);
    $router->get('all-orders', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomOrderController@all_orders']);
    $router->get('history', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomOrderController@history']);

    $router->get('', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomOrderController@index']);
    $router->get('re-order/{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomOrderController@reOrder']);
    $router->get('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomOrderController@show']);
    $router->get('{id}/time-slots', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomOrderController@order_timeslot']);

    $router->post('', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomOrderController@create']);
    $router->post('bulk-delete', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomOrderController@bulk_delete']);
    $router->post('{id}/change-status', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomOrderController@changeStatus']);
    $router->post('{id}/time-extend', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomOrderController@time_extend']);
    $router->post('{id}/rtc', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomOrderController@order_rtc']);
    $router->post('offer-check', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomOrderController@offer_check']);
    $router->delete('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomOrderController@delete']);
});
// Order
$router->group(['prefix' => 'dinein-orders'], function () use ($router) {
    $router->get('', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomDineinOrderController@index']);
    $router->get('order-history', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomDineinOrderController@order_history']);
    $router->get('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomDineinOrderController@show']);

    $router->post('', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomDineinOrderController@create']);
    $router->post('{id}/change-status', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomDineinOrderController@changeStatus']);
});
// Restaurant Booking
$router->group(['prefix' => 'bookings'], function () use ($router) {
    $router->get('', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomBookingController@index']);
    $router->get('home', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomBookingController@home']);
    $router->post('', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomBookingController@create']);

    $router->get('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomBookingController@show']);
    $router->post('bulk-delete', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomBookingController@bulk_delete']);
    $router->post('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomBookingController@update']);
    $router->post('{id}/change-status', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomBookingController@change_status']);
    $router->delete('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomBookingController@delete']);
});
// Review
$router->group(['prefix' => 'reviews'], function () use ($router) {
    $router->get('', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user,guest', 'uses' => 'TiffintomReviewController@index']);
    $router->get('home', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user,guest', 'uses' => 'TiffintomReviewController@home']);
    $router->get('history', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user,guest', 'uses' => 'TiffintomReviewController@history']);
    $router->get('count', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user,guest', 'uses' => 'TiffintomReviewController@count']);
    $router->post('', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomReviewController@create']);

    $router->get('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user,guest', 'uses' => 'TiffintomReviewController@show']);
    $router->post('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomReviewController@update']);
    $router->delete('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomReviewController@delete']);

    $router->post('{id}/enable', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomReviewController@enable']);
    $router->post('{id}/disable', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomReviewController@disable']);
});
// Referral
$router->group(['prefix' => 'referrals'], function () use ($router) {
    $router->get('', ['uses' => 'TiffintomReferralController@index']);
    $router->get('referral-pending', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomReferralController@refferal_pending']);
    $router->get('referral-history', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomReferralController@refferal_pending_index']);
    $router->post('', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomReferralController@create']);

    $router->get('{id}', ['uses' => 'TiffintomReferralController@show']);
    $router->post('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomReferralController@update']);
    $router->post('{id}/referral', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomReferralController@update_referral']);
    $router->delete('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomReferralController@delete']);
});
// Site Setting 
$router->group(['prefix' => 'site-settings'], function () use ($router) {
    $router->get('', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user,guest', 'uses' => 'TiffintomSiteSettingController@index']);
    $router->get('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user,guest', 'uses' => 'TiffintomSiteSettingController@show']);
    $router->get('{id}/all', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user,guest', 'uses' => 'TiffintomSiteSettingController@show_all']);

    $router->post('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomSiteSettingController@update']);
});
// Epos Shortln Url Message
$router->group(['prefix' => 'payment-message'], function () use ($router) {
    $router->get('', ['middleware' => 'role:admin,epos_admin,tiffintom_user,epos_user,user,guest', 'uses' => 'TiffintomShortlnUrlController@index']);
    $router->post('', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user,user,guest', 'uses' => 'TiffintomShortlnUrlController@create']);
    $router->post('payment-intent', ['middleware' => 'role:epos_admin,admin,user,guest', 'uses' => 'TiffintomShortlnUrlController@payment_intent']);
    $router->get('find/{code}', ['uses' => 'TiffintomShortlnUrlController@find']);
    $router->post('{id}/resend', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user,user,guest', 'uses' => 'TiffintomShortlnUrlController@resend']);
    $router->post('{id}/change-status', ['uses' => 'TiffintomShortlnUrlController@change_status']);
    $router->post('{id}/cancel-payment', ['uses' => 'TiffintomShortlnUrlController@change_cancel']);
});
// Partner Message
$router->group(['prefix' => 'partner-messages'], function () use ($router) {
    $router->get('', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomPartnerMessageController@index']);
    $router->post('', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomPartnerMessageController@create']);

    $router->get('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomPartnerMessageController@show']);
    $router->post('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomPartnerMessageController@update']);
    $router->delete('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomPartnerMessageController@delete']);

    $router->post('{id}/enable', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomPartnerMessageController@enable']);
    $router->post('{id}/disable', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomPartnerMessageController@disable']);
});
// Partner Dashboard
$router->group(['prefix' => 'dashboard'], function () use ($router) {
    $router->get('admin-dashboard', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomDashboardController@admin_dashboard']);
    $router->get('overview', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomDashboardController@dashboard_overview']);
    $router->get('payment-overview', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user,user,guest', 'uses' => 'TiffintomDashboardController@payment_overview']);
    $router->get('pending-count', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user,user,guest', 'uses' => 'TiffintomDashboardController@pending_count']);
});
// Payment Transaction
$router->group(['prefix' => 'payment-transactions'], function () use ($router) {
    $router->get('', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomPaymentTransactionController@index']);
});
// Favourite Restaurant
$router->group(['prefix' => 'favourite-restaurants'], function () use ($router) {
    $router->get('', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomFavouriteRestaurantController@index']);
    $router->post('', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomFavouriteRestaurantController@create_update']);
});
// Cuisine
$router->group(['prefix' => 'cuisines'], function () use ($router) {
    $router->get('', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user,guest', 'uses' => 'TiffintomCuisineController@index']);
    $router->post('', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomCuisineController@create']);

    $router->get('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomCuisineController@show']);
    $router->post('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomCuisineController@update']);
    $router->delete('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomCuisineController@delete']);

    $router->post('{id}/enable', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomCuisineController@enable']);
    $router->post('{id}/disable', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomCuisineController@disable']);
});
// Dietary
$router->group(['prefix' => 'dietaries'], function () use ($router) {
    $router->get('', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user,guest', 'uses' => 'TiffintomDietaryController@index']);
    $router->post('', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomDietaryController@create']);

    $router->get('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomDietaryController@show']);
    $router->post('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomDietaryController@update']);
    $router->delete('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomDietaryController@delete']);

    $router->post('{id}/enable', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomDietaryController@enable']);
    $router->post('{id}/disable', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomDietaryController@disable']);
});
// Cuisine
$router->group(['prefix' => 'become-partners'], function () use ($router) {
    $router->get('', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user,guest', 'uses' => 'TiffintomRestaurantRegistrationController@index']);
    $router->post('', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomRestaurantRegistrationController@create']);

    $router->get('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomRestaurantRegistrationController@show']);
    $router->post('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomRestaurantRegistrationController@update']);
    $router->delete('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomRestaurantRegistrationController@delete']);
});
// Print Blocks
$router->group(['prefix' => 'print-blocks'], function () use ($router) {
    $router->get('', ['middleware' => 'role:epos_admin,epos_user,tiffintom_user', 'uses' => 'TiffintomPrintBlockController@index']);
    $router->post('', ['middleware' => 'role:epos_admin,epos_user,tiffintom_user', 'uses' => 'TiffintomPrintBlockController@create']);

    $router->post('print-block-bulk', ['middleware' => 'role:epos_admin,epos_user,tiffintom_user', 'uses' => 'TiffintomPrintBlockController@print_block_bulk']);

    $router->get('{id}', ['middleware' => 'role:epos_admin,epos_user,tiffintom_user', 'uses' => 'TiffintomPrintBlockController@show']);
    $router->post('{id}', ['middleware' => 'role:epos_admin,epos_user,tiffintom_user', 'uses' => 'TiffintomPrintBlockController@update']);
    $router->delete('{id}', ['middleware' => 'role:epos_admin,epos_user,tiffintom_user', 'uses' => 'TiffintomPrintBlockController@delete']);
});

$router->group(['prefix' => 'print-block-assigns'], function () use ($router) {
    $router->get('', ['middleware' => 'role:epos_admin,epos_user,tiffintom_user', 'uses' => 'TiffintomPrintBlockAssignController@index']);
    $router->post('', ['middleware' => 'role:epos_admin,epos_user,tiffintom_user', 'uses' => 'TiffintomPrintBlockAssignController@create']);
    $router->post('multiple', ['middleware' => 'role:epos_admin,epos_user,tiffintom_user', 'uses' => 'TiffintomPrintBlockAssignController@create_multiple']);

    $router->get('{id}', ['middleware' => 'role:epos_admin,epos_user,tiffintom_user', 'uses' => 'TiffintomPrintBlockAssignController@show']);
    $router->post('{id}', ['middleware' => 'role:epos_admin,epos_user,tiffintom_user', 'uses' => 'TiffintomPrintBlockAssignController@update']);
    $router->delete('{id}', ['middleware' => 'role:epos_admin,epos_user,tiffintom_user', 'uses' => 'TiffintomPrintBlockAssignController@delete']);
});

// Contact
$router->group(['prefix' => 'contacts'], function () use ($router) {
    $router->get('', ['middleware' => 'role:admin,epos_admin,epos_user,tiffintom_user', 'uses' => 'TiffintomContactController@index']);
    $router->post('', ['middleware' => 'role:admin,epos_admin,epos_user,tiffintom_user,guest', 'uses' => 'TiffintomContactController@create']);

    $router->get('{id}', ['middleware' => 'role:admin,epos_admin,epos_user,tiffintom_user', 'uses' => 'TiffintomContactController@show']);
    $router->post('{id}', ['middleware' => 'role:admin,epos_admin,epos_user,tiffintom_user', 'uses' => 'TiffintomContactController@update']);
    $router->delete('{id}', ['middleware' => 'role:admin,epos_admin,epos_user,tiffintom_user', 'uses' => 'TiffintomContactController@delete']);


    $router->post('{id}/enable', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomContactController@enable']);
    $router->post('{id}/disable', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomContactController@disable']);
});
// Messages Package
$router->group(['prefix' => 'sms-messages'], function () use ($router) {
    $router->get('', ['middleware' => 'role:admin,epos_admin,epos_user,tiffintom_user', 'uses' => 'TiffintomMessageController@index']);
    $router->post('', ['middleware' => 'role:admin,epos_admin,epos_user,tiffintom_user', 'uses' => 'TiffintomMessageController@create']);

    $router->get('{id}', ['middleware' => 'role:admin,epos_admin,epos_user,tiffintom_user', 'uses' => 'TiffintomMessageController@show']);
    $router->post('{id}', ['middleware' => 'role:admin,epos_admin,epos_user,tiffintom_user', 'uses' => 'TiffintomMessageController@update']);
    $router->delete('{id}', ['middleware' => 'role:admin,epos_admin,epos_user,tiffintom_user', 'uses' => 'TiffintomMessageController@delete']);

    $router->post('{id}/enable', ['middleware' => 'role:admin,epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomMessageController@enable']);
    $router->post('{id}/disable', ['middleware' => 'role:admin,epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomMessageController@disable']);
});

// SMS Events
$router->group(['prefix' => 'sms-events'], function () use ($router) {
    $router->get('', ['middleware' => 'role:admin,epos_admin,epos_user,tiffintom_user', 'uses' => 'TiffintomSMSEventController@index']);
    $router->post('', ['middleware' => 'role:admin,epos_admin,epos_user,tiffintom_user', 'uses' => 'TiffintomSMSEventController@create']);

    $router->post('load-events', ['middleware' => 'role:admin,epos_admin,epos_user,tiffintom_user', 'uses' => 'TiffintomSMSEventController@load_events']);
    $router->get('{id}', ['middleware' => 'role:admin,epos_admin,epos_user,tiffintom_user', 'uses' => 'TiffintomSMSEventController@show']);
    $router->post('{id}', ['middleware' => 'role:admin,epos_admin,epos_user,tiffintom_user', 'uses' => 'TiffintomSMSEventController@update']);
    $router->delete('{id}', ['middleware' => 'role:admin,epos_admin,epos_user,tiffintom_user', 'uses' => 'TiffintomSMSEventController@delete']);
});

// Surcharges
$router->group(['prefix' => 'surcharges'], function () use ($router) {
    $router->get('', ['middleware' => 'role:admin,epos_admin,epos_user,tiffintom_user', 'uses' => 'TiffintomSurchargeController@index']);
    $router->post('', ['middleware' => 'role:admin,epos_admin,epos_user,tiffintom_user', 'uses' => 'TiffintomSurchargeController@create']);

    $router->get('{id}', ['middleware' => 'role:admin,epos_admin,epos_user,tiffintom_user', 'uses' => 'TiffintomSurchargeController@show']);
    $router->post('{id}', ['middleware' => 'role:admin,epos_admin,epos_user,tiffintom_user', 'uses' => 'TiffintomSurchargeController@update']);
    $router->delete('{id}', ['middleware' => 'role:admin,epos_admin,epos_user,tiffintom_user', 'uses' => 'TiffintomSurchargeController@delete']);
});
// Offer Text
$router->group(['prefix' => 'offer-texts'], function () use ($router) {
    $router->get('', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomOfferTextController@index']);
    $router->post('', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomOfferTextController@create']);

    $router->get('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomOfferTextController@show']);
    $router->post('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomOfferTextController@update']);
    $router->delete('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomOfferTextController@delete']);

    $router->post('{id}/enable', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomOfferTextController@enable']);
    $router->post('{id}/disable', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomOfferTextController@disable']);
});
// Countries
$router->group(['prefix' => 'countries'], function () use ($router) {
    $router->get('', ['uses' => 'TiffintomCountryController@index']);
    $router->post('', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomCountryController@create']);

    $router->get('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomCountryController@show']);
    $router->post('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomCountryController@update']);
    $router->delete('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomCountryController@delete']);

    $router->post('{id}/enable', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomCountryController@enable']);
    $router->post('{id}/disable', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomCountryController@disable']);
});
// States
$router->group(['prefix' => 'states'], function () use ($router) {
    $router->get('', ['uses' => 'TiffintomStateController@index']);
    $router->post('', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomStateController@create']);

    $router->get('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomStateController@show']);
    $router->post('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomStateController@update']);
    $router->delete('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomStateController@delete']);

    $router->post('{id}/enable', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomStateController@enable']);
    $router->post('{id}/disable', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomStateController@disable']);
});
// Cities
$router->group(['prefix' => 'cities'], function () use ($router) {
    $router->get('', ['uses' => 'TiffintomCityController@index']);
    $router->post('', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomCityController@create']);

    $router->get('history', ['uses' => 'TiffintomCityController@history']);
    $router->get('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomCityController@show']);
    $router->post('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomCityController@update']);
    $router->delete('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomCityController@delete']);

    $router->post('{id}/enable', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomCityController@enable']);
    $router->post('{id}/disable', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomCityController@disable']);
});
// Locations
$router->group(['prefix' => 'locations'], function () use ($router) {
    $router->get('', ['uses' => 'TiffintomLocationController@index']);
    $router->post('', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomLocationController@create']);

    $router->get('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomLocationController@show']);
    $router->post('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomLocationController@update']);
    $router->delete('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomLocationController@delete']);

    $router->post('{id}/enable', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomLocationController@enable']);
    $router->post('{id}/disable', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomLocationController@disable']);
});
// Domains
$router->group(['prefix' => 'domains'], function () use ($router) {
    $router->get('', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomDomainController@index']);
    $router->post('', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomDomainController@create']);

    $router->get('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomDomainController@show']);
    $router->post('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomDomainController@update']);
    $router->delete('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomDomainController@delete']);

    $router->post('{id}/enable', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomDomainController@enable']);
    $router->post('{id}/disable', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomDomainController@disable']);
});
// Domains
$router->group(['prefix' => 'pre-messages'], function () use ($router) {
    $router->get('', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomPreMessagesController@index']);
    $router->post('', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomPreMessagesController@create']);

    $router->get('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomPreMessagesController@show']);
    $router->post('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomPreMessagesController@update']);
    $router->delete('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomPreMessagesController@delete']);

    $router->post('{id}/enable', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomPreMessagesController@enable']);
    $router->post('{id}/disable', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomPreMessagesController@disable']);
});

// Payment Methods
$router->group(['prefix' => 'payment-methods'], function () use ($router) {
    $router->get('', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomPaymentMethodController@index']);
    $router->post('', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomPaymentMethodController@create']);

    $router->get('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomPaymentMethodController@show']);
    $router->post('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomPaymentMethodController@update']);
    $router->delete('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomPaymentMethodController@delete']);

    $router->post('{id}/enable', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomPaymentMethodController@enable']);
    $router->post('{id}/disable', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomPaymentMethodController@disable']);
});

// Tiffintom Add on about page Cards
$router->group(['prefix' => 'site-cards'], function () use ($router) {
    $router->get('', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomCardController@index']);
    $router->post('', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomCardController@create']);

    $router->get('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomCardController@show']);
    $router->post('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomCardController@update']);
    $router->delete('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomCardController@delete']);
});

// Download Document / Import Document
$router->group(['prefix' => 'download-documents'], function () use ($router) {
    $router->get('', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomDownloadDocumentController@index']);
    $router->post('', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomDownloadDocumentController@create']);

    $router->get('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomDownloadDocumentController@show']);
    $router->post('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomDownloadDocumentController@update']);
    $router->delete('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomDownloadDocumentController@delete']);
});

// Partner Media
$router->group(['prefix' => 'partner-medias'], function () use ($router) {
    $router->get('', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomPartnerMediaController@index']);
    $router->post('', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomPartnerMediaController@create']);

    $router->get('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomPartnerMediaController@show']);
    $router->post('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomPartnerMediaController@update']);
    $router->delete('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomPartnerMediaController@delete']);

    $router->post('{id}/enable', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomPartnerMediaController@enable']);
    $router->post('{id}/disable', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomPartnerMediaController@disable']);
});
// SMS Port
$router->group(['prefix' => 'sms-ports'], function () use ($router) {
    $router->get('', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomSMSPortController@index']);
    $router->post('', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomSMSPortController@create']);

    $router->get('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomSMSPortController@show']);
    $router->post('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomSMSPortController@update']);
    $router->delete('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomSMSPortController@delete']);

    $router->post('{id}/enable', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomSMSPortController@enable']);
    $router->post('{id}/disable', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomSMSPortController@disable']);
});
// Keyword
$router->group(['prefix' => 'keywords'], function () use ($router) {
    $router->get('', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomKeywordController@index']);
    $router->post('', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomKeywordController@create']);

    $router->get('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomKeywordController@show']);
    $router->post('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomKeywordController@update']);
    $router->delete('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomKeywordController@delete']);

    $router->post('{id}/enable', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomKeywordController@enable']);
    $router->post('{id}/disable', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomKeywordController@disable']);
});
// Notification
$router->group(['prefix' => 'notifications'], function () use ($router) {
    $router->get('', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomNotificationsController@index']);
    $router->post('', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomNotificationsController@create']);

    $router->get('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomNotificationsController@show']);
    $router->post('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomNotificationsController@update']);
    $router->delete('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomNotificationsController@delete']);

    $router->post('{id}/enable', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomNotificationsController@enable']);
    $router->post('{id}/disable', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomNotificationsController@disable']);
});
// Payment Plan
$router->group(['prefix' => 'payment-plans'], function () use ($router) {
    $router->get('', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomPaymentPlanController@index']);
    $router->post('', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomPaymentPlanController@create']);

    $router->get('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomPaymentPlanController@show']);
    $router->post('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomPaymentPlanController@update']);
    $router->delete('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomPaymentPlanController@delete']);

    $router->post('{id}/enable', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomPaymentPlanController@enable']);
    $router->post('{id}/disable', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomPaymentPlanController@disable']);
});
//urls
$router->group(['prefix' => 'urls'], function () use ($router) {
    $router->get('', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomUrlController@index']);
    $router->post('', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomUrlController@create']);

    $router->get('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomUrlController@show']);
    $router->post('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomUrlController@update']);
    $router->delete('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomUrlController@delete']);
});
//News Letters
$router->group(['prefix' => 'news-letters'], function () use ($router) {
    $router->get('', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomNewsLetterController@index']);
    $router->post('send-mail-all', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomNewsLetterController@send_all']);
    $router->post('send-mail-customer', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomNewsLetterController@send_customer']);
});
// Static Pages
$router->group(['prefix' => 'static-pages'], function () use ($router) {
    $router->get('', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomStaticPageController@index']);
    $router->post('', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomStaticPageController@create']);

    $router->get('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomStaticPageController@show']);
    $router->post('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomStaticPageController@update']);
    $router->delete('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomStaticPageController@delete']);

    $router->post('{id}/enable', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomStaticPageController@enable']);
    $router->post('{id}/disable', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomStaticPageController@disable']);
});
// Notes 
$router->group(['prefix' => 'notes'], function () use ($router) {
    $router->get('', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomNoteController@index']);
    $router->post('', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomNoteController@create']);

    $router->get('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomNoteController@show']);
    $router->post('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomNoteController@update']);
    $router->delete('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomNoteController@delete']);

    $router->post('{id}/enable', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomNoteController@enable']);
    $router->post('{id}/disable', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomNoteController@disable']);
});
// Promotion Banners 
$router->group(['prefix' => 'promotion-banners'], function () use ($router) {
    $router->get('', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomPromotionBannerController@index']);
    $router->post('', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomPromotionBannerController@create']);

    $router->get('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomPromotionBannerController@show']);
    $router->post('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomPromotionBannerController@update']);
    $router->delete('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomPromotionBannerController@delete']);
});
// Language Setting 
$router->group(['prefix' => 'language-settings'], function () use ($router) {
    $router->get('', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomLanguageSettingController@index']);
    $router->post('', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomLanguageSettingController@create']);

    $router->get('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomLanguageSettingController@show']);
    $router->post('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomLanguageSettingController@update']);
    $router->delete('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomLanguageSettingController@delete']);

    $router->post('{id}/enable', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomLanguageSettingController@enable']);
    $router->post('{id}/disable', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomLanguageSettingController@disable']);

    $router->post('{id}/enable-default', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomLanguageSettingController@enable_default']);
    $router->post('{id}/disable-default', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomLanguageSettingController@disable_default']);
});
// Time Zones 
$router->group(['prefix' => 'time-zones'], function () use ($router) {
    $router->get('', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomTimeZoneController@index']);
    $router->post('', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomTimeZoneController@create']);

    $router->get('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomTimeZoneController@show']);
    $router->post('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomTimeZoneController@update']);
    $router->delete('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomTimeZoneController@delete']);
});
// Promotions 
$router->group(['prefix' => 'promotions'], function () use ($router) {
    $router->get('', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomPromotionController@index']);
    $router->post('', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomPromotionController@create']);

    $router->get('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomPromotionController@show']);
    $router->post('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomPromotionController@update']);
    $router->delete('{id}', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomPromotionController@delete']);
});

// aamarpay payment method
$router->group(['prefix' => 'aamarpay'], function () use ($router) {
    $router->post('', ['middleware' => 'role:epos_admin,tiffintom_user,epos_user', 'uses' => 'TiffintomAamarPayController@payment']);
});