<?php

/*
|--------------------------------------------------------------------------
| Application Routes
|--------------------------------------------------------------------------
|
| Here is where you can register all of the routes for an application.
| It is a breeze. Simply tell Lumen the URIs it should respond to
| and give it the Closure to call when that URI is requested.
|
*/

use App\Http\Controllers\AamarPayController;

$router->get('/', function () use ($router) {
    return view('ubsidi-main');
});

$router->get('/card-reader-payment', function () use ($router) {
    return view('card-reader-payment');
});
$router->get('/success', function () use ($router) {
    return view('card-reader-success');
});
$router->get('/failed', function () use ($router) {
    return view('card-reader-failed');
});
$router->get('/direct-payment', function () use ($router) {
    return view('direct-payment');
});
$router->get('/direct-payment-success', function () use ($router) {
    return view('direct-payment-success');
});
$router->get('/direct-payment-failed', function () use ($router) {
    return view('direct-payment-failed');
});
// $router->get('/epos-payment', function () use ($router) {
//     return view('epos-payment');
// });
$router->get('/epos-payment-success', function () use ($router) {
    return view('epos-payment-success');
});
$router->get('/epos-payment-failed', function () use ($router) {
    return view('epos-payment-failed');
});

$router->get('/epos-payment', function () use ($router) {
    return view('payment');
});

//Invoice
$router->get('/invoice-payment-success', function () use ($router) {
    return view('invoice-payment-success');
});
$router->get('/invoice-payment-failed', function () use ($router) {
    return view('invoice-payment-failed');
});

$router->get('/invoice-payment', function () use ($router) {
    return view('invoice-payment');
});

$router->get('/sitemap', ['uses' => 'SitemapController@index']);

$router->get('/invoice-send-recepit/{txn_id}', ['uses' => 'StripeTransactionController@transactionFetch']);

$router->group(['prefix' => 'logs'], function () use ($router) {
    $router->get('', ['middleware' => 'role:admin,user', 'uses' => 'LogController@index']);
    $router->delete('', ['middleware' => 'role:admin,user', 'uses' => 'LogController@delete']);
});

$router->get('stripe-custom-payment', ['uses' => 'StripeTransactionController@stripeCustomPayment']);
$router->post('create-payment-intent', ['uses' => 'StripeTransactionController@createPaymentIntent']);

$router->get('api/ubsidi/stripe-payment', ['uses' => 'StripeTransactionController@stripePaymentConfirmation']);
$router->post('api/ubsidi/create-payment-schema', ['uses' => 'UbsidiPaymentGatewayController@createPaymentSchema']);

// aamarpay payment method
$router->group(['prefix' => 'aamarpay'], function () use ($router) {
    $router->post('success', ['uses' => 'AamarPayController@success']);
    $router->post('fail', ['uses' => 'AamarPayController@fail']);
    $router->get('cancel', ['uses' => 'AamarPayController@cancel']);
    $router->get('pay', ['uses' => 'AamarPayController@pay']);
    $router->post('checkout', ['uses' => 'AamarPayController@checkout']);
});