<!doctype html>
<html lang="en">

<head>
    <meta charset="utf-8">
    <title>UBSIDI | Leading Merchant Platform for 360-Degree Payment Solutions</title>
    <link rel="icon" type="image/png" href="./images/favicon_ubsidi.png">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <meta name="description" content="UBSIDI is a leading merchant platform empowering any businesses to accept multiple modes of payments, get in-depth customer insights, and grow their business using working capital solutions." />

    <link href="https://maxcdn.bootstrapcdn.com/bootstrap/4.0.0/css/bootstrap.min.css" rel="stylesheet" id="bootstrap-css">
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.0.0/js/bootstrap.min.js"></script>
    <script src="https://code.jquery.com/jquery-1.11.1.min.js"></script>

    <style>
        body {
            font-family: "Lato", sans-serif;
        }

        .main-head {
            height: 150px;
            background: #FFF;

        }

        .sidenav {
            height: 100%;
            background-color: #09c4a9;
            overflow-x: hidden;
            padding-top: 20px;
        }

        .main {
            padding: 0px 10px;
        }

        @media  screen and (max-height: 450px) {
            .sidenav {
                padding-top: 15px;
            }
        }

        @media  screen and (min-width: 768px) {
            .main {
                margin-left: 40%;
            }

            .sidenav {
                width: 45%;
                position: fixed;
                z-index: 1;
                top: 0;
                left: 0;
            }
        }

        .login-main-text {
            margin-top: 5%;
            padding: 20px;
            color: #fff;
        }

        .login-main-text-opposite {
            margin-top: 5%;
            padding: 30px;
            color: #000;
        }

        .login-main-text-opposite h2 {
            font-weight: 500;
        }

        .login-main-text h1 {
            font-weight: 700;
        }

        span {
            color: #000 !important;
        }

        .btn-black {
            background-color: #09c4a9 !important;
            color: #fff;
        }
    </style>
</head>

<body>
    <div class="sidenav">
        <div class="login-main-text text-center" style="min-height: calc(100vh - 78vh);">
            <!-- <h1>Ubsidi</h1> -->
            <img src="./images/ubsidi-logo-white.png" alt="ubsidi main">
        </div>
        <div class="col-md-12 col-sm-12">
            <img src="./images/auth_bg.png" alt="ubsidi main">
        </div>
    </div>
    <div class="main">
        <div class="col-md-12 col-sm-12">
            <div style="min-height: calc(100vh - 104px);">
                <div class="login-main-text-opposite">
                    <h2 class="text-center">Start selling with Ubsidi</h2>
                    <p class="py-2 ml-md-5 px-md-5" style="font-size: 17px; color: #000;font-family:verdana;">Taking card payments is
                        simple and easy with Ubsidi. Better yet, you could opt for an integrated point of sale system with tablet functionality,
                        great for taking orders on the move. All connected seamlessly to help you grow your business. A
                        simple solution for you, all in one place.</p>
                </div>
                <div class="text-center p-1">
                    <!-- <h3 class="p-3"> Go Merchant Panel</h3> -->
                    <a href="https://www.ubsidi.com/epos/" class="btn btn-black text-center">Get started </a>
                    <a href="https://www.ubsidi.com/epos/" class="btn btn-black text-center">Sign in </a>
                </div>
                <div class="text-center p-5">
                    <h3 class="p-3"> Get Our App</h3>
                    <a href="https://play.google.com/store/apps/details?id=com.ubsidi" class="text-center">
                        <img src="./images/playstore-icon-qr.png" alt="ubsidi playstore">
                    </a>
                    <a href="https://apps.apple.com/us/app/ubsidi/id1574017140" class="text-center">
                        <img src="./images/app_store_qr.png" alt="ubsidi appstore">
                    </a>
                </div>
            </div>

            <div class="text-center">
                <a href="#" class="text-center font-weight-bold mr-3">
                    <span>Terms</span>
                </a>
                <a href="#" class="text-center font-weight-bold">
                    <span>Contact Us</span>
                </a>
            </div>
        </div>
    </div>
</body>

</html><?php /**PATH C:\xampp\htdocs\ubsid-rms-admin-panel\resources\views/ubsidi-main.blade.php ENDPATH**/ ?>